function exercise_15_18(alg)

disp('Solving exercise 15.18 ...')
disp('Quantized downscaled DIT FFT, alg: empty or PQN')
close all

if nargin<1, alg=''; end, 
if ~isempty(alg)&~strcmp(alg,'PQN'), error('alg is not valid'), end

Q=qstruct('B',32,'fb',31); 
fprintf('Downscaled DIT FFT roundoff error, simulation')
if strcmp(alg,'PQN'), Q=qstructset(Q,'Operation','PQN'); fprintf(', with PQN'), end, fprintf('\n')
Qinput=qstruct('double');
Qcos=qstruct('double');
%Qmul=qstruct('double');
Qmul=Q;
N=256; q=lsb(Q);

var_th=N^2*q^2/12

x=(rand(1,N)-0.5)*2; xq=roundq(x,qstructset(Q,'Operation','quantize'));
Xq=roundfft(xq,Q,struct('algorithm','DIT','exponent','downscale',...
  'Qinput',Qinput,'Qcos',Qcos,'Qmul',Qmul));
X=fft(xq);
Xerr=Xq*N-X;
varXq=mean(abs(Xerr).^2,1)/2;
varXqav=mean(varXq)
