function exercise_15_24(alg)

disp('Solving exercise 15.24 ...')
disp('Quantized DIF FFT, alg: empty or PQN')
close all
if nargin<1, alg=''; end, 
if ~isempty(alg)&~strcmp(alg,'PQN'), error('alg is not valid'), end

Q=qstruct('B',32,'fb',31); 
fprintf('DIF FFT roundoff error, simulation')
if strcmp(alg,'PQN'), Q=qstructset(Q,'Operation','PQN'); fprintf(', with PQN'), end, fprintf('\n')
Qinput=qstruct('double');
Qcos=qstruct('double');
%Qmul=qstruct('double');
Qmul=Q;
N=256; q=lsb(Q);
%N=8;

C=50;    
global N_for_test_only
if ~isempty(N_for_test_only), C=2; end %make tests shorter
for ic=1:C
  x=1/32*(rand(1,N)-0.5)*2; xq=roundq(x,qstructset(Q,'Operation','quantize'));
  Xq=roundfft(xq,Q,struct('algorithm','DIF','Qinput',Qinput,'Qcos',Qcos,'Qmul',Qmul));
  X=fft(xq);
  %figure(1), plot([0:N-1],real(X),'b',[0:N-1],imag(X),'g')
  if ic==1
    varXth=q^2/12*N/0.8
    varXavth=q^2/12*N/2
    varXthstr='q^2/12*N/0.8, varXavth=q^2/12*N/2';
    %varXqav1=var(Xq-X,1)/2
    %varXqav1=mean(abs(Xq-X).^2)/2
  end
  Xerr(ic,:)=Xq-X;
  varXq=mean(abs(Xerr(1:ic,:)).^2,1)/2;
  varXqav=mean(varXq);
  fprintf('cyc = %.0f, var{X(N-1)}/2 = %.3g, varXav/2 = %.3g\n',ic,varXq(N),varXqav)
  %fprintf('.'), if ic==C, disp(' '), end
  if rem(ic,20)==0
    varXth, varXavth
    plot([1:N],varXq,N,varXth,'.g',[1,N],varXavth*[1,1],':r'), drawnow, shg
  end
end
plot([1:N],varXq,N,varXth,'.g',[1,N],varXavth*[1,1],':r'), drawnow, shg
%if strcmp(alg,'PQN'), save DIF_PQN, else save DIF_q, end
