function exercise_15_6(alg,abcd)

disp('Solving exercise 15.6 ...')
disp('Quantized DIT FFT, alg: empty or PQN')

close all
if nargin<2, abcd=''; end
if nargin<1, alg=''; end, %may be 'PQN'
if ~isempty(alg)&~strcmp(alg,'PQN'), error('alg is not valid'), end

Q=qstruct('B',32,'fb',31); 
fprintf('DIT FFT roundoff error, simulation')
if strcmp(alg,'PQN')
  Q=qstructset(Q,'Operation','PQN'); fprintf(', with PQN')
end 
fprintf('\n')
Qinput=qstruct('double');
Qcos=qstruct('double');
%Qmul=qstruct('double');
Qmul=Q;
N=256; q=lsb(Q);

if any(findstr('a',abcd))|isempty(abcd)
  figure(1)
  disp('No input quantization, no coefficients quantization')
  C=50;
  global N_for_test_only
  if ~isempty(N_for_test_only), C=2; end %make tests shorter
  for ic=1:C
    x=1/32*(rand(1,N)-0.5)*2; xq=roundq(x,qstructset(Q,'Operation','quantize'));
    Xq=roundfft(xq,Q,struct('algorithm','DIT','Qinput',Qinput,'Qcos',Qcos,'Qmul',Qmul));
    X=fft(xq);
    %figure(1), plot([0:N-1],real(X),'b',[0:N-1],imag(X),'g')
    if ic==1
      varXth=q^2/12*N/2
      varXavth=q^2/12*N/3
      varXthstr='q^2/12*N/2, varXavth=q^2/12*N/3';
      %varXqav1=var(Xq-X,1)/2
      %varXqav1=mean(abs(Xq-X).^2)/2
    end
    Xerr(ic,:)=Xq-X;
    varXq=mean(abs(Xerr(1:ic,:)).^2,1)/2;
    varXqav=mean(varXq);
    fprintf('cyc = %.0f, var{X(N-1)}/2 = %.3g, varXav/2 = %.3g\n',ic,varXq(N),varXqav)
    %fprintf('.'), if ic==C, disp(' '), end
    if rem(ic,20)==0
      varXth, varXavth
      plot([1:N],varXq,N,varXth,'.g',[1,N],varXavth*[1,1],':r'), drawnow, shg
    end
  end
  plot([1:N],varXq,N,varXth,'.g',[1,N],varXavth*[1,1],':r'), drawnow, shg
  %if strcmp(alg,'PQN'), save DIT_PQN, else save DIT_q, end
end

%(b)
Qcos=Q; Qmul=Q;
if any(findstr('b',abcd))|any(findstr('c',abcd))|isempty(abcd)
  if any(findstr('b',abcd))|isempty(abcd)
    figure(2)
    disp('Input quantization and all roundoffs')
  end
  if any(findstr('c',abcd))|isempty(abcd)
    disp('Coeff. roundoffs')
  end
  C=50;
  global N_for_test_only
  if ~isempty(N_for_test_only), C=2; end %make tests shorter
  for ic=1:C
    x=1/32*(rand(1,N)-0.5)*2; xq=roundq(x,qstructset(Q,'Operation','quantize'));
    Xqq=roundfft(xq,Q,struct('algorithm','DIT','Qinput',Qinput,'Qcos',Qcos,'Qmul',Qmul));
    X=fft(x); Xq=fft(xq);
    %figure(1), plot([0:N-1],real(X),'b',[0:N-1],imag(X),'g')
    if ic==1
      varXth=q^2/12*N/2
      varXavth=q^2/12*N/3
      varXthstr='q^2/12*N/2, varXavth=q^2/12*N/3';
      %varXqav1=var(Xq-X,1)/2
      %varXqav1=mean(abs(Xq-X).^2)/2
    end
    if any(findstr('b',abcd))|isempty(abcd)
      Xerr(ic,:)=Xqq-X;
      varXq=mean(abs(Xerr(1:ic,:)).^2,1)/2;
      varXqav=mean(varXq);
      fprintf('cyc = %.0f, var{X(N-1)}/2 = %.3g, varXav/2 = %.3g\n',ic,varXq(N),varXqav)
      %fprintf('.'), if ic==C, disp(' '), end
      if rem(ic,20)==0
        varXth, varXavth
        figure(2)
        plot([1:N],varXq,N,varXth,'.g',[1,N],varXavth*[1,1],':r'), drawnow, shg
      elseif ic==C
        figure(2)
        plot([1:N],varXq,N,varXth,'.g',[1,N],varXavth*[1,1],':r'), drawnow, shg
      end
    end
    if any(findstr('c',abcd))|isempty(abcd)
      Xerr2(ic,:)=Xqq-Xq;
      varXq2=mean(abs(Xerr2(1:ic,:)).^2,1)/2;
      varXqav2=mean(varXq2);
      fprintf('cyc = %.0f, var{X(N-1)}/2 = %.3g, varXav/2 = %.3g\n',ic,varXq2(N),varXqav2)
      %fprintf('.'), if ic==C, disp(' '), end
      if rem(ic,20)==0
        %varXth, varXavth
        figure(3)
        plot([1:N],varXq2,N,varXth,'.g',[1,N],varXavth*[1,1],':r'), drawnow, shg
      elseif ic==C
        figure(3)
        plot([1:N],varXq2,N,varXth,'.g',[1,N],varXavth*[1,1],':r'), drawnow, shg
      end
    end
  end
end

Qinput=qstruct('double');
Qcos=qstruct('double');
if any(findstr('d',abcd))|isempty(abcd)
  figure(4)
  disp('Input quantization, no coefficients quantization')
  C=50;
  global N_for_test_only
  if ~isempty(N_for_test_only), C=2; end %make tests shorter
  for ic=1:C
    x=1/32*(rand(1,N)-0.5)*2; xq=roundq(x,qstructset(Q,'Operation','quantize'));
    Xq=roundfft(xq,Q,struct('algorithm','DIT','Qinput',Qinput,'Qcos',Qcos,'Qmul',Qmul));
    X=fft(x);
    %figure(1), plot([0:N-1],real(X),'b',[0:N-1],imag(X),'g')
    if ic==1
      varXth=q^2/12*N/2
      varXavth=q^2/12*N/3
      varXthstr='q^2/12*N/2, varXavth=q^2/12*N/3';
      %varXqav1=var(Xq-X,1)/2
      %varXqav1=mean(abs(Xq-X).^2)/2
    end
    Xerr(ic,:)=Xq-X;
    varXq=mean(abs(Xerr(1:ic,:)).^2,1)/2;
    varXqav=mean(varXq);
    fprintf('cyc = %.0f, var{X(N-1)}/2 = %.3g, varXav/2 = %.3g\n',ic,varXq(N),varXqav)
    %fprintf('.'), if ic==C, disp(' '), end
    if rem(ic,20)==0
      varXth, varXavth
      figure(4)
      plot([1:N],varXq,N,varXth,'.g',[1,N],varXavth*[1,1],':r'), drawnow, shg
    elseif ic==C
      plot([1:N],varXq,N,varXth,'.g',[1,N],varXavth*[1,1],':r'), drawnow, shg
      %if strcmp(alg,'PQN'), save DIT_PQN, else save DIT_q, end
    end
  end
  end
end
