disp('Solving exercise 15.9 ...')

close all
%B=16; %old
B=18;
Q=qstruct('Q','B',B,'fb',B-1);
Qlong=qstruct('Qlong','B',54,'fb',53);
%Nvec=256; old
Mvec=[4:11];
%Mvec=[4:8];
global N_for_test_only
if ~isempty(N_for_test_only), Mvec=[3,4]; end %make tests shorter
for fig='abcd'
%for fig='a'
  Nv=[]; NSRv=[]; RMSe_RMSX=[]; RMSethv=NaN;
  varXWv=[];
  for N=2.^Mvec
    if findstr(fig,'a')
      x=(rand(N,1)-0.5)*2; RMSx=1/sqrt(3); xN{log2(N)}=x;
    elseif findstr(fig,'c')
      x=rand(N,1); RMSx=sqrt(1/12+1/4); xN{log2(N)}=x;
    else
      x=xN{log2(N)};
    end
    x=x(:); xq=roundq(x,Q);
    C=0.4; Cs=C*2^(3/2)*2/RMSx;
    RMSX=sqrt(N)*RMSx;
    RMSeth=RMSX * sqrt(N)*2^(-B)*Cs;
    fprintf('N = %.0f, theor. variance of X = %.1e\n',N,RMSeth)

    c0=clock;
    if findstr(fig,'bd')
      X=fft(x); RMSX2=sqrt(mean(abs(X(1:end)).^2));
      Xqq_bf=roundfft(x,Q,struct('exponent','block-float'));
      Xq=Xqq_bf.data*2^Xqq_bf.bfe;
    elseif findstr(fig,'ac')
      Xq=fft(xq);
      Xqq_bf=roundfft(xq,Q,struct('exponent','block-float','Qcos',Qlong));
      Xqq=Xqq_bf.data*2^Xqq_bf.bfe;
      if findstr(fig,'a')
        XWq_bf=roundfft(xq,Qlong,struct('exponent','block-float','Qcos',Q));
        XWq=XWq_bf.data*2^XWq_bf.bfe;
      end
    end
    et=etime(clock,c0);
    err=[];
    if findstr(fig,'ac')
      err=(Xqq-Xq);
    elseif findstr(fig,'bd')
      err=(Xq-X);
    end
    varX=(err'*err)/N;
    if findstr(fig,'a')
      X=fft(x); err=(XWq-X);
      varXW=(err'*err)/N;
      varX,varXW
      varXWv=[varXWv,varXW/varX];
    end
    stdX=sqrt(double(varX)); if imag(stdX), error('Imaginary stdX'), end
    fprintf('RMS = %.1e\n',stdX), RMS=stdX;
    fprintf('Elapsed time in cycle: %.0f min %.0f s\n',fix(et/60),rem(et,60))
    Nv=[Nv,N]; %NSRv=[NSRv,20*log10(stdX)]; 
    RMSe_RMSX=[RMSe_RMSX,stdX/RMSX];
    RMSethv=[RMSethv,RMSeth/RMSX];
    if N==32, RMSethv(1)=RMSethv(2)/(RMSethv(3)/RMSethv(2))^log2(1.6); end
    figure(fig-'a'+1)
    semilogy(log2(Nv),RMSe_RMSX,'o',...
      [log2(10),log2(Nv)],[RMSethv],[log2(10),log2(Nv)],3/4*[RMSethv],':'), grid
    set(gca,'xlim',[log2(10),log2(N)+1])
    set(gca,'ylim',[10^(-5),10^(-3)])
    xlabel('M = log2(N)')
    if findstr(fig,'ab'), titlstr='input uniform in (-1,1)';
    else titlstr='input uniform in (0,1)';
    end
    if findstr(fig,'ac'), titlstr2=', only operation roundoffs';
    else titlstr2=', all roundoffs';
    end
    title(['RMS\{err\}/RMS\{X\}, ',titlstr,titlstr2])
    drawnow, shg
  end% for N
  saveprobfig(fig-'a'+1,['figp_15_9',fig,'.eps'])
  if findstr(fig,'a')
    figure(5), plot(log2(Nv),varXWv)
    title(['var-Wround / var-opround',titlstr])
    xlabel('M = log2(N)')
    saveprobfig(5,['figp_15_9e.eps'])
  end
end %for fig
