function exercise_16_8
disp('Solving exercise 16.8 ...')

close all

%1. theoretically
B=16; q=2^(-(B-1)); Qfix=qstruct('Qfix','B',16,'fb',B-1);
p=12; Qfloat=qstruct('Qfloat','p',p);
ord=3;

disp('Fixed-point:')
varnuout=2*ord*q^2/12
A=0.06; 
SNR1fix=10*log10(0.5*A^2/varnuout)

disp('Floating-point')
a=[1,-0.28,0.19,0.7]; b=[0.7,0.19,-0.28,1];
Ntr=120;
Nx=1e3+Ntr+2; 
x=A*sin(2*pi*0.1*[1:Nx]);
xAR=filter([1],a,x); y=filter(b,a,x);
plot(xAR), shg
MS=[...
  mean(x(Ntr+3:end).^2)
    mean(xAR(Ntr+3:end).^2)
    mean((-a(1)*xAR(Ntr+2:end-1)-a(2)*xAR(Ntr+1:end-2)-a(3)*xAR(Ntr:end-3)).^2)
    mean((-a(1)*xAR(Ntr+2:end-1)-a(2)*xAR(Ntr+1:end-2)).^2)
    mean((b(1)*xAR(Ntr+2:end-1)+b(2)*xAR(Ntr+1:end-2)+b(3)*xAR(Ntr:end-3)).^2)
    mean((b(1)*xAR(Ntr+2:end-1)+b(2)*xAR(Ntr+1:end-2)).^2)
    mean(y(Ntr+3:end).^2)
  ];
MS=[MS,MS/A^2]
MSout=0.180*2^(-2*p)*(MS(2)*(sum(a(2:end).^2)+sum(b.^2))+sum(MS(2:end)))*A^2
MSoutdB=10*log10(MSout)
SNRout=10*log10(0.5*A^2)-MSoutdB

figure(1)
H_AR=tf([1],a,1), bode(H_AR), shg
h_AR=impulse(H_AR); hARabssum=sum(abs(h_AR))
saveprobfig(1,'figp_16_8.eps')
H=tf(b,a,1); %bode(H), shg
h=impulse(H); habssum=sum(abs(h))
%h2sum=sum(h.^2)

%LATTICE
[k,v]=tf2latc(b,a);
[ylat,sk]=latcfilt_ap_q(k,x);

%fixed-point
wt=[];
for imp=1:6
  [h_i]=latcfilt_ap_q(k,zeros(size(x)),'',imp);
  wt=[wt,sum(h_i(1:end).^2)];
end
weight=2*sum(wt)
MSoutlatfix=weight*q^2/12
MSoutlatfixdB=10*log10(A^2/2/MSoutlatfix)

maxHv=[]; hsum=[];
[y,ski]=latcfilt_ap_q(k,[1,zeros(size(x))]);
for ki=1:13
  h=ski(:,ki); hsum=[hsum,sum(abs(h))];
  H=fft(h); maxH=max(abs(H));
  maxHv=[maxHv,maxH];
end
maxHv, maxH=max(maxHv), maxhsum=max(hsum)

MaxHw=max(maxHv([6,2,1])), maxhsumw=max(hsum([6,2,1])),

%floating-point
MSlat=[mean(sk(Ntr:end,1:end).^2)];
%MSlatA2=MSlat/(A^2/2)
MSoutlat=0.180*2^(-2*p)*sum(MSlat);
MSoutlatdB=10*log10(MSoutlat);
SNRoutlatfloat=10*log10(0.5*A)-MSoutlatdB

[ydirIIqfix]=filter_dirii_q(b,a,x,Qfix);
dirII_SNR_fix_simul=10*log10(mean((ylat(Ntr:end)).^2)/mean((ydirIIqfix(Ntr:end)-ylat(Ntr:end)).^2))
[ydirIIqfloat]=filter_dirii_q(b,a,x,Qfloat);
dirII_SNR_float_simul=10*log10(mean((ylat(Ntr:end)).^2)/mean((ydirIIqfloat(Ntr:end)-ylat(Ntr:end)).^2))

[ylatqfix]=latcfilt_ap_q(k,x,Qfix);
lattice_SNR_fix_simul=10*log10(mean((ylat(Ntr:end)).^2)/mean((ylatqfix(Ntr:end)-ylat(Ntr:end)).^2))
[ylatqfloat]=latcfilt_ap_q(k,x,Qfloat);
lattice_SNR_float_simul=10*log10(mean((ylat(Ntr:end)).^2)/mean((ylatqfloat(Ntr:end)-ylat(Ntr:end)).^2))

%save matlab
