function exercise_17_10
disp('Solving exercise 17_10 ...')

%clear
fs=10; %Hz
T=1/fs;
C1=0.49; C2=1.23;
Hplant_s=tf(1,[1,1,0]);
Hplant_z=c2d(Hplant_s,T,'zoh'); set(Hplant_z,'variable','z^-1');
d1=Hplant_z.den{1}(1);
Hplant_z.num{1}=Hplant_z.num{1}/d1;
Hplant_z.den{1}=Hplant_z.den{1}/d1
N=1e3;
Hcomp=tf(2.04*0.2*[1,1/2]*0.813,[1,-1/2],T); %,'variable','z^-1'
B1=10; qADC=10/2^B1;
B2=8; qDAC=10/2^B2; plantinprev=0;

fdA=100.31;
fdD=100.31;
for ii='abcd'-'a'+1 %bd
  if ii==1, dADC=zeros(N,1); dDAC=zeros(N,1);
  elseif ii==2, dADC=qADC*(rand(N,1)-.5); dDAC=qDAC*(rand(N,1)-.5);
  elseif ii==3, dADC=qADC/3*(randn(N,1)); dDAC=qDAC/3*(randn(N,1));
  elseif ii==4, dADC=sqrt(2)*qADC*sin(2*pi*[1:N]*fdA); dDAC=sqrt(2)*qDAC*sin(2*pi*[1:N]*fdD);
  end %dithers
  errmax=0; dcerrmax=1.8;
  for qd={'','d','q','qd'}
    qd=qd{1};
    if ii==1
      A=0.06/4;
      A=0.02;
      x=A*sin(2*pi*[0:N-1]/100); 
    end
    y=zeros(size(x));
    Fc=0; Fpl=[0,0]; plantinprev=0; histoutprev=0;
    if ii==1, AmaxADC=0; AmaxDAC=0; end 
    for n=1:N-1
      ADCin=(x(n)-y(n))*C1;
      if any(findstr('d',qd))
        ADCin=ADCin+dADC(n);
      end
      %if ii==1,
      if any(findstr('q',qd))
        ADCout=qADC*round(ADCin/qADC);
      else ADCout=ADCin; 
      end
      if (ii==1)&(n>N-100)
        if (abs(ADCin)>AmaxADC), AmaxADC=abs(ADCin); end
      end
      [DACin,Fc]=filter(Hcomp.num{1},Hcomp.den{1},ADCout,Fc);
      if any(findstr('d',qd))
        DACin=DACin+dDAC(n);
      end
      %if ii==1,
      if any(findstr('q',qd))
        DACout=qDAC*round(DACin/qDAC); 
      else DACout=DACin; 
      end
      if (ii==1)&(n>N-100)
        if (abs(DACin)>AmaxDAC), AmaxDAC=abs(DACin); end 
      end
      plantin=C2*DACout;
      if ii==6, dhist=0.03; else dhist=0; end
      plantin=plantin+dhist*randn(1,1); %dither at hysteresis
      if any(ii==[1,2])&0 %hysteresis
        dh=0.05;
        if (abs(plantin-plantinprev)>dh)
          signpl=sign(plantin-plantinprev);
          plantin=plantin-dh*signpl; if abs(plantin)>2, plantin=2*sign(plantin); end
          plantinprev=plantin; histoutprev=plantin;
        else
          plantin=histoutprev;
        end
      end
      [ynp1,Fpl]=filter(Hplant_z.num{1},Hplant_z.den{1},plantin,Fpl);
      y(n+1)=ynp1;
    end %for n
    if strcmp(qd,''), y0=y; end
    if strcmp(qd,'q'), yq=y; end
    if strcmp(qd,'d'), yd=y; end
    if strcmp(qd,'qd'), yqd=y; end
  end %for qd

  %if any(ii==[1,2,3,4])
    figure(ii)
    subplot(2,1,1)
    plot([1:N]*T,x), shg
    title(sprintf('Command input, A = %.3g',A))
    set(gca,'ylim',0.035*[-1,1])
    subplot(2,1,2)
    if ii==1, y=yq;
    else y=yqd;
    end
    plot([1:N]*T,y), shg
    title('System output')
    set(gca,'ylim',0.035*[-1,1])
    shg, drawnow
    saveprobfig(ii,['figp_19_9',setstr('a'-1+ii),'.eps'])
  %end
  %AmaxADC, qADC, AmaxDAC, qDAC
  if ii==1, disp('No dither')
  elseif ii==2, disp(' '), disp('Uniform dither')
  elseif ii==3, disp(' '), disp('Gaussian dither')
  elseif ii==4, disp(' '), disp('Sinusoidal dither')
  end
  RMSqderr=sqrt(mean((yqd(N-[0:499])-y0(N-[0:499])).^2))
  RMSderr=sqrt(mean((yd(N-[0:499])-y0(N-[0:499])).^2))
  RMSqerr=sqrt(RMSqderr^2-RMSderr^2)
end %for ii
