disp('Solving exercise 17.12 ...')

fs=10; %Hz
T=1/fs;
C1=0.49; C2=1.23;
Hplant_s=tf(1,[1,1,0])
Hplant_z=c2d(Hplant_s,T,'zoh'); set(Hplant_z,'variable','z^-1');
d1=Hplant_z.den{1}(1);
Hplant_z.num{1}=Hplant_z.num{1}/d1;
Hplant_z.den{1}=Hplant_z.den{1}/d1
if ~exist('N_for_test_only'), N=1000; else N=N_for_test_only; end
Hcomp=tf(2.04*0.2*[1,1/2]*0.813,[1,-1/2],T) %,'variable','z^-1'
B1=10; qADC=10/2^B1;
B2=8; qDAC=10/2^B2; plantinprev=0;

for ii='acf'-'a'+1 %bd
  if ii==1, dcv=1.9; %(a) illustrate that there is limit cycle
  elseif ii==2, dcv=[1.6:0.005:1.8,1.9,NaN];
  else dcv=1.9;
  end
  errmax=0; dcerrmax=1.8;
  for dc=dcv
    if isnan(dc), dc=dcerrmax; end
    if ii==3, x=[1;zeros(N-1,1)]; else x=dc*ones(N,1); end
    y=zeros(size(x));
    Fc=0; Fpl=[0,0]; plantinprev=0; histoutprev=0;
    for n=1:N-1
      ADCin=(x(n)-y(n))*C1;
      %if ii==2, ADCin=ADCin+qADC*randn(1,1); end %dither at ADC
      ADCout=qADC*round(ADCin/qADC);
      [DACin,Fc]=filter(Hcomp.num{1},Hcomp.den{1},ADCout,Fc);
      %if ii==2, DACin=DACin+qDAC*randn(1,1); end %dither at DAC
      DACout=qDAC*round(DACin/qDAC);
      plantin=C2*DACout;
      if ii==6, dhist=0.03; else dhist=0; end
      plantin=plantin+dhist*randn(1,1); %dither at hysteresis
      if 1|any(ii==[1,2])%&0 %hysteresis
        dh=0.05;
        if (abs(plantin-plantinprev)>dh)
          signpl=sign(plantin-plantinprev);
          plantin=plantin-dh*signpl; if abs(plantin)>2, plantin=2*sign(plantin); end
          plantinprev=plantin; histoutprev=plantin;
        else
          plantin=histoutprev;
        end
      end
      [ynp1,Fpl]=filter(Hplant_z.num{1},Hplant_z.den{1},plantin,Fpl);
      y(n+1)=ynp1;
    end
    err=abs(dc-mean(y(N/2:N)));
    if err>errmax, errmax=err; dcerrmax=dc; end 
    if ii==3, Bb=sum(abs(y)); end
  end %for dc
  
  figure(ii)
  plot([1:N]*T,y), shg
  %grid
  if dhist==0, dtxt=''; else dtxt=sprintf(', with dither, sigma = %3.g',dhist); end
  if ii==2, dctxt=sprintf(', dc error = %3.g',err); else dctxt=''; end
  if ii==3, 
    title(sprintf(['Impulse response']))
  else
    title(sprintf(['Step response, step of %.3g',dctxt,dtxt],dc))
    hold on, xlim=get(gca,'xlim'); plot(xlim,dc*[1,1],':k'), hold off
  end
  shg, drawnow
  saveprobfig(ii,['figp_19_11',setstr('a'-1+ii),'.eps'])
end %for ii
