disp('Solving exercise 18.2 ...')

clf
qfigset([],[],'subplot')
global N_for_test_only
if ~isempty(N_for_test_only), N=N_for_test_only; else N=1e3; end
Ntr=N;
a=1/3;
p=64;
A=1;
global yesinpacceptdef
yesinpacceptdef='yes';
pause off
systype='linear';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%try, chaos, catch, end
%
%chaos
%Core script to generate illustrations for the chaotic example

if ~exist('systype'), systype=''; end,
if isempty(systype), systype='chaos'; end %chaos or linear
systype=roundq('private','yesinput','Type of system, linear|chaos',systype,'linear|chaos');

if ~exist('N'), N=[]; end, if isempty(N), N=1e3; end
N=roundq('private','yesinput','Number of steps',N,[1,inf]);
%
if ~exist('Ntr'), Ntr=[]; end, if isempty(Ntr), Ntr=20; end
Ntr=roundq('private','yesinput','Number of steps in transient',Ntr,[1,inf]);
%N=50;
if ~exist('a'), a=[]; end, if isempty(a), a=3.8; end
a=roundq('private','yesinput','a',a,[0,4]);
if ~exist('p'), p=[]; end, if isempty(p), p=16; end
p=roundq('private','yesinput','p',p,[2,106]);
ver=version;
if ver(1)>'6'
  if p>53
    try, qclear('Qext'), catch, end
    Q=qmake('Qext','p',p);
    %Q='Qext';
  end
  y=zeros(N,1);
  y(1)=0.5;
  if p<=53, yq=y;
  else yq=qdata(y,Q);
  end
  if ~exist('A'), A=[]; end, if isempty(A), A=0; end
  A=roundq('private','yesinput','Sine amplitude',A,[0,1]);
  T=100;
  st=strcmp(systype,'linear');
  kvect=[0:N-1];
  for k=2:N
    if st==0
      yq(k)=qfloat(qfloat(a*yq(k-1),p)*qfloat(1-yq(k-1),p),p);
      y(k)=(a*y(k-1))*(1- y(k-1));
    else %linear system
      if p<=53
        yq(k)=qfloat(a*yq(k-1),p);
      else
        yq(k)=a*yq(k-1);
        %fprintf('.')
      end
      y(k)=(a*y(k-1));
    end
    if p>=53
      %if yq(k)~=y(k), error(sprintf('yq and y differ for k=%.0f',k)), end
    end
    if A>0
      if p<=53
        yq(k)=qfloat(yq(k)+A*sin(k/T*2*pi),p);
      else
        yq(k)=yq(k)+A*sin(k/T*2*pi);
        fprintf('.')
        if rem(k,50)==0, disp(' '), end
      end
      y(k)=y(k)+A*sin(k/T*2*pi);
    end
  end
  %
  pp=get(gcf,'paperposition'); set(gcf,'paperposition',pp*0.8)
  h221=subplot(2,2,1);
  plot(kvect,y,'.'), title(sprintf('y(k), a=%.4g, p=53',a))
  ax=axis; ax(2)=N; ax(3)=min(ax(3),-ax(4)); axis(ax)
  ax=axis; text(ax(1)-0.2*(ax(2)-ax(1)),ax(3)-0.15*(ax(4)-ax(3)),'(a)')
  xlabel('k')
  h222=subplot(2,2,2);
  plot(kvect,double(yq),'.'), title(sprintf('y''(k), a=%.4g, p=%.0f',a,p))
  axis(ax)
  ax=axis; ax(2)=N; axis(ax);
  text(ax(1)-0.2*(ax(2)-ax(1)),ax(3)-0.15*(ax(4)-ax(3)),'(b)')
  xlabel('k')
  h223=subplot(2,2,3);
  pos=get(h223,'Position'); pos(2)=pos(2)-0.04; set(h223,'Position',pos)
  Ntr=min(Ntr,N); %yq=double(yq)';
  if isa(yq,'qdata'), dy=double(yq-qdata(y)); else dy=yq(1:Ntr)-y(1:Ntr); end
  plot(kvect(1:Ntr),dy,'.'), title('Error: y''(k)-y(k)')
  trmax=max(abs(dy)), trmax2=trmax^2
  mse_dy=mean(dy.^2)
  emax=max(abs(dy)); ax(1:2)=[0,Ntr]; ax(3:4)=1.1*emax*[-1,1];
  if emax<max(abs(y(1:Ntr)))/10, ax(3:4)=ax(3:4)+[-eps,eps]; end
  axis(ax)
  hca=gca; axes('Position',get(gca,'Position'),'visible','off');
  ax=axis; text(ax(1)-0.2*(ax(2)-ax(1)),ax(3)-0.15*(ax(4)-ax(3)),'(c)')
  axes(hca)
  xlabel('k')
  if A>0
    h224=subplot(2,2,4);
    plot(kvect(2:end),A*sin([2:N]/T*2*pi))
    ax2=axis; ax2(3:4)=1.1*A*[-1,1]; axis(ax2)
    title(sprintf('A=%.5g',A))
    ax=axis; text(ax(1)-0.2*(ax(2)-ax(1)),ax(3)-0.15*(ax(4)-ax(3)),'(d)')
    xlabel('k')
    pos=get(h224,'Position'); pos(2)=pos(2)-0.04; set(h224,'Position',pos)
    axes(h223)
  end
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  clear systype
  clear global yesinpacceptdef
  pause on
  %
  if strcmp(qfigtype,'psfrag')
    %title('')
    psfname=[qfigsdir,'figp_20_2.eps'];
    global saveprobfigson
    if saveprobfigson
      disp(['Preparing file ',psfname,' ...'])
      print('-deps',psfname)
    end
  elseif strcmp(qfigtype,'styled')
    %everything is done
  else %strcmp(qfigtype,'simple')
    %everything is done
  end
  figure(gcf)
else
  warning('cannot execute in Matlab under version 7')
end
