disp('Solving exercise 21.1 ...')

close all
Q=qstruct(struct('type','fixed-point','B',15,'fb',10,'coding','two''s complement'));
qstructget(Q)
h=[1 -0.3 0.7 0.5 -0.8 1 .2];
hq=qfix(h,Q);
he=hq-h;
disp('''Exact'' filter coefficients:')
for ii=1:length(h), fprintf('  '), num2bin(roundq(h(ii),qstruct('bits',54,'fract',52)),'fixed'), end
disp('Quantized filter coefficients:')
for ii=1:length(hq), fprintf('  '), num2bin(hq(ii),Q), end
disp('Error filter coefficients:')
for ii=1:length(he), fprintf('  '), num2bin(he(ii),'fixed'), end
figure(1)
subplot(2,1,1)
ver=version;
if ver(1)>'7'
  stem([0:6],hq,'markersize',0)
else
  stem([0:6],hq)
end
set(gca,'ylim',[-1.2,1.2])
set(gca,'xlim',[-.5,6.5])
title('Quantized filter')
subplot(2,1,2)
stem([0:6],hq-h,'markersize',0)
set(gca,'xlim',[-.5,6.5]), set(gca,'ylim',[-.2e-4,2.5e-4])
title('Error filter')
%
N=1024;
[H,f]=freqz(h,1,N);
[Hq,fq]=freqz(hq,1,1024);
He=Hq-H;
figure(2)
subplot(2,1,1)
plot(fq,db(Hq)); ylabel('dB')
title('Quantized filter')
subplot(2,1,2)
plot(f,db(Hq-H)); ylabel('dB')
title('Error filter')
shg

saveprobfig(1,['figp_21_1a.eps'])
saveprobfig(2,['figp_21_1b.eps'])