disp('Solving exercise 21.6 ...')

close all
Q=qstruct(struct('type','fixed-point','B',10,'fb',5,'coding','two''s complement'));
qstructget(Q)
b=0.9; bq=qfix(b,Q);
B=1; A=[1 -b]; H=tf([B,0],A,1); set(H,'variable','z^-1');
B=1; Aq=[1 -bq]; Hq=tf([B,0],Aq,1); set(Hq,'variable','z^-1');
He=Hq-H;

N=60;
u=[zeros(1,N-1)]; y=u;
del=2; ym1=1.7; ym1q=qfix(1.75,Q);

%(a)
y=[ym1,filter(B,A,u,b*ym1)];
%ye=filter(He.num{1},He.den{1},u);
figure(1), stem([-1:N-2],y,'markersize',0), set(gca,'xlim',[-2.5,N])
title('Response of perfect system')

%(b)
yqi=[ym1q,filter(B,A,u,b*ym1q)];
figure(2)
subplot(2,1,1)
stem([-1:N-2],yqi,'markersize',0), set(gca,'xlim',[-2.5,N])
title('Response of perfect system, rounded initial condition')
subplot(2,1,2)
stem([-1:N-2],yqi-y,'markersize',0), set(gca,'xlim',[-2.5,N])
title('Difference from perfect response')

%(c)
yqc=[ym1,filter(B,Aq,u,bq*ym1)];
figure(3)
subplot(2,1,1)
stem([-1:N-2],yqc,'markersize',0), set(gca,'xlim',[-2.5,N])
title('Response of system with bq, perfect initial condition')
subplot(2,1,2)
stem([-1:N-2],yqc-y,'markersize',0), set(gca,'xlim',[-2.5,N])
title('Difference from perfect response')

%(d)
yqci=[ym1q,filter(B,Aq,u,bq*ym1q)];
figure(4)
subplot(2,1,1)
stem([-1:N-2],yqci,'markersize',0), set(gca,'xlim',[-2.5,N])
title('Response of system with bq, rounded initial condition')
subplot(2,1,2)
stem([-1:N-2],yqci-y,'markersize',0), set(gca,'xlim',[-2.5,N])
title('Difference from perfect response')

%(e)
figure(5)
subplot(2,1,1)
stem([-1:N-2],y+yqci,'markersize',0), set(gca,'xlim',[-2.5,N])
title('Sum of perfect response, and rounded b and y(-1)')
subplot(2,1,2)
stem([-1:N-2],yqi+yqc,'markersize',0), set(gca,'xlim',[-2.5,N])
title('Sum of response with rounded b, and response with rounded y(-1)')

figure(6)
subplot(2,1,2)
stem([-1:N-2],y+yqci-(yqi+yqc),'markersize',0), set(gca,'xlim',[-2.5,N])
title('Difference of the two different sums')

saveprobfig(1,['figp_21_6a.eps']) 
saveprobfig(2,['figp_21_6b.eps'])
saveprobfig(3,['figp_21_6c.eps'])
saveprobfig(4,['figp_21_6d.eps']) 
saveprobfig(5,['figp_21_6e.eps'])
saveprobfig(6,['figp_21_6f.eps'])
