disp('Solving exercise 4.14 ...')

figure(1)
x=-5:0.01:5; sigma=1;
fx=0.4*1/sqrt(2*pi)*exp(-(x-sigma).^2/2);
fx=fx+0.6*1/sqrt(2*pi)*exp(-(x+sigma).^2/2);
plot(x,fx,'linewidth',1.7), set(gca,'ylim',[0,.3])
hold on
for ii=-4.5:4.5
plot([ii,ii],get(gca,'ylim'),':')
end
hold off
shg
saveprobfig(1,'figp_4_12a.eps')

q=1; sigma=q;
Ex=-0.2*sigma; Exq=Ex;
Ex2=2*sigma^2; Ex2q=Ex2+q^2/12;
Ex3=-0.2*sigma^3;
Ex4=10*sigma^4;

S2=q^2/12;
S3=q^2/4*Exq;
S4=1/2*q^2*Ex2q - 7/240*q^4;

R2=(sigma^2/pi^2+4*sigma^2)*exp(-2*pi^2);
R3=(-3*q*(-1)/pi*2*(-0.2*sigma^2) -3*q^2*(1/pi)^2*(-0.2*sigma)/pi^2)...
   *exp(-2*pi^2);  
R4=(-6*(q^2/pi^2*(-1) + 2*q/pi*(-sigma*2*pi))*q^2/2 ...
        +4*q*((-1)/pi*((3*sigma^3*2*pi - sigma^3* 2*pi)^3 )...
    -3*(-0.2)*sigma)*(-sigma^2 + sigma^2*(2*pi)^2 )-3*sigma^2*(-sigma*2*pi)...
       +6*q^2/pi^2*((- sigma^2 + sigma^2 *(2*pi)^2 )-sigma^2)...
     +q^3*(1/pi -6/pi^3)*(- sigma*2*pi)+q^4/2*(-1/pi^2) -6/pi^4)...
   *exp(-2*pi^2);

R2pS2=R2/S2;
R3pS3=R3/S3;
R4pS4=R4/S4;

%Monte Carlo...
Nx=1e6; Nx1=round(0.4*Nx); Nx2=round(0.6*Nx); q=1;
R2_MC=0; R3_MC=0; R4_MC=0;
varR2=0; varR3=0; varR4=0;
global N_for_test_only
if ~isempty(N_for_test_only), N=round(N_for_test_only/30);
else N=100;
end
for n=1:N
  x=[randn(Nx1,1)+1;randn(Nx2,1)-1];
  if n==1
    figure(2)
    hist(x,50), set(gca,'xlim',[-5,5]), drawnow, shg
    saveprobfig(2,'figp_4_12b.eps')
  end
  xq=q*round(x/q);
  mxq=-0.2*sigma; mxq2=mean(xq.^2);
  R2_MCn=(mxq2-q^2/12-mean(x.^2));
  R2_MC=(n-1)/n*R2_MC+1/n*R2_MCn;
  R3_MCn=(mean(xq.^3)-3*mxq*q^2/12-mean(x.^3));
  R3_MC=(n-1)/n*R3_MC+1/n*R3_MCn;
  R4_MCn=(mean(xq.^4)-(q^2/2*mxq2-7/240*q^4)-mean(x.^4));
  R4_MC=(n-1)/n*R4_MC+1/n*R4_MCn;
  if n>1
    varR2=(n-2)/(n-1)*varR2 + n/(n-1)^2*abs(R2_MCn-R2_MC).^2;
    varR3=(n-2)/(n-1)*varR3 + n/(n-1)^2*abs(R3_MCn-R3_MC).^2;
    varR4=(n-2)/(n-1)*varR4 + n/(n-1)^2*abs(R4_MCn-R4_MC).^2;
  end
  fprintf('.')
  if rem(n,50)==0, disp(' '), end
end
disp(' ')

format short e
fprintf('Samples: %.2e x %.0f\n',Nx,N)
R2_S2_R2pS2_R2MC_stdR2=[R2,S2,R2/S2,R2_MC,sqrt(varR2/N)]
R3_S3_R3pS3_R3MC_stdR3=[R3,S3,R3/S3,R3_MC,sqrt(varR3/N)]
R4_S4_R4pS4_R4MC_stdR4=[R4,S4,R4/S4,R4_MC,sqrt(varR4/N)]
format short
