disp('Solving Exercise 4.8 ...')

close all

q=1;
dx=5/1000;
xv=-5*q+dx/2:dx:5*q;

fx=zeros(size(xv));
ind=find((xv>-1.7*q)&(xv<1.7*q));
fx(ind)=1/3.4*ones(size(ind));
indnu=find(abs(xv)<0.7*q); nu=xv(indnu);
indnu05=find((nu>-0.5*q)&(nu<0.5*q));
fnu=zeros(size(nu));
for nui=indnu05
  indi=find(abs(rem(xv-nu(nui),q)-round(rem(xv-nu(nui),q)))<dx/3);
  fnu(nui)=sum(fx(indi));
  %indi,fx(indi),lengthindi=length(indi)
end

figure(11)
plot(fliplr(nu),fnu);
title('PDF of the quantization noise');
saveprobfig(11,'figp_4_8g.eps')

Enu2=3/3.4*1/12+2/3.4*1/3*(0.5^3-0.3^3)

fx=zeros(size(xv));
ind=find(abs(xv)<1.7*q);
fx(ind)=1/3.4*ones(size(ind));

figure(1)
plot(xv,fx);
title('Original PDF');
saveprobfig(1,'figp_4_8a.eps')

f1=(1-3/3.4)/2;
f2=1/3.4;
f3=1/3.4;
f4=1/3.4;
f5=(1-3/3.4)/2;

F1=f1
F2=F1+f2
F3=F2+f3
F4=F3+f4;
F5=F4+f5;

sincm2=sinc((xv+2)/q)*F1;
sincm1=sinc((xv+1)/q)*F2;
sinc0=sinc((xv-0)/q)*F3;
sinc1=sinc((xv-1)/q)*F4;
sinc2=sinc((xv-2)/q)*F5;
sinc3=sinc((xv-3)/q);

figure(2)
plot(xv,sincm2,xv,sincm1,xv,sinc0,xv,sinc1,xv,sinc2,xv,sinc3);
title('Interpolating sinc functions');
saveprobfig(2,'figp_4_8b.eps')

Fkozel=sincm2+sincm1+sinc0+sinc1+sinc2+sinc3;
for ii=4:100
  Fkozel=Fkozel+sinc((xv-ii)/q);
end
figure(3)
plot(xv,Fkozel);
title('Approximation of the CDF');
saveprobfig(3,'figp_4_8c.eps')

f=diff(Fkozel)/dx; f=[f,f(end)];
figure(4)
plot(xv,f);
set(gca,'xlim',[-5,5])
title('Interpolated PDF');
saveprobfig(4,'figp_4_8d.eps')

figure(5)
plot(xv+q/2,f);
set(gca,'xlim',[-5,5])
title('The interpolated PDF shifted to the right');
saveprobfig(5,'figp_4_8e.eps')

figure(6)
plot(xv+q/2,f,xv,fx)
set(gca,'xlim',[-5,5])
title('Interpolated and original PDF');
saveprobfig(6,'figp_4_8f.eps')

figsorder