disp('Solving exercise 5.11...')

close all
sigma=1; q=1;
plotno=0;
dnu=0.02*q;
for mu=[0,q/4]
  for typ='abc' %three methods
    plotno=plotno+1;
    plotlab=setstr('a'-1+plotno);
    figure(plotno)
    %for q=[1,2,2.5]*sigma
    for sigma=[1,0.5,0.4]*q
      if strcmp(typ,'a')
        %PDF
        nu=-0.5*q:dnu:0.5*q; fnu=zeros(size(nu));
        for xq=floor(-4*sigma+mu):ceil(4*sigma+mu)
          fnu=fnu+1/sqrt(2*pi)/sigma*exp(-(xq-nu-mu).^2/2/sigma^2);
        end
        plot(nu,fnu)
        title(['f(\nu), Sliced PDF, \mu = ',num2str(mu)])
      elseif strcmp(typ,'b')
        %CF based PDF
        nu=-0.5*q:dnu:0.5*q; fnu=zeros(size(nu));
        for l=[-10:10]
          u=l*2*pi/q;
          fnu=fnu+exp(j*u*mu-sigma^2*u^2/2)*exp(j*l*2*pi/q*nu);
        end
        plot(nu,real(fnu))
        title(['f(\nu), Fourier series, \mu = ',num2str(mu)])
      elseif strcmp(typ,'c')
        %Monte Carlo
        Nx=2e6;
        x=sigma*randn(Nx,1)+mu;
        xp=q*round(x/q);
        nu=xp-x;
        nuh=-.5+dnu/2:dnu:.5;
        [N,X]=hist(nu,nuh);
        %bar(X,N/Nx/dnu)
        plot(X,N/Nx/dnu)
        title(['f(\nu), Monte-Carlo, \mu = ',num2str(mu)])
      end
      if q==sigma, hold on, end
    end %for sigma
    set(gca,'ylim',[0,1.5])
    saveprobfig(plotno,['figp_5_5',plotlab,'.eps'])
  end %for typ
end %for mu
clear x xp nu