function exercise_9_2
disp('Solving exercise 9.2...')

close all
Nx=1e6;
rho=0.8; q=1; A1=2.8*q/2; A2=3*q/2; mu1=0.5*q; mu2=0;
plotno=0; res=50; dx=0.05;
for typ='bc'
  if strcmp(typ,'b')
    x1=randn(Nx,1); x2=rho*x1+sqrt(1-rho^2)*randn(Nx,1);
    x1u=A1*2*(GaussCDF(x1)-0.5)+mu1; x2u=A2*2*(GaussCDF(x2)-0.5)+mu2;
  else %'c'
    ind1=0; Nx2=Nx/2; lim=1.9*A1*(1-rho);
    while ind1<Nx
      x1=A1*2*(rand(Nx2,1)-0.5)+mu1; x2=A2*2*(rand(Nx2,1)-0.5)+mu2;
      indm1=find(((x1-mu1)>(x2-mu2)/A2*A1+lim)&((x1-mu1)<=-A1+2*lim)); 
      x1(indm1)=-2*A1+2*lim-(x1(indm1)-mu1)+mu1;
      indm2=find(((x1-mu1)<(x2-mu2)/A2*A1-lim)&((x1-mu1)>=(A1-2*lim))); 
      x1(indm2)=2*A1-2*lim-(x1(indm2)-mu1)+mu1;
      ind=sort([find(abs(x1-mu1-(x2-mu2)/A2*A1)<=lim)]);
      N=min(length(ind),Nx-ind1);
      x1u(ind1+[1:N])=x1(ind(1:N)); x2u(ind1+[1:N])=x2(ind(1:N));
      ind1=ind1+N;
    end
  end
  plotno=plotno+1; figure(plotno)
  if exist('hist3.m','file')
    [N3,X3]=hist3([x1u,x2u],{mu1+[-A1-dx/2:dx:A1],mu2+[-A2-dx/2:dx:A2]});
    hist3([x1u,x2u],{mu1+[-A1:dx:A1],mu2+[-A2:dx:A2]})
    set(gca,'view',[-14.5000   28.0000])
    title('Input PDF')
    saveprobfig(plotno,['figp_9_2',setstr('a'-1+plotno),'.eps'])
  else
    warning(['Figure 9.2',setstr('a'-1+plotno),' is generated using the hist3 function of the Statistics Toolbox'])
  end

  plotno=plotno+1; figure(plotno)
  if exist('hist3.m','file')
    hist3([x1u,x2u],{[round(-1.1*A1+mu1)+.5:1.1*A1+mu1],[round(-1.1*A2+mu2)+.5:1.1*A2+mu2]});
    set(gca,'view',[-14.5000   28.0000])
    title('Quantizer output PDF')
    saveprobfig(plotno,['figp_9_2',setstr('a'-1+plotno),'.eps'])
  else
    warning(['Figure 9.2',setstr('a'-1+plotno),' is generated using the hist3 function of the Statistics Toolbox'])
  end

  plotno=plotno+1; figure(plotno)
  if exist('hist3.m','file')
    ind1=find((X3{1}<0.5)&(X3{1}>=-0.5)); ind2=find((X3{2}<0.5)&(X3{2}>=-0.5));
    nu1=X3{1}(ind1); nu2=X3{2}(ind2);
    fnu=zeros(length(ind1),length(ind2));
    for i1=1:length(X3{1})
      for i2=1:length(X3{2})
        [dummy,nu1i]=min(abs(nu1+X3{1}(i1)-round(X3{1}(i1))));
        [dummy,nu2i]=min(abs(nu2+X3{2}(i2)-round(X3{2}(i2))));
        fnu(nu1i,nu2i)=fnu(nu1i,nu2i)+N3(i1,i2);
      end
    end
    %[X,Y]=meshgrid(nu2,nu1);
    %mesh(X,Y,fnu)
    bar3(nu1,flipud(fnu))
    set(gca,'view',[-14.5000   28.0000])
    set(gca,'xtick',[.65,length(nu2)/2,length(nu2)+.35],...
      'xticklabel',{'-0.5','0','0.5'})
    set(gca,'yticklabel',{'0.5','0','-0.5'})
    saveprobfig(plotno,['figp_9_2',setstr('a'-1+plotno),'.eps'])
  else
    warning(['Figure 9.2',setstr('a'-1+plotno),' is generated using the hist3 function of the Statistics Toolbox'])
  end
  
  if strcmp(typ,'b'), disp('Transforming Gaussian...')
  elseif strcmp(typ,'c'), disp('Modifying uniform...')
  end
  x1q=q*round(x1u/q); x2q=q*round(x2u/q);
  E1=mean([x1q,x2q]);
  E2=mean([x1q.^2,x2q.^2]);
  E12=mean([(x1q).*(x2q)])
  E2_12=mean([(x1q.^2).*(x2q.^2)])
  R12=mean([x1q.*x2q])
  Rth=rho*A1*A2/3
  cov12=(R12-prod(E1))
  rho12=(R12-prod(E1))/sqrt(prod(E2-E1.^2))
  
end %for type

function f=GaussCDF(x,sigma,mu)
if nargin<3, mu=0; end
if nargin<2, sigma=1; end
f=(erf((x-mu)/sqrt(2)/sigma)+1)/2;
