function saveprobfig(n,fn)
%SAVEPROBFIG  Save exercise figures

global saveprobfigson
if (nargin==1)&isstr(n)
  if strcmp(n,'on')
    %allow saving of problem figures
    if isequal(saveprobfigson,1)
      disp('Saving of problem eps files was already switched on')
    else
      saveprobfigson=1; %save files
      disp('Saving of problem eps files is switched on')
    end
    return
  elseif strcmp(n,'off')
    %disable saving of problem figures
    saveprobfigson=0; %save files
    disp('Saving of problem eps files is switched off')
    return
  end
end
if isempty(saveprobfigson), saveprobfigson=isequal(1,2); end %do not save...
if exist('saveprobfig.mat')&saveprobfigson %developer's machine, save is on
else 
  return
end
%if return commented, or file is existing, automatically save all figures
%default: not commented (switched off)

error(nargchk(2,3,nargin))
fprintf('Saving figure %.0f to file %s ...\n',n,fn)
if nargin<1, n=[]; end, if isempty(n), n=1; end
if nargin<3, voffs=[]; end, if isempty(voffs), voffs=0; end
figure(n)
p=get(n,'position'); %set(n,'position',[p(1:2),0.5*p(3:4)])
pp=get(n,'paperposition'); %set(n,'paperposition',[pp(1:2),0.5*pp(3:4)])
set(n,'position',[421   389   0.5*[600   329]]);
if ~isequal(voffs,0)&0
  hc=[findall(n,'type','axes');findall(n,'type','text')];
  for ii=1:length(hc)
    if strcmp(get(hc(ii),'type'),'axes')
      pa=get(hc(ii),'position');
      set(hc(ii),'position',[pa(1),pa(2)+voffs,pa(3:4)])
    elseif strcmp(get(hc(ii),'type'),'text')
      if any(findstr(get(hc(ii),'string'),'Frequency '))
        pa=get(hc(ii),'position');
        set(hc(ii),'position',[pa(1),pa(2)+voffs,pa(3)])
      end
    end
  end
end
set(n,'paperposition',[0.6345    6.3452   0.5*[20.3046   15.2284]]);
print(['-f',num2str(n)],'-deps',[probfigsdir,fn]);
set(n,'position',p,'paperposition',pp);
