function testexercises(exercise,exercise2)
%TESTEXERCISES  Test all existing exercise solving M-files
%   testexercises exercise_4_4  execute one exercise file
%   testexercises exercise_4_4:  continue from here

global saveprobfigson %allow saving of exercise figures
saveprobfigson=0; %do not save files

%if ~qunique, error('Name collision, see info in command window'), end
diary off, delete testexercises.diary
diary testexercises.diary
cont=0; %1 for contnuing from given exercise

ap=which('testexercises.m');
if isempty(ap), error('files not found'), end
if nargin<1, exercise=''; end
if nargin<2, exercise2=''; end
ind=findstr(':',exercise);
if ~isempty(ind)&(length(exercise)>ind+1)
  exercise2=exercise(ind+1:end); exercise(ind:end)=''; 
end
%if isnumeric(exercise), exercise=num2str(exercise); end
if isstr(exercise)&~isempty(exercise)
  ind=findstr(exercise,'.');
  for indi=ind, exercise(indi)='_'; end
  if strcmp(exercise(end),':'), exercise(end)=''; cont=1; end
  if ~any(findstr(exercise,'exercise'))&~any(findstr(exercise,'example'))
    exercise=['exercise_',exercise];
  end
end
if isstr(exercise2)&~isempty(exercise2)
  ind=findstr(exercise2,'.'); 
  for indi=ind, exercise2(indi)='_'; end
  cont=1;
  if ~any(findstr(exercise2,'exercise'))&~any(findstr(exercise2,'example'))
    exercise2=['exercise_',exercise2];
  end
end
if ~isempty(exercise)&~cont
  diritems=dir([ap(1:end-15),exercise,'.m']);
  disp(['Testing exercise-solving M-file ',exercise,' ...'])
else
  diritems=[];
  for ie=1:21
    for ie2=1:9
      diritems=[diritems;dir([ap(1:end-15),...
        'exercise_',num2str(ie),'_',num2str(ie2),'.m'])];
    end
    diritems=[diritems;dir([ap(1:end-15),'exercise_',num2str(ie),'_??*.m'])];
  end
  for ie='a':'z'
    diritems=[diritems;dir([ap(1:end-15),'exercise_',setstr(ie),'*.m'])];
  end
  diritems=[diritems;dir([ap(1:end-15),'example_*_*.m'])];
  diriadd.name='exercise_15_18 PQN';
  diriadd.date='07-aug.-2008 09:19:21';
  diriadd.bytes=5034;
  diriadd.isdir=0;
  diriadd.datenum=7.3363e+005;
  diritems=[diriadd;diritems];
  diriadd.name='exercise_15_6 PQN';
  diritems=[diriadd;diritems];
  save diritems
  if cont
    if ~isempty(exercise)
      try
        while ~strcmp(diritems(1).name,[exercise,'.m']), diritems(1)=[]; end
      catch
        load diritems, diritems.name
        error('Starting exercise not found')
      end
    end
    if ~isempty(exercise2)
      try
        while ~strcmp(diritems(end).name,[exercise2,'.m']), diritems(end)=[]; end
      catch
        load diritems, diritems.name
        error('Ending exercise not found')
      end
    end
  end
  save diritems
  disp('Testing exercise-solving M-files...')
end
c0=clock;
try
  pause off
  for dirii=1:length(diritems)
    global N_for_test_only
    N_for_test_only=120; %make tests shorter
    disp('===========================')
    fprintf(['Evaluating ',diritems(dirii).name(1:end),': '])
    evalexercise(diritems(dirii).name(1:end));
  end 
  disp(' ')
  if isempty(exercise)
    disp('All exercise-solving files have been executed OK.')
  elseif cont
    disp(['Exercise-solving files starting from ',exercise,'.m have been executed OK.'])
  else
    disp(['Exercise-solving file ',exercise,'.m has been executed OK.'])
  end
  etp=etime(clock, c0);
  fprintf('Elapsed time: %.0f min %.0f s\n',fix(etp/60),rem(etp,60))
catch
  disp(' ')
  disp(lasterr)
  disp('M-file:')
  diritems(min(dirii,length(diritems)))
  disp(['An error occurred while executing file  ',diritems(min(dirii,length(diritems))).name(1:end)])
  disp(['This is Matlab version ',version])
  diary off
  error('Tests of exercises halted')
end
diary off
if exist('testroundoff.m')&isempty(exercise)
  dbs=dbstack; tfound=0;
  for dirii=1:length(dbs)
    if strcmp(dbs(dirii).file,'testroundoff.m')
      tfound=1; %call from that function
    end
  end
  if ~tfound, testroundoff, end %test quantization toolbox
end
fprintf('Elapsed time for exercises: %.0f min %.0f s\n',fix(etp/60),rem(etp,60))
clear global saveprobfigson %allow to save figures (if file exists in file saveprobfigs.m)
N_for_test_only=[];
pause on
clear

function evalexercise(exercise)
close all, drawnow
if strcmp(exercise([end-1,end]),'.m'), exercise=exercise(1:end-2); end 
eval(exercise)
