%CERI

echo on
fv=[0.1:0.1:5]'/2/pi; F=length(fv);
%num=real(poly([-.5,-.25+j*1,-.25-j*1]));
%denom=real(poly([-.2+j*2,-.2-j*2,-.3+0.2*j,-.3-0.2*j]));
num=1;
denom=real(poly(-1));
nord=length(num)-1; dord=length(denom)-1;
delay=1;
X=msinclip(fv,ones(F,1),[],'nograph',0);
vdat=1e-7*[1,1];
randn('seed',0) %reproducible run
[Xm,Ym]=simfou(exppar('s',num,denom,delay),fv,X,vdat);
%
%nord=nord+2; dord=dord+3; %Underdetermined model
%
%Generate a solution vector
pv=elis([fv,Xm,Ym],vdat,['s',nord,dord],[nord+dord+3,delay],[],-100);
pv=elis([fv,Xm,Ym],vdat,['s',nord,dord],[],['mf'],-100,pv);
save ceri.mat
%
%Test of scaling follows...
i=0; NaNv=NaN; dsc=1;
%dsc=10; %delayscale
for sc=[1,100]
  i=i+1;
  rfile=sprintf('sctest%.0f.rep',i);
  [pvi,fit,Cp,CR]=elis([fv,Xm/sc,Ym/sc],vdat/sc^2,...
           ['s'+0,nord,dord],'v',['s','f',0],[],pv,rfile);
  fprintf(rfile,'Scale factor = %.4g\n',sc)
  eval(sprintf('Cp%.0f=Cp;',i))
  eval(sprintf('CR%.0f=CR;',i))
end
%
echo off
if isunix
  %!diff sctest1.rep sctest2.rep > tmp
  !grep '1 s' sctest1.rep > tmp
  !grep '1 s' sctest2.rep >> tmp
  type tmp
elseif exist('diffreps.m')
  diffreps
else
  type sctest1.rep
  type sctest2.rep
end
%[diag(Cp1),diag(Cp2),diag(Cp1)-diag(Cp2)]
%[diag(CR1),diag(CR2),diag(CR1)-diag(CR2)]
do=nord+dord+3;
fprintf('CR: %.3e, %.3e, diff: %.3e\n',...
     CR1(do,do),CR2(do,do),CR1(do,do)-CR2(do,do))
fprintf('Cp: %.3e, %.3e, diff: %.3e\n',...
     Cp1(do,do),Cp2(do,do),Cp1(do,do)-Cp2(do,do))
%
%End of ceri
