function s = dec2bin(d,n)
%DEC2BIN Convert integer to a binary string.
%       DEC2BIN(D) returns the binary representation of D as a string.
%       D must be a non-negative integer.  For example, DEC2BIN(23)
%       returns '10111'.
%
%       DEC2BIN(D,N) produces a binary representation with at least
%       N bits.

%	Written by: I. Kollar
%	Last modified: 18-Mar-1995

if nargin<2, n=1; end
md=max(d)+realmin; nd=floor(log2(md))+1;
if nd>45, if md<pow2(nd-1), nd=nd-1; end, end %log is not sensitive enough
n=max(nd,n);
no=round(n/3+.4);
tabl=['xxx';'xxx';'000';'001';'010';'011';'100';'101';'110';'111']';
if n<=30
  s=reshape(tabl(:,sprintf(['%.',int2str(no),'o'],d)-45),3*no,length(d))';
else %sprintf won't do it right for 2^32<=d
  drem=rem(d,pow2(30));
  d=(d-drem)/pow2(30);
  s=[reshape(tabl(:,sprintf(['%.',int2str(no-10),'o'],d)-45),3*no-30,...
	length(d))',reshape(tabl(:,sprintf(['%.10o'],drem)-45),30,length(d))'];
end
s(:,1:2-rem(n-1,3))='';
%end of dec2bin
