clear all;
% for argument frequency of function fiddata
frequencies = [7.85; 6.28; 5.24; 4.49; 3.93; 
               3.49; 3.14; 2.86; 2.42; 2.09; 
               1.75; 1.31; 0.87; 0.52; 0.16];            

%*************************
%if these are really in rad/min, scale them to get Hz:
frequencies = frequencies*2*pi/60;
%*************************

% for argument y of function fiddata
y_amp = [0.029;0.073;0.149;0.219;0.298;
         0.365;0.436;0.504;0.591;0.669;
         0.739;0.840;0.920;0.970;0.999];

y_degree = [1469.2; 1141.2; 1074.4; 938.6; 837.0; 
             806.0;  689.4;  436.9; 375.2; 363.6; 
             345.0;  279.0;  198.0; 128.7; 44.5];                    
y_phase = y_degree/360*2*pi;
          
%***********************
%y = y_amp.*exp(j*2*pi*y_phase);
%                ******
y = y_amp.*exp(j*y_phase);
%***********************

% for argument u of function fiddata
u_amp = ones(15,1);
u_phase = zeros(15,1);

%***********************
%u =  u_amp.*exp(j*2*pi*u_phase);
%                 ******
u =  u_amp.*exp(j*u_phase);
%***********************

% import data for fdtool
fiddata_diffusion = fiddata(y, u,frequencies);

% plot of frequency vs. original data of phase of ouput y
figure(1); 
subplot(2,1,1);
plot(frequencies, 20*log10(y_amp), 'b*');
title('Magnitude of output (Original data)');
ylabel('dB');

subplot(2,1,2);
plot(frequencies, y_degree, 'b*');
title('phase of output (Original data)');
xlabel('Frequency (rad/min)');
ylabel('degree');

% plot of frequency vs. fiddata of phase of ouput y
figure(2); plot(fiddata_diffusion, '=');

% elis call
figure(3);
%*************************
elis(fiddata_diffusion, 's', 8, 8);
%*************************
