rand('seed',0); A=rand(10,3); B=rand(3,3);
B=10^-14*B;

% Test GSVD

[U,V,X,C,S] = gsvd(A,B);
sigma = gsvd(A,B);

warning off
sig = sqrt(diag(C'*C)./diag(S'*S));
warning on
sig = sig((sig > 100*eps) & (sig < 1/(100*eps)));
sigma = sigma((sigma > 100*eps) & (sigma < 1/(100*eps)));
e = (sig - sigma)./sigma;

% Residuals

normab = norm([A; B],1) + realmin;
res = [norm(e)
       norm(U*C*X'-A,1)/normab
       norm(V*S*X'-B,1)/normab
       norm(C'*C+S'*S-eye(size(C'*C)),1)
       norm(U'*U-eye(size(U,2)),1)
       norm(V'*V-eye(size(V,2)),1)];
res = res/eps;
if any(res > 1000)
   res
   warning('Residuals too large')
end

% Values are sorted

sortok = norm((sigma-sort(sigma))./sigma,1) <= 100*eps;

% [A;B] is rank deficient if and only if X is rank deficient.

rankab = rank([A;B]);
rankx = rank(X);
rankok = isequal(rankab==min(size([A;B])),rankx==min(size(X)));
if ~rankok
   rankab
   rankx
end

% C is diagonal

[i,j] = find(C);
k = j-i;
cok = all(k >= 0) & norm(diff(k))==0;
if ~cok
   C
end

% S is diagonal

[i,j] = find(S);
k = j-i;
sok = all(k >= 0) & norm(diff(k))==0;
if ~sok
   S
end

% Summary

ok = [all(res <= 1000); sortok; rankok;  cok; sok];
if ~all(ok)
   disp(['not ok: ' int2str([size(A) size(B) ok'])])
else
   disp(['ok: ' int2str([size(A) size(B)])])
end
ok = all(ok);

