function neglv=neglval();
%NEGLVAL Smallest positive number on this computer.
%	For use with Matlab 3.5 or earlier versions. Substituted by realmin
%	in Matlab 4.0.

%	Copyright (c) I. Kollar, 1990-93
%	Copyright (c) Vrije Universiteit Brussel, Dienst ELEC, 1990-93
%	All rights reserved.
%	Last modified: 27-Mar-1993
%
if exist('size')==5 %Matlab 4.0
  neglv=realmin;
  disp('WARNING! Usage of neglval is obsolete, please use realmin instead.')
else
  if strcmp(computer,setstr('pc'-32))|...
	strcmp(computer,setstr('pcat'-32))|...
	strcmp(computer,setstr('at'-32)) %PC-Matlab or AT-Matlab
    neglv=2.225073858507203e-308; iter=0; %do not iterate
  elseif strcmp(computer,[setstr('pc'-32),'386'])|...
	strcmp(computer,'386')|...
	strcmp(computer,setstr('macii'-32))|...
	strcmp(computer,[setstr('mac'-32),'2'])
    neglv=1e-323; iter=1;
  elseif strcmp(computer,setstr('mac'-32)) %Macintosh Edu-Matlab
    neglv=1e-307; iter=1;
  else
    neglv=1; iter=1;
  end
  if iter==1
    while (neglv/2>0)&(neglv/2<neglv), neglv=neglv/2; end
    dev=.5;
    while 1+dev>1
      if neglv/(1+dev)>0, neglv=neglv/(1+dev); end
      dev=dev/1.9;
    end
  end
end
%%%%%%%%%%%%%%%%%%%%%%%% end of neglval %%%%%%%%%%%%%%%%%%%%%%%%