disp('Solving problem 11.3 ...')

close all
plotno=0;
mtypes='nns'; ordn=0;
for ord=[1,2,2]
  ordn=ordn+1; mtype=mtypes(ordn);
  for ptype='ma'
    plotno=plotno+1;
    figure(plotno)
    sigm=0.5; dist='g'; 
    if ordn<3, mumax=1; else mumax=5; end 
    amax=.8;
    muv=[0:0.01:mumax];
    if strcmp(ptype,'m'), sigmv=sigm; 
    else sigmv=0.01:0.01:amax;
    end
    xc=floor(-4*max(sigmv)+min(muv)):ceil(4*max(sigmv)+max(muv));
    E=zeros(2,length(sigmv)); is=0;
    for sigm=sigmv
      Emu=zeros(size(muv));
      is=is+1; F=0;
      for xci=1:length(xc)
        [F1,xF1,x2F1]=cdf_gauss(xc(xci)-0.5,sigm,muv,xc(xci));
        [F2,xF2,x2F2]=cdf_gauss(xc(xci)+0.5,sigm,muv,xc(xci));
        if strcmp(mtype,'n')&isequal(ord,1)
          Emu=Emu-(xF2-xF1);
        elseif strcmp(mtype,'n')&isequal(ord,2)
          Emu=Emu+(x2F2-x2F1)-1/12*(F2-F1);
        elseif strcmp(mtype,'s')&isequal(ord,2)
          Emu=Emu+xc(xci)^2*(F2-F1)-(sigm^2+muv.^2+1/12).*(F2-F1);
        else
          error('Type not known')
        end
      end
      if strcmp(ptype,'a')
        E(1,is)=max(Emu);
        E(2,is)=min(Emu);
      end
      end %for sigm
    if strcmp(ptype,'m')
      plot(muv,Emu)
    else %amplitude
      semilogy(sigmv,E(1,:))
    end
    if strcmp(mtype,'n')
      if ord==1, title(['E\{\nu\}'])
      else title(['Deviation of E\{\nu^',num2str(ord),'\} from q^2/12'])
      end
    elseif strcmp(mtype,'s')
      title(['Deviation of E\{(x'')^',num2str(ord),'\} from \sigma^2+\mu^2+q^2/12'])
    end
    if strcmp(ptype,'m'), xlabel('\mu/q')
    elseif strcmp(ptype,'a'), xlabel('\sigma/q')
    end
    saveprobfig(plotno,['figp_11_4',setstr('a'-1+plotno),'.eps'])
  end %for mtype
end %for ord
