disp('Solving problem 15.10 ...')

close all, qclear

p=24;
Q=qmake('Q','p',p); eps24=2^(-p+1);
N=256;
%N=16;
global N_for_test_only
if ~isempty(N_for_test_only), N=8; end %make tests shorter
x=(rand(N,1)-0.5)*2; xq=qdata(x,Q);
xqd=double(xq);

Delta_Xm=1/sqrt(3)*sqrt(N)*sqrt(0.42)*2^(-p)*sqrt(log2(N));
Delta_Xm_per_eps=Delta_Xm/eps24;
fprintf('Delta_Xm (th) = %.2g eps\n',Delta_Xm_per_eps)

for ii=1:5
  c0=clock;
  if ii==1, Xq=roundfft(xq);
  elseif ii==2, X=fft(x); %double
  elseif ii==3, Xqd=fft(xqd);
  elseif ii==4, XqW0=roundfft(xq,struct('Qcos','double'));
  end
  et=etime(clock,c0); 
  if any(ii==[1,4])
    fprintf('Cycle: %.0f, elapsed time: %.0f min %.0f s\n',ii,fix(et/60),rem(et,60))
  end
  err=[];
  if ii==2, err=(Xq-X)/eps24;
  elseif ii==3, err=(Xq-Xqd)/eps24;
  elseif ii==4, err=(XqW0-X)/eps24;
  elseif ii==5, err=(XqW0-Xqd)/eps24;
  end
  varX=(err'*err)/N;
  stdX=sqrt(double(varX)); if imag(stdX), error('Imaginary stdX'), end
  if ii==2, fprintf('RMS_24+input = %.3e * eps\n',stdX)
  elseif ii==3, fprintf('RMS_24_i0 = %.3e * eps\n',stdX)
  elseif ii==4,  fprintf('RMS_24_W0 = %.3e * eps\n',stdX)
  elseif ii==5,  fprintf('RMS_24_W0_i0 = %.3e * eps\n',stdX)
  end
end