disp('Solving problem 15.11 ...')

close all, qclear

Q=qmake('Q','p',60);
N=256;
%N=16;
global N_for_test_only
if ~isempty(N_for_test_only), N=8; end %make tests shorter
x=(rand(N,1)-0.5)*2; xq=qdata(x,Q);

p=53;
Delta_Xm=1/sqrt(3)*sqrt(N)*sqrt(0.42)*2^(-p)*sqrt(log2(N));
Delta_Xm_per_eps=Delta_Xm/eps;
fprintf('Delta_Xm (th) = %.2g eps\n',Delta_Xm_per_eps)

xq60=rand(xq,[-1,1]);
xd53=double(xq60);
xq53=qdata(xd53,'double'); %53-bit, on 60

for ii=1:5
  c0=clock;
  if ii==1, Xq60=roundfft(xq60); %60-bit reference
  elseif ii==2, Xd53=fft(xd53); %double
  elseif ii==3, Xq53=roundfft(xq53); %quantized input
  elseif ii==5, Xq53W0=roundfft(xq53,struct('Qcos',Q)); %quantized input, exact Wk
  end
  et=etime(clock,c0); 
  if any(ii==[1,3,5])
    fprintf('Cycle: %.0f, elapsed time: %.0f min %.0f s\n',ii,fix(et/60),rem(et,60))
  end
  err=[];
  if ii==2, err=(Xq60-Xd53)/eps;
  elseif ii==3, err=(Xq53-Xd53)/eps;
  elseif ii==4, err=(Xq60-Xq53)/eps;
  elseif ii==5, err=(Xq60-Xq53W0)/eps;
  end
  varX=(err'*err)/N;
  stdX=sqrt(double(varX)); if imag(stdX), error('Imaginary stdX'), end
  if ii==2, fprintf('RMS_Matlab+input = %.3e * eps\n',stdX)
  elseif ii==3, fprintf('RMS_Matlab = %.3e * eps\n',stdX)
  elseif ii==4,  fprintf('RMS_QDSP_53 = %.3e * eps\n',stdX)
  elseif ii==5,  fprintf('RMS_QDSP_53_W0 = %.3e * eps\n',stdX)
  end
  c0=clock;
end