disp('Solving problem 15.9 ...')

close all

B=16;
B=B+4;
Q=qstruct('Q','B',B,'fb',B-1);
Qlong=qstruct('Q','B',54,'fb',53);
N=256;
%N=8;
%Nv=[]; NSRv=[]; NSRth=[]; for N=2.^[4:12] %switch on to plot as function of N
Nv=[]; NSRv=[]; NSRth=[]; for N=2.^[3,4:2:16] %switch on to plot as function of N
global N_for_test_only
if ~isempty(N_for_test_only), N=8; end %make tests shorter
x=(rand(N,1)-0.5)*2; RMSx=1/sqrt(3); %RMSx=0.3;
x=rand(N,1); RMSx=1/sqrt(3); %RMSx=0.3;
%A=0.495; x=A*cos(2*pi*5.3*[1:N]/N)'; RMSx=A/sqrt(2);
x=x(:); xq=roundq(x,Q);
C=0.4; Cs=C*2^(3/2)*2/RMSx;

RMSX=sqrt(N)*RMSx;
RMS_Xmth=RMSX * sqrt(N)*2^(-B)*Cs;
%RMS_Xmth=RMS_Xmth/(sqrt(N)/sqrt(3));
fprintf('N = %.0f, variance of Xm (th) = %.1e\n',N,RMS_Xmth)

if exist('Nv'), iv=[1,3]; else iv=[1:5]; end
for ii=iv
  c0=clock;
  if ii==1, X=fft(x); Xq=fft(xq); %double
  elseif ii==2, Xqfft_bf=roundfft(xq,Q,struct('exponent','block-float','Qinput',Qlong)); 
    Xqfft=Xqfft_bf.data*2^Xqfft_bf.bfe;
  elseif ii==3, Xqq_bf=roundfft(xq,Q,struct('exponent','block-float')); 
    Xqq=Xqq_bf.data*2^Xqq_bf.bfe;
  elseif ii==4, XqqW0_bf=roundfft(xq,Q,struct('exponent','block-float','Qcos',Qlong));
    XqqW0=XqqW0_bf.data*2^XqqW0_bf.bfe;
  end
  et=etime(clock,c0); 
  err=[];
  if ii==2, err=(Xqfft-Xq);
  elseif ii==3, err=(Xqq-X);
  elseif ii==4, err=(XqqW0-X);
  elseif ii==5, err=(XqqW0-Xq);
  end
  varX=(err'*err)/N;
  stdX=sqrt(double(varX)); if imag(stdX), error('Imaginary stdX'), end
  if ii==2, fprintf('ii = %.0f, RMS_i0 = %.1e\n',ii,stdX)
  elseif ii==3, fprintf('ii = %.0f, RMS = %.1e\n',ii,stdX), RMS=stdX;
  elseif ii==4,  fprintf('ii = %.0f, RMS_W0 = %.1e\n',ii,stdX)
  elseif ii==5,  fprintf('ii = %.0f, RMS_W0_i0 = %.1e\n',ii,stdX), RMS_W0_i0=stdX;
  end
  if any(ii==[2,3,4])
    fprintf('Cycle: %.0f, elapsed time: %.0f min %.0f s\n',ii,fix(et/60),rem(et,60))
  end
  if exist('Nv')&(ii==3)
    Nv=[Nv,N]; NSRv=[NSRv,20*log10(stdX)];
    NSRth=[NSRth,20*log10(RMS_Xmth)];
    plot(log2(Nv),NSRv,'x',log2(Nv),NSRth), grid
    hold on, plot(log2(Nv),NSRth-20*log10(5),':'), hold off
    %set(gca,'xlim',[Nv(1)/1.2,1.2*N])
    set(gca,'xlim',[log2(Nv(1))-1,log2(N)+1]), xlabel('M = log2(N)')
    ylabel('RMS{X}')
    drawnow, shg
  end, %clear Nv
end %for N
end