disp('Solving problem 18.1 ...')

close all
rand('seed',0), randn('seed',0) %initialize random generators 
N=1e3; 
sigma=0.01;
x=sigma*randn(N,1);
y=zeros(size(x));
yq=zeros(size(x));
yPQN=zeros(size(x));
Q=qstruct(struct('B',8,'fb',7,'coding','t')); %define quantizer
a=0.625; if ~isequal(a,qfix(a,Q)); error('a is not properly quantized'), end
qfix(a,Q,'list');
q=lsb(a,Q);
xq=qfix(x,Q); %execute input quantization
for n=2:N
  y(n)=xq(n)+a*y(n-1);
  yq(n)=qfix(xq(n)+qfix(a*yq(n-1),Q),Q);
  yPQN(n)=xq(n)+a*yPQN(n-1)+q*(rand(1,1)-0.5)+q*(rand(1,1)-0.5);
end
figure(1)
plot(1:N,y,'-b','markersize',0.5)
hold on
plot(1:N,yq,'-r','markersize',0.5)
plot(1:N,yPQN,'-g','markersize',0.5)
hold off
title('Reference answer (blue), quantized (red) and with PQN (green)')
zoom on, shg
figure(2)
plot(1:N,yq-y,'-r','markersize',0.5)
hold on
plot(1:N,yPQN-y,'-g','markersize',0.5)
title('Difference from reference answer, quantized (red) and with PQN (green)')
hold off
var_nu=std(yq(100:N)-y(100:N))^2;
var_PQN=std(yPQN(100:N)-y(100:N))^2;
var_PQN_theor=q^2/6/(1-a^2);
fprintf('q = %.3e, q^2/12 = %.3e, var_nu = %.3e,\n  var_PQN = %.3e, var_PQN_theor = %.3e, N = %.0f\n',...
  q,q^2/12,var_nu,var_PQN,var_PQN_theor,N)%