disp('Solving problem 16.7 ...')

B=32; p=24; a=0.8;
global N_for_test_only
if isempty(N_for_test_only), Nx=2e3; else Nx=1.5*N_for_test_only; end
Ns=100; x=sin(1.01*2*pi*[1:Nx]'/Ns);
for rtype={'fix','float'}
%for rtype={'float','fix'}
  y1=zeros(Nx,1); yq1=y1;
  y2=zeros(Nx,1); yq2=y2;
  rtype=rtype{1};
  if strcmp(rtype,'fix')
    disp('Fixed-point roundoff, B=32')
    Q=qstruct(struct('type','fixed-point','B',B,'fract',B-1,'ovf','c')); q=lsb(-1,Q);  
    x=(1-q)*x;
    RMSth=q^2/6/(1-a^2);
  elseif strcmp(rtype,'float')
    disp('Floating-point roundoff, p=24')
    Q=qstruct(struct('type','floating-point','p',p,'Emin',-126,'Emax',127));  
    RMSth=0.6^2*(0.180*2^(-2*p)*1/2*((1+0.8^2*5^2+5^2)*1/(1-a^2)+0.8^2*5^4+5^4)*1/(1-a^2));
  else
    error('Unknown rtype')
  end
  qstructget(Q)
  for n=2:Nx
    if strcmp(rtype,'fix')
      y1(n)=0.2*x(n)+0.8*y1(n-1);
      y2(n)=0.2*y1(n)+0.8*y2(n-1);
      yq1(n)=roundq(roundq(0.2*roundq(x(n),Q),Q)+roundq(0.8*yq1(n-1),Q),Q);
      yq2(n)=roundq(roundq(0.2*yq1(n),Q)+roundq(0.8*yq2(n-1),Q),Q);
    elseif strcmp(rtype,'float')
      y1(n)=x(n)+0.8*y1(n-1);
      y2(n)=y1(n)+0.8*y2(n-1);
      y2(n-1)=0.6*y2(n-1);
      yq1(n)=roundq(roundq(x(n),Q)+roundq(0.8*yq1(n-1),Q),Q);
      yq2(n)=roundq(yq1(n)+roundq(0.8*yq2(n-1),Q),Q);
      yq2(n-1)=roundq(0.6*yq2(n-1),Q);
    end
    if rem(n,50)==2, fprintf('.'), end %sign of life
    if rem(n,50*50)==1, disp(' '), end
  end
  plot((yq2(150:end)-y2(150:end))), shg
  RMSth, RMSnu2=mean((yq2(150:end)-y2(150:end)).^2)
end
