function problem
disp('Solving problem 19.8 ...')

%clear
fs=10; %Hz
T=1/fs;
C1=0.49; C2=1.23;
Hplant_s=tf(1,[1,1,0]);
Hplant_z=c2d(Hplant_s,T,'zoh'); set(Hplant_z,'variable','z^-1');
d1=Hplant_z.den{1}(1);
Hplant_z.num{1}=Hplant_z.num{1}/d1;
Hplant_z.den{1}=Hplant_z.den{1}/d1
global N_for_test_only
if ~exist('N_for_test_only')|isempty(N_for_test_only), N=1000; else N=N_for_test_only; end
Hcomp=tf(2.04*0.2*[1,1/2]*0.813,[1,-1/2],T); %,'variable','z^-1'
B1=10; qADC=10/2^B1;
B2=8; qDAC=10/2^B2; plantinprev=0;
xDAC=[]; yDAC=[];

for ii='ab'-'a'+1 %bd
  if ii==1, dcv=1.9; %(a) illustrate that there is limit cycle
  %elseif ii==2, dcv=[1.6:0.005:1.8,1.9,NaN];
  %else dcv=1.66;
  end
  errmax=0; dcerrmax=1.8; 
  for dc=dcv
    if isnan(dc), dc=dcerrmax; end
    if ii==1
      A=0.06;
      %A=0.034;
      x=A*sin(2*pi*[0:N-1]/100); 
    end
    y=zeros(size(x));
    Fc=0; Fpl=[0,0]; plantinprev=0; histoutprev=0;
    if ii==1, AmaxADC=0; AmaxDAC=0; end 
    for n=1:N-1
      ADCin=(x(n)-y(n))*C1;
      %if ii==5, ADCin=ADCin+qADC*(rand(1,1)-.5); end %dither at ADC
      if ii==1, ADCout=qADC*round(ADCin/qADC); else ADCout=ADCin; end
      if (ii==1)&(n>N-100)
        if (abs(ADCin)>AmaxADC), AmaxADC=abs(ADCin); end
      end
      [DACin,Fc]=filter(Hcomp.num{1},Hcomp.den{1},ADCout,Fc);
      %if ii==5, DACin=DACin+qDAC*(rand(1,1)-.5); end %dither at DAC
      if ii==1, DACout=qDAC*round(DACin/qDAC); else DACout=DACin; end
      if (ii==1)&(n>N-100)
        if (abs(DACin)>AmaxDAC), AmaxDAC=abs(DACin); end 
        xDAC=[xDAC,DACin];
        yDAC=[yDAC,DACout];
      end
      plantin=C2*DACout;
      if ii==6, dhist=0.03; else dhist=0; end
      plantin=plantin+dhist*randn(1,1); %dither at hysteresis
      if any(ii==[1,2])&0 %hysteresis
        dh=0.05;
        if (abs(plantin-plantinprev)>dh)
          signpl=sign(plantin-plantinprev);
          plantin=plantin-dh*signpl; if abs(plantin)>2, plantin=2*sign(plantin); end
          plantinprev=plantin; histoutprev=plantin;
        else
          plantin=histoutprev;
        end
      end
      [ynp1,Fpl]=filter(Hplant_z.num{1},Hplant_z.den{1},plantin,Fpl);
      y(n+1)=ynp1;
    end
  end %for dc
  if ii==1, yq=y; end
end %for ii
figure(1)
subplot(2,1,1), plot(x)
title(sprintf('Command input, A = %.3g',A))
set(gca,'ylim',0.1*[-1,1])
subplot(2,1,2), plot(yq)
title('System output')
set(gca,'ylim',0.1*[-1,1])
shg, drawnow

saveprobfig(1,['figp_19_8.eps'])

MSerr=mean((yq(N-[0:99])-y(N-[0:99])).^2)
AmaxADC, qADC, AmaxDAC, qDAC