disp('Solving problem 16.13 ...')

close all
Nx=1e6;
q=1;
format short e
for dtype='gs'
  if strcmp(dtype,'g')
    d=q*randn(Nx,1);
    dtxt='Gaussian dither with sigma=q, mu=0';
    Ed2=q^2;
  elseif strcmp(dtype,'s')
    d=15*q/2*sin(2*pi*(75+pi)*[1:Nx]'/Nx);
    dtxt='Sinusoidal dither, d=7.5q*sin()';
    Ed2=7.5^2/2;
  else
    error('Unknown dtype')
  end
  for xtype='csu'
    disp(dtxt), disp(' ')
    if strcmp(xtype,'c')
      x=0.3*q*ones(Nx,1); 
      disp('Constant input, x=0.3q')
    elseif strcmp(xtype,'s')
      x=0.3*q/2*sin(2*pi*[1:Nx]'/Nx)+0.1*q; 
      disp('Sinusoidal input, x=0.15q*sin()+0.1q')
    elseif strcmp(xtype,'u')
      x=q*(rand(Nx,1)-0.5)+0.2*q;
      disp('Uniform input in [-q/2,q/2]+0.2q')
    else
      error('Unknown xtype')
    end
    nu=q*round((x+d)/q)-x-d;
    for mtype={'dxi','nu','xnu'}
      mtype=mtype{1};
      if strcmp(mtype,'dxi'),
        devEdxi=[mean(d.*(d+nu))-Ed2,std(d.*(d+nu))/sqrt(Nx)]
        %Ed2
      elseif strcmp(mtype,'nu'),
        Enu=[mean(nu),std(nu)/sqrt(Nx)]
      elseif strcmp(mtype,'xnu'),
        Exnu=[mean(x.*nu),std(x.*nu)/sqrt(Nx)]
      else
        error('Unknown mtype')
      end
    end %for mtype
  end %for xtype
end %for dtype
format short
