disp('Solving problem 16.16 ...')

close all
Nx=1e6;
q1=1; q2=1;
format short e
d1=q1*((rand(Nx,1)-0.5)+(rand(Nx,1)-0.5));
d2=q2*((rand(Nx,1)-0.5)+(rand(Nx,1)-0.5));

for xtype='csu'
  if strcmp(xtype,'c')
    x=0.3*q1*ones(Nx,1); mux=0.3*q1;
    disp('Constant input, x=0.3q')
  elseif strcmp(xtype,'s')
    x=0.3*q1/2*sin(2*pi*[1:Nx]'/Nx)+0.1*q1; mux=0.1*q1;
    disp('Sinusoidal input, x=0.15q*sin()+0.1q')
  elseif strcmp(xtype,'u')
    x=q1*(rand(Nx,1)-0.5)+0.2*q1; mux=0.2*q1;
    disp('Uniform input in [-q/2,q/2]+0.2q')
  else
    error('Unknown xtype')
  end
  nu1=q1*round((x+d1)/q1)-x-d1;
  nu2=q2*round((x+d2)/q2)-x-d2; Enu2=mean(nu2);
  for mtype={'x1nu2','d1nu1','d2nu1'}
    mtype=mtype{1};
    if strcmp(mtype,'x1nu2'),
      covx1nu2=[mean(x.*nu2)-mux*Enu2,std(x.*nu2)/sqrt(Nx)]
    elseif strcmp(mtype,'d1nu1'),
      covd1nu1=[mean(d1.*nu1),std(d1.*nu1)/sqrt(Nx)]
    elseif strcmp(mtype,'d2nu1'),
      covd2nu1=[mean(d2.*nu1),std(d2.*nu1)/sqrt(Nx)]
    else
      error('Unknown mtype')
    end
  end %for mtype
end %for xtype
format short
