disp('Solving problem 21.5 ...')

close all
Q=qstruct(struct('type','fixed-point','B',10,'fb',5,'coding','two''s complement'));
qstructget(Q)
b=0.9; bq=qfix(b,Q);
B=1; A=[1 -b]; H=tf([B,0],A,1); set(H,'variable','z^-1');
B=1; Aq=[1 -bq]; Hq=tf([B,0],Aq,1); set(Hq,'variable','z^-1');
He=Hq-H;
figure(1)
H,bode(H), title('Perfect tf')
figure(2)
%p=get(2,'position'); set(2,'position',[p(1:2),0.5*p(3:4)])
%p=get(2,'paperposition'); set(2,'paperposition',[p(1:2),0.5*p(3:4)])
He,bode(He), title('Error tf')

N=60;
u=[1,zeros(1,N-1)];
y=filter(B,A,u);
ye=filter(He.num{1},He.den{1},u);
figure(3)
subplot(2,1,1)
stem([0:length(u)-1],y,'markersize',0), %set(gca,'ylim',[-1.2,1.2])
title('Impulse response of perfect filter')
subplot(2,1,2)
stem([0:N-1],ye,'markersize',0), %set(gca,'ylim',[-1.2,1.2])
title('Impulse response of error filter')

%(b) for N samples
ratio_SOS=sum(ye.*ye)/sum(y.*y)
%0.00215

%(c)
SOSH=sum(abs(freqz(H.num{1},H.den{1},1000)).^2);
SOSHe=sum(abs(freqz(He.num{1},He.den{1},1000)).^2);
ratio_SOS_th=SOSHe/SOSH
%0.00217

%(d)
u=randn(1000,1);
y=filter(B,A,u);
ye=filter(He.num{1},He.den{1},u);
ratio_MS_n=sum(ye(11:end).*ye(11:end))/sum(y(11:end).*y(11:end))
%0.00215
%The MS ratio is close to the ratio of the impulse responses.

saveprobfig(1,['figp_21_5a.eps']) 
saveprobfig(2,['figp_21_5b.eps'])
saveprobfig(3,['figp_21_5c.eps'])
