disp('Solving figp 4.1 ...')

close all

sigma=2;
xv=[-3*sigma:6/1000:3*sigma]; dx=mean(diff(xv));
fn=zeros(size(xv));
ind=find(abs(xv)<1/2); fn(ind)=ones(size(ind));
fx=1/sqrt(2*pi)/sigma*(exp(-1*xv.^2/2/2^sigma));

figure(1)
plot(xv,fn,xv,fx);
set(gca,'xlim',[-6.5,6.5],'ylim',[0,1.1])
saveprobfig(1,'figp_4_1a.eps')

figure(2);
c=conv(fx,fn)/length(ind);
plot([-(length(c)-1)/2:(length(c)-1)/2]*dx,c);
set(gca,'xlim',[-6.5,6.5],'ylim',[0,1.1])
title('Result of convolution');
saveprobfig(2,'figp_4_1b.eps')
