disp('Solving problem 4.11 ...')

q=1; A=2*q; 
if ~exist('alpha','var')
  alpha=1; %House
  %alpha=10^30; %triangular
  alpha=0; %uniform
end
B=1/(2*A+alpha*A);
fprintf('\n"House" PDF, alpha=%.2g\n',alpha)
figure(1)
plot([-3,-2,-2,0,2,2,3],2/(2+alpha)*[0,0,1,1+alpha,1,0,0],'linewidth',1.7)
set(gca,'ylim',[0,2/(2+alpha)*(1+alpha)])
hold on
for ii=-2.5:0.5:2.5, plot([ii,ii],get(gca,'ylim'),':'), end
for ii=-2.5:1:2.5, plot([ii,ii],get(gca,'ylim'),'-','linewidth',1), end
for ii=0:0.5/3:2/(2+alpha)*(1+alpha)
plot(get(gca,'xlim'),[ii,ii],':')
set(gca,'ytick',2/(2+alpha)*[0,1,1+alpha+eps])
end
hold off
shg
if alpha==1, saveprobfig(1,'figp_4_11a.eps'), end

format short e
%R2=2*A*B*1/6*q^2+alpha*A*B*1/12*q^2-q^2/12
R2=2*A*B*q^2/12;
S2=q^2/12;
R2pS2=R2/S2;
%
R4num1=(9/32-3/64-1/5)*3840;
R4num2=(3/32-3/128-2/80-1/24)*3840;
R4=2*A*B*R4num1*A^4/3840 + alpha*A*B*R4num2*A^4/3840 + 7/240*q^4;
S4=1/2*q^2*(2*A*B*3/2*q^2+alpha*A*B*3/4*q^2)-7/240*q^4;
R4pS4=R4/S4;
%
%disp('Monte Carlo')
Nx=1.5e6; Nx1=round(2*A*B*Nx); Nx2=round(alpha*A*B*Nx); q=1;
x=[A*(2*(rand(Nx1,1)-0.5));A/2*(2*(rand(Nx2,1)-0.5))+A/2*(2*(rand(Nx2,1)-0.5))];
figure(2)
hist(x,50)
if alpha==1, saveprobfig(2,'figp_4_11b.eps'), end
xq=q*round(x/q);
R2_MC=(mean(xq.^2)-q^2/12)-mean(x.^2);
R4_MC=mean(xq.^4)-(q^2/2*mean(xq.^2)-7/240*q^4)-mean(x.^4);

ds=dbstack;
if (length(ds)<2)|~strcmp(ds(2).name,'problem_4_24')
  R2_S2_R2pS2_R2MC=[R2,S2,R2/S2,R2_MC]
  R4_S4_R4pS4_R4MC=[R4,S4,R4/S4,R4_MC]
end

format short