disp('Solving figp 4.2 ...')

close all
sigma=0.8; du=24/1000; umax=6*pi;
uv=[-umax:du:umax];
q=1;

phin=sinc(1/pi*q*uv/2);
phix=exp(-(sigma*uv).^2/2);

Pszi=2*pi;
szorzat=phix.*phin;

figure(1)
plot(uv,phix);
title('\Phi_x(u)');
set(gca,'xtick',2*pi*[-2:2],'ylim',[0,1.1])
saveprobfig(1,'figp_4_2a.eps')

figure(2)
plot(uv,phin);
title('\Phi_n(u)');
set(gca,'xtick',2*pi*[-2:2],'ylim',[-0.3,1.1])
hold on, plot(get(gca,'xlim'),[0,0]), hold off
saveprobfig(2,'figp_4_2b.eps')

%figure(3)
%plot(uv,phix,uv,phin);
%title('\Phi_x(u) s \Phi_n(i)');
%saveprobfig(3,'figp_4_2c.eps')

figure(4)
plot(uv,szorzat);
title('\Phi_x(u)\Phi_n(u)');
set(gca,'xtick',2*pi*[-2:2],'ylim',[0,1.1])
saveprobfig(4,'figp_4_2d.eps')

%figure(5)
%plot(uv,phix,uv,phin,uv,szorzat);
%title('Minden');

figure(5)
for ii=[-3:3]
  ind=find(abs(uv+ii*2*pi)<umax-du);
  if ii~=-3, hold on, end
  plot(uv(round(ind+ii*2*pi/du)),szorzat(ind))
  hold off
end
set(gca,'xtick',2*pi*[-2:2],'ylim',[0,1.1])
title('\Phi_{x}(u-l\Psi)');
saveprobfig(5,'figp_4_2e.eps')

eltolt=szorzat;
for ii=[-3,-2,-1,1,2,3]
  ind=find(abs(uv+ii*2*pi)<umax-du);
  eltolt(ind)=eltolt(ind)+szorzat(round(ind+ii*2*pi/du));
end
figure(6)
plot(uv,eltolt);
set(gca,'xtick',2*pi*[-2:2],'ylim',[0,1.1])
title('\Phi_{x''}(u)');
saveprobfig(6,'figp_4_2f.eps')
