disp('Solving figp 4.3 ...')

close all
dx=12/1000; xv=-6:dx:6-dx;
sigma=1;
fx=1/sqrt(2*pi)/sigma*exp(-xv.^2/sigma^2/2);
q=2*sigma;
%q=sigma;

figure(1)
plot(xv,fx);
title('Input PDF');
saveprobfig(1,'figp_4_3a.eps')

%F(x)=erf(x/sqrt(2))/2+.5;
Fm5sigma=erf((-5)/sqrt(2))/2+.5;
Fm3sigma=erf((-3)/sqrt(2))/2+.5;
Fm1sigma=erf((-1)/sqrt(2))/2+.5;
F1sigma=erf((1)/sqrt(2))/2+.5;
F3sigma=erf((3)/sqrt(2))/2+.5;
F5sigma=erf((5)/sqrt(2))/2+.5;

sincm5=sinc((xv+6)/q)*Fm5sigma;
sincm3=sinc((xv+4)/q)*Fm3sigma;
sincm1=sinc((xv+2)/q)*Fm1sigma;
sincp1=sinc((xv-0)/q)*F1sigma;
sincp3=sinc((xv-2)/q)*F3sigma;
sincp5=sinc((xv-4)/q)*F5sigma;

figure(22)
plot(xv,sincm5,xv,sincm3,xv,sincm1,xv,sincp1,xv,sincp3,xv,sincp5);
title('sinc functions');
saveprobfig(22,'figp_4_3f.eps')

Fkozel=sincm3+sincm1+sincp1+sincp3+sincp5;
for ii=7:2:50
  Fkozel=Fkozel+sinc((xv-(ii-1))/q);
end

figure(2)
plot(xv,Fkozel);
title('Interpolation of the CDF');
saveprobfig(2,'figp_4_3b.eps')

f=[diff(Fkozel)/dx,0];

figure(3)
plot(xv,f);
title('Derivative of the interpolated CDF');
saveprobfig(3,'figp_4_3c.eps')

figure(4)
plot(xv+q/2,f);
set(gca,'xlim',[-6+q/2,6+q/2]), shg
title('Derivative of the interpolated CDF, shifted right');
saveprobfig(4,'figp_4_3d.eps')

figure(5)
plot(xv+q/2,f,xv,fx);
set(gca,'xlim',[-6+q/2,6+q/2]), shg
title('Interpolated and original PDF');
saveprobfig(5,'figp_4_3e.eps')
