disp('Solving figp 4.5 ...')

close all
dx=5/1000;
xv=-2:dx:2-dx;
A=1; q=1;
fx=zeros(size(xv));
ind=find(abs(xv)<0.8);
fx(ind)=ones(size(ind));

figure(1)
plot(xv,fx);
title('Original PDF');
set(gca,'ylim',[0,1.1])
saveprobfig(1,'figp_4_5a.eps')

Fx=cumsum(fx)*dx;
figure;
plot(xv,Fx);
title('Cumulative distribution function');
saveprobfig(2,'figp_4_5b.eps')

figure(3)
plot(xv,Fx,xv-q/2,Fx,'red',xv+q/2,Fx,'green');
title('Delayed and advanced CDF''s');
saveprobfig(3,'figp_4_5c.eps')

dN=round(q/dx);
fxn=Fx(1+dN:end)-Fx(1:end-dN);
figure(4)
plot(xv(1+dN/2:end-dN/2),fxn);
hold on
for x=[-1:1]*q
  [dummy,ind]=min(abs(xv-x));
  plot([x,x],[0,fxn(ind-dN/2)],'linewidth',1.5,'color','r')
end
hold off
title('f_{x+n}(x)');
saveprobfig(4,'figp_4_5d.eps')
