disp('Solving figp 4.9 ...')

close all
dx=5/1000;
xv=-5:dx:5-dx;
q=1;
A=3.7*q;

fx=zeros(size(xv));
ind=find(abs(xv)<(A));
fx(ind)=1/(A)*(1-abs(xv(ind))/(A));

figure(1)
plot(xv,fx);
title('Original PDF');
saveprobfig(1,'figp_4_9a.eps')

F=cumsum(fx)*dx;
for ii=-3:4
  [dummy,ind]=min(abs(xv-(ii)));
  Fii(ii+4)=F(ind+round(q/2/dx));
end

figure(2)
Fkozel=zeros(size(xv));
for ii=-3:4
  sincii=sinc((xv-(ii))/q)*Fii(ii+4);
  Fkozel=Fkozel+sincii;
  plot(xv,sincii)
  hold on
end
hold off
title('Interpolating sinc functions');
saveprobfig(2,'figp_4_9b.eps')

for ii=5:100
  Fkozel=Fkozel+1*sinc((xv-(ii))/q);
end
figure(3)
plot(xv,Fkozel);
title('Approximation of the CDF');
saveprobfig(3,'figp_4_9c.eps')

f=diff(Fkozel)/dx; f=[f,f(end)];
figure(4)
plot(xv,f);
set(gca,'xlim',[-5,5])
title('Interpolated PDF');
saveprobfig(4,'figp_4_9d.eps')

figure(5)
plot(xv+q/2,f);
set(gca,'xlim',[-5,5])
title('The interpolated PDF shifted to the right');
saveprobfig(5,'figp_4_9e.eps')

figure(6)
plot(xv+q/2,f,xv,fx)
set(gca,'xlim',[-5,5])
title('Interpolated and original PDF');
saveprobfig(6,'figp_4_9f.eps')

figsorder