disp('Solving Problem 8.3...')

close all
%x=[-3:.01:3]; plot(x,GaussCDF(x)), shg
Nx=1e6;
rho=0.8; sigma=1; q=1;
res=50; dx=0.1;
x1=randn(Nx,1); x2=rho*x1+sqrt(1-rho^2)*randn(Nx,1);

if exist('hist3.m','file')
  figure(1)
  hist3([x1,x2],{[-4.5:dx:4.5],[-4.5:dx:4.5]});
  title('Input PDF')
  set(gca,'View', [-8.50001 44.0406])
  saveprobfig(1,'figp_8_3a.eps')
else
  warning('Figure 8.3a is generated using the hist3 function of the Statistics Toolbox')
end

if exist('hist3.m','file')
  figure(2)
  hist3([x1,x2],{[-4.5:4.5],[-4.5:4.5]});
  title('Quantizer output PDF')
  set(gca,'View', [-8.50001 44.0406])
  saveprobfig(2,'figp_8_3b.eps')
else
  warning('Figure 8.3b is generated using the hist3 function of the Statistics Toolbox')
end

if exist('hist3.m','file')
  [N3,X3]=hist3([x1,x2],{[-4.5:4.5],[-4.5:4.5]});
  x1q=q*round(x1/q); x2q=q*round(x2/q);
  E1=mean([x1q,x2q])
  E2=mean([x1q.^2,x2q.^2])
  R12=mean([x1q.*x2q])
  Rth=rho*sigma^2
  
  x1d=[-4:33.5]';
  x1a=[-4.5+dx/2:dx:4.5]';
  fc=zeros(length(x1a),length(x1a));
  [X1,X2]=meshgrid(x1a,x1a);
  for ii1=1:length(x1d)
    CDF=cumsum(cumsum(N3,1),2);
    for ii2=1:length(x1d)
      sampl=CDF(min(ii1,end),min(ii2,end));
      fc=fc+sampl*(pi*(X1-x1d(ii1)).*cos(pi*(X1-x1d(ii1))/q)-q*sin(pi*(X1-x1d(ii1))/q))...
        ./(q*pi*(X1-x1d(ii1)).^2)...
        .*(pi*(X2-x1d(ii2)).*cos(pi*(X2-x1d(ii2))/q)-q*sin(pi*(X2-x1d(ii2))/q))...
        ./(q*pi*(X2-x1d(ii2)).^2);
    end
  end
  figure(3)
  mesh(X1,X2,fc), shg
  set(gca,'View', [-8.50001 44.0406])
  saveprobfig(3,'figp_8_3c.eps')
else
  warning('Figure 8.3c is generated using the hist3 function of the Statistics Toolbox')
end
