disp('Solving Problem 8.4...')

close all
Nx=1e6;
rho=0.8; A=10; q=1;
plotno=0; res=50; dx=0.2;
for typ='bc'
  if strcmp(typ,'b')
    x1=randn(Nx,1); x2=rho*x1+sqrt(1-rho^2)*randn(Nx,1);
    x1u=A*cdf_gauss(x1); x2u=A*cdf_gauss(x2);
  else %'c'
    ind1=0; Nx2=Nx/2; lim=1.9*A*(1-rho);
    while ind1<Nx
      x1=A*rand(Nx2,1); x2=A*rand(Nx2,1);
      indm1=find((x1>x2+lim)&(x1<=2*lim)); 
      x1(indm1)=2*lim-x1(indm1);
      indm2=find((x1<x2-lim)&(x1>=(A-2*lim))); 
      x1(indm2)=2*A-2*lim-x1(indm2);
      ind=sort([find(abs(x1-x2)<=lim)]);
      N=min(length(ind),Nx-ind1);
      x1u(ind1+[1:N])=x1(ind(1:N)); x2u(ind1+[1:N])=x2(ind(1:N));
      ind1=ind1+N;
    end
  end
  plotno=plotno+1; figure(plotno)
  if exist('hist3.m','file')
    hist3([x1u,x2u],{[0:dx:A],[0:dx:A]})
    set(gca,'view',[-14.5000   28.0000])
    title('Input PDF')
    saveprobfig(plotno,['figp_8_4',setstr('a'-1+plotno),'.eps'])
    plotno=plotno+1; figure(plotno)
    hist3([x1u,x2u],{[.5:10],[.5:10]});
    set(gca,'view',[-14.5000   28.0000])
    title('Quantizer output PDF')
    saveprobfig(plotno,['figp_8_4',setstr('a'-1+plotno),'.eps'])
  else
    warning(['Figure 8.4',setstr('a'-1+plotno),' is generated using the hist3 function of the Statistics Toolbox'])
  end
  
  x1q=q*round(x1u/q); x2q=q*round(x2u/q);
  E1=mean([x1q,x2q])
  E2=mean([x1q.^2,x2q.^2])
  R12=mean([x1q.*x2q])
  Rth=25+rho*A^2/12+q^2/12
  r12=(R12-prod(E1))/sqrt(prod(E2-E1.^2))
end %for type
