disp('Solving Problem 9.1...')

close all
Nx=1e6;
rho=0.5; q1=1; sigma1=q1; q2=1; sigma2=1.5*q2;
mu1=0.5*q1; mu2=0;
res=50; dx=0.1;
x1=randn(Nx,1); x2=rho*x1+sqrt(1-rho^2)*randn(Nx,1);
x1=sigma1*x1+mu1; x2=sigma2*x2+mu2;

if exist('hist3.m','file')
  figure(1)
  hist3([x1,x2],{[-4.5:dx:4.5],[-4.5:dx:4.5]});
  title('Input PDF')
  set(gca,'View', [-8.50001 44.0406])
  saveprobfig(1,'figp_9_1a.eps')
else
  warning(['Figure 9.1a is generated using the hist3 function of the Statistics Toolbox'])
end

if exist('hist3.m','file')
  figure(2)
  hist3([x1,x2],{[-4.5:4.5],[-4.5:4.5]});
  title('Quantizer output PDF')
  set(gca,'View', [-8.50001 44.0406])
  saveprobfig(2,'figp_9_1b.eps')
  [N3,X3]=hist3([x1,x2],{[-4.5:4.5],[-4.5:4.5]});
else
  warning(['Figure 9.1b is generated using the hist3 function of the Statistics Toolbox'])
end

x1q=q1*round(x1/q1); x2q=q2*round(x2/q2); 
E1=mean([x1q,x2q]);
E2=mean([x1q.^2,x2q.^2]);
E12=mean([(x1q).*(x2q)])
E2_12=mean([(x1q.^2).*(x2q.^2)])
R12=mean([x1q.*x2q])
Rth=rho*sigma1*sigma2
cov12=(R12-prod(E1))
r12=(R12-prod(E1))/sqrt(prod(E2-E1.^2))

x1d=[-3.5:3.5];
x1a=sort([-.8:0.01:.8])';
[X1,X2]=meshgrid(x1a,x1a); S=[sigma1^2,rho*sigma1*sigma2;rho*sigma1*sigma2,sigma2^2];
fnu=zeros(length(x1a),length(x1a));
for ii1=1:length(x1d)
  for ii2=1:length(x1d)
    indnu=find((abs(X1)<0.5)&(abs(X2)<0.5));
    xv1=(x1d(ii1)-X1(indnu));
    xv2=(x1d(ii2)-X2(indnu));
    for ii=1:length(indnu)
      fnu(indnu(ii))=fnu(indnu(ii))...
        +1/2/pi/sqrt(det(S))*exp(-1/2*[xv1(ii),xv2(ii)]*inv(S)*[xv1(ii),xv2(ii)]');
    end
  end
end

figure(3)
mesh(X1,X2,fnu), shg
title('PDF of the quantization noises')
set(gca,'View', [-8.50001 44.0406])
saveprobfig(3,'figp_9_1c.eps')
