function testallproblems(problem)
%TESTALLPROBLEMS  Test all existing problem M-files
%   testallproblems problem_4_4  execute one problem file
%   testallproblems problem_4_4:  continue from here

global saveprobfigson %allow saving of problem figures
saveprobfigson=0; %do not save files

%if ~qunique, error('Name collision, see info in command window'), end

ap=which('testallproblems.m');
if isempty(ap), error('files not found'), end
if nargin==0, problem=''; end
if isnumeric(problem), problem=num2str(problem); end
if isstr(problem)&~isempty(problem)
  ind=findstr(problem,'.'); if ~isempty(ind), problem(ind)='_'; end
  if strcmp(problem(end),':'), problem(end)=''; cont=1; else cont=0; end
end
if ~isempty(problem)&~cont
  diritems=dir([ap(1:end-17),problem,'.m']);
  disp(['Testing problem-solving M-file ',problem,' ...'])
else
  diritems=dir([ap(1:end-17),'problem_?_*.m']);
  diritems=[diritems;dir([ap(1:end-17),'problem_??_*.m'])];
  if ~isempty(problem)
    for ii=1:length(diritems)
      if strcmp([problem,'.m'],diritems(ii).name), diritems(1:ii-1)=[]; break, end
    end
  end
  disp('Testing problem-solving M-files...')
end
try
  pause off
  for dirii=1:length(diritems)
    global N_for_test_only
    N_for_test_only=120; %make tests shorter
    disp('===========================')
    eval(diritems(dirii).name(1:end-2))
  end 
  disp(' ')
  if isempty(problem)
    disp('All problem-solving files have been executed OK.')
  elseif cont
    disp(['Problem-solving files starting from ',problem,'.m have been executed OK.'])
  else
    disp(['Problem-solving file ',problem,'.m has been executed OK.'])
  end
catch
  disp(' ')
  disp(lasterr)
  disp('M-file:')
  diritems(min(dirii,length(diritems)))
  disp(['An error occurred while executing file  ',diritems(min(dirii,length(diritems))).name(1:end)])
  disp(['This is Matlab version ',version])
  error('Tests of problems halted')
end
if exist('testroundoff.m')&isempty(problem)
  dbs=dbstack; tfound=0;
  for dirii=1:length(dbs)
    if strcmp(dbs(dirii).file,'testroundoff.m')
      tfound=1; %call from that function
    end
  end
  if ~tfound, testroundoff, end %test quantization toolbox
end
clear global saveprobfigson %allow to save figures (if file exists in file saveprobfigs.m)
N_for_test_only=[];
pause on
clear
