function [ki,longstr] = b_add(a,b,prec,dummyobj)
%B_ADD  Addition through conversion to bit sequences
%
%   ki = b_add(a,b) %a,b: qdata objects

%   ki = b_add(a,b,prec,dummyobj) %a=obj.data
%      Here dummyobj is used to be able to call with vectors

Q='double';
if nargin<3, prec=[]; end
if isa(b,'qdata')
  bvect=b.data; Q=b.name;
  if nargin<3, prec=qget(b.name,'precision'); end
else
  bvect=b;
end
if isa(a,'qdata')
  avect=a.data; Q=a.name;
  if nargin<3, prec=qget(a.name,'precision'); end
else
  avect=a;
end
if isempty(prec), prec=53; end

sign_a = sign(avect(1));
sign_b = sign(bvect(1));
avect = abs(avect);
bvect = abs(bvect);
sign_k = 1;

[a_binary e_a]=num2binsegm(avect,22,prec);
[b_binary e_b]=num2binsegm(bvect,22,prec);
a_binary=sign_a*a_binary;
b_binary=sign_b*b_binary;

if e_a>e_b+prec
  result=[a_binary,0,b_binary];
  e=e_a;
elseif e_b>e_a+prec
  result=[b_binary,0,a_binary];
  e=e_b;
elseif e_a>e_b
  a_binary=[a_binary,zeros(1,e_a-e_b)];
  b_binary=[zeros(1,e_a-e_b),b_binary];
  if length(a_binary)>length(b_binary)
    b_binary=[b_binary,zeros(1,length(a_binary)-length(b_binary))];
  elseif length(a_binary)<length(b_binary)
    a_binary=[a_binary,zeros(1,length(b_binary)-length(a_binary))];
  end
  result=a_binary+b_binary;
  e=e_a;
elseif e_a<e_b
  b_binary=[b_binary,zeros(1,e_b-e_a)];
  a_binary=[zeros(1,e_b-e_a),a_binary];
  if length(a_binary)>length(b_binary)
    b_binary=[b_binary,zeros(1,length(a_binary)-length(b_binary))];
  elseif length(a_binary)<length(b_binary)
    a_binary=[a_binary,zeros(1,length(b_binary)-length(a_binary))];
  end
  result=a_binary+b_binary;
  e=e_b;
else
  if length(a_binary)>length(b_binary)
    b_binary=[b_binary,zeros(1,length(a_binary)-length(b_binary))];
  elseif length(a_binary)<length(b_binary)
    a_binary=[a_binary,zeros(1,length(b_binary)-length(a_binary))];
  end
  result=a_binary+b_binary;
  e=e_a;
end

while (length(result)>0)&(result(1)==0), result(1)=[]; e=e-1; end
if (length(result)>0)&(result(1)<0), result=-result; sign_k=-1; end

if nargout>=2
  [result,emod,longstr]=fixbin(result,Q,sign_k,e_a+e_b);
else
  [result,emod]=fixbin(result,Q);
end
if length(result)<prec, result=[result,zeros(1,prec-length(result))]; end
e=e+emod;

%javitva, s most szegmensels
N=length(avect);
szam = zeros(N,1);
L=22;

for k = 1 : N
  for n = 1 : L
    szam(k) = 2^(-(n-1)) * result((k-1)*L+n) + szam(k);
    if (k-1)*L+n==length(result), break, end
  end
end

szam = szam * 2 ^ (e);
ki = sign_k * szam;
if isa(a,'qdata')
  num.name=a.name; num.data=ki; 
  ki=qdata(num);
end
