function [ki,longstr] = b_times(a,b,prec)
%B_TIMES  Multiplication through conversion to bit sequences
%
%   ki = b_times(a,b) %a,b: qdata objects

%   ki = b_times(a,b,prec,dummyobj) %a=obj.data
%      Here dummyobj is used to be able to call with vectors

if isa(a,'qdata')
  avect=a.data; bvect=b.data; Q=a.name;
  if nargin<3, prec=qget(a.name,'precision'); end
  if strcmp(qget(Q,'type'),'fixed-point'), MSB=2^(qget(Q,'precision')-1-qget(Q,'fractionbits')); else MSB=[]; end
else
  avect=a; bvect=b; Q='double'; MSB=[];
  if nargin<3, prec=53; end
end
sign_a = sign(avect(1));
sign_b = sign(bvect(1));
avect = abs(avect);
bvect = abs(bvect);
sign_k = sign_a * sign_b;

[a_binary e_a]=num2binsegm(avect,22,MSB,prec);
[b_binary e_b]=num2binsegm(bvect,22,MSB,prec);

result = conv(a_binary,b_binary);
%here is the product, yet not formed

if nargout>=2
  [result,emod,longstr]=fixbin(result,Q,sign_k,e_a+e_b);
else
  [result,emod]=fixbin(result,Q);
end
e=e_a+e_b+emod;

%javitva, s most szegmensels
N=length(avect);
szam = zeros(N,1);
L=22;

for k = 1 : N
  for n = 1 : L
    szam(k) = 2^(-(n-1)) * result((k-1)*L+n) + szam(k);
    if (k-1)*L+n==length(result), break, end
  end
end

szam = szam * 2 ^ (e);
ki = sign_k * szam;
if isa(a,'qdata')
  num.name=a.name; num.data=ki; 
  ki=qdata(num);
end
