function y = double(a)
%DOUBLE        Convert @qdata objects to double precision.
%     DOUBLE(X) returns the double precision value for the @qdata object X.

% Copyright (C) 2004 by JUHASZ Laszlo

% generating quantizer property short-code for 'double'
persistent qcode
if ~isempty(a.name)
    qcode = qdspdemo('quantizers',a.name);
end

%   qcode = ['SEGNUM=[3];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[53];',...
%         'LEADINGBIT=''hidden'';FRACTION=[52];INVSIGNAL=''neglect+nan'';',...
%         'OVERFLOW=''inf'';OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
%         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
%         'EMAX=[1023];EMIN=[-1022];'];

eval(qcode);
a = a.data;

% filtering out empty matrix
if isempty(a), out = []; return, end

orsiza = size(a);
% calculating the number of segments in 'a'
%segna = orsiza(1);
% calculating the real size WITHOUT segments - the length of size is
% minimum 2 so the '2:end' expression is always correct.
orsiza = orsiza(2:end); %if length(orsiza)==1, orsiza=[orsiza,1]; end
% convert to two dimension
a = reshape(a,[SEGNUM,prod(orsiza)]);

% rounding real part
%s=sign(real(a)); 
[re,of,uf,inv,warn,err] = seground(real(a),qcode); error(err); warning(warn);
ofs = of; ufs = uf; ins = inv;
% rounding imag part
[im,of,uf,inv,warn,err] = seground(imag(a),qcode); error(err); warning(warn);
ofs = ofs | of; ufs = ufs | uf; ins = ins | inv;
% collecting to 'y'

%its realy hurt:)
%y = sum(re)+j.*sum(im);
if(isdscalar(orsiza))
   orsiza = [1 orsiza];
end
yre = zeros(1,prod(orsiza));
for ir = SEGNUM:-1:1
    yre = yre + re(ir,:).*2.^((ir-1)*(-22));
end

yim = zeros(1,prod(orsiza));
for ii = SEGNUM:-1:1
    yim = yim + im(ii,:).*2.^((ii-1)*(-22));
end

y = yre + j.*yim;

y=reshape(y,orsiza);

% reshaping
%if~(orsiza==1)
%    y = reshape(y,[1 orsiza]);
%end

% store statistical info
if any(ofs(:)) | any(ufs(:)) | any(ins(:))
   % reshape stat info variables into size of 'data' without leading
   % segment dimensions
   ofs = reshape(ofs,orsiza);
   ufs = reshape(ufs,orsiza);
   ins = reshape(ins,orsiza);
   st = dbstack;
   % clear the top of the stack containing info about current function
   st(1) = [];
   % prevent from storing empty 'dbstack' struct with complete fieldnames
   % (in case when command line event occured and the former operation cleared
   % this)
   if isempty(st), st = []; end
   % fill up struct
   stat.dbstack = st;
   stat.ofmask = ofs;
   stat.ufmask = ufs;
   stat.invmask = ins;
   stat.arg1 = a;
   stat.arg2 = [];
   stat.result = y;
   % send to 'quantizers'
   qdspdemo('quantizers','event',stat);
end
