function y = expj(a)
%EXPJ     Exponential for non complex qdata object
%    y = cos(a) + j * sin(a) 
%    EXP(X) is the exponential of the elements of X, e to the X.
%    For complex Z=X+i*Y, EXP(Z) = EXP(X)*(COS(Y)+i*SIN(Y)).

qpi=qdata(qpi_str(qdata),a.name);

%X talaktsa sorvektorr
if isempty(a.data)
    % argument is empty so the result will be empty too
    y = class(emptyclass,'qdata');
    return
else
    orsiza = size(a.data);
    % calculating the number of segments in 'a'
    segna = orsiza(1);
    % calculating the real size WITHOUT segments - the length of size is
    % minimum 2 so the '2:end' expression is always correct.
    orsiza = orsiza(2:end);
    % convert to two dimension
    a.data = reshape(a.data,[segna,prod(orsiza)]);
end

% download quantizer properties - the first argument ('a') has a bigger
% priority.
if ~isempty(a.name)
   qcode = qdspdemo('quantizers',a.name);
elseif ~isempty(b.name)
   qcode = qdspdemo('quantizers',b.name);
else
   error('One of the inputs must have a quantizer name.');
end   
eval(qcode)

% extract values from structs - the name is unnecessary from now on
a = a.data;

reres = zeros(15,size(a,2));
reres = zeros(15,size(a,2));


for k = 1 : prod(orsiza)
    %egyesvel kiszmoljuk a sinuszt
    t = cos_priv(a(:,k),SEGNUM,qpi.data);
    reres(1:length(t),k) = t.';
    t = sin_priv(a(:,k),SEGNUM,qpi.data);
    imres(1:length(t),k) = t.';
end

[reres,of,uf,inv,warn,err] = seground(reres,qcode); error(err); warning(warn);
ofs = of; ufs = uf; ins = inv;
[imres,of,uf,inv,warn,err] = seground(imres,qcode); error(err); warning(warn);
ofs = ofs | of; ufs = ufs | uf; ins = ins | inv;

% ***** TRAILER *****
% interleaving real and imag part
t = reres+i.*imres;
% cut number of segs to SEGNUM
t = t(1:SEGNUM,:);
% reshape to original size
t = reshape(t,[SEGNUM,orsiza]);


% generating output object
if ~isempty(t(:))
   y.name = NAME;
else
   y.name = '';
end
y.data = t;
y = class(y,'qdata');

% store statistical info
if any(ofs(:)) | any(ufs(:)) | any(ins(:))
   % reshape stat info variables into size of 'data' without leading
   % segment dimensions
   ofs = reshape(ofs,orsiza);
   ufs = reshape(ufs,orsiza);
   ins = reshape(ins,orsiza);
   st = dbstack;
   % clear the top of the stack containing info about current function
   st(1) = [];
   % prevent from storing empty 'dbstack' struct with complete fieldnames
   % (in case when command line event occured and the former operation cleared
   % this)
   if isempty(st), st = []; end
   % fill up struct
   stat.dbstack = st;
   stat.ofmask = ofs;
   stat.ufmask = ufs;
   stat.invmask = ins;
   stat.arg1 = v;
   stat.arg2 = [];
   stat.result = y;
   % send to 'quantizers'
   qdspdemo('quantizers','event',stat);
end