function a = fi(v,T)
%FI  Fixed-point numeric object converted from qdata
%
%   Syntax:
%     a = fi(v)
%     a = fi(v,T)
%
%     fi(v,T) returns a fixed-point object with value v and
%     embedded.numerictype T.

%   Written by Istvn Kollr, 9-April-2007
%   All rights reserved

if strcmp(get(v,'type'),'floating-point'), error('Cannot convert floating-point objects to fi'), end
B=get(v,'Bits'); fb=get(v,'FractionBits');
th=get(v,'TreatHalf'); if strcmp(th,'toeven'), rm='convergent'; else rm='round'; end 
of=get(v,'Overflow'); if strcmp(of,'clip'), of='saturate'; end
Q=quantizer(struct('mode','fixed','format',[B,fb],'roundmode',rm,'overflowmode',of));

d=double(v);
a=fi(0,Q); a.bin=get(v,'bin');
