function y = mrdivide(a,b)
%MRDIIVIDE     Slash or right matrix divide.
%    A/B is the matrix division of B into A, which is roughly the
%    same as A*INV(B) , except it is computed in a different way.
%    More precisely, A/B = (B'\A')'. See MLDIVIDE for details.
% 
%    C = MRDIVIDE(A,B) is called for the syntax 'A / B' when A or B is an
%    object.
% 
%    See also MLDIVIDE, RDIVIDE, LDIVIDE.

if (length(a)==1)|(length(b)==1)
  y=a./b;
  return
end
error(sprintf(['    Matrix mrdivide currently isn''t supported. Use ''./'' for array\n',...
   '    division instead of ''/''.']))
