function y = mtimes(a,b)
%MTIMES(*)     Matrix multiply of @qdata objects.
%     X*Y is the matrix product of X and Y.  Any scalar (a 1-by-1 matrix)
%     may multiply anything.  Otherwise, the number of columns of X must
%     equal the number of rows of Y.
%     Either of X or Y can be also a double array.

%warning(sprintf(['    Matrix muliplication currently isn''t supported. Use ''.*'' for array\n',...
%   '    multiplication instead of ''*''.']))

if (length(a)==1)&(length(b)==1) %scalar
  y = times(a,b); return
end
%make from double qdata
if isa(a,'qdata')&isnumeric(b), b=qdata(b,a.name);
elseif isa(b,'qdata')&isnumeric(a), a=qdata(a,b.name);
end
if (length(a)==0)|(length(b)==0) %empty
  y = a; y.data=[];
else
  if length(a)==1, y=b;
  elseif length(b)==1, y=a; a=b;
	end
	if length(a)==1
		for ii=1:prod(size(y))
			y=subsasgn(y,struct('type','()','subs',cell({{ii}})),times(subsref(y,struct('type','()','subs',cell({{ii}}))),a)); 
		end
		return
	end
end
%true matrix product
y = qdata(zeros(size(a,1),size(b,2)),a.name);
if size(a,2)~=size(b,1), error('sizes are inconsistent'), end
for ix=1:size(a,1)
	for iy=1:size(b,2)
		z=0;
		for ii=1:max(size(a,2),size(b,1))
			sa.type='()'; sa.subs={ix,min(ii,size(a,2))};
			sb.type='()'; sb.subs={min(ii,size(b,1)),iy};
			z=subsref(a,sa)*subsref(b,sb)+z;
		end
		y.data(:,ix,iy)=z.data;
	end
end
