function str=num2bin(number,Qdisp)
%NUM2BIN  Return binary string of qdata object

% By Istvn Kollr

error(nargchk(1,2,nargin))
str='';
if nargin==2
  if nargout, str=num2bin(qdata(number,Qdisp));
  else str=num2bin(qdata(number,Qdisp));
  end
  return
end
% group number - controls how many bits are in a group separated with
% spaces from each other
gn=4;
siz = size(number);
len = max(size(number));
name = number.name;
x = number.data;
% obtaining real and imag part
re = real(x);
im = imag(x);
% indicates that any nonzero data exist in either real or imag parts
isre = any(re(:));
isim = any(im(:));
% filtering out empty and zero objects
if isempty(name)
  if isempty(x)
    % empty object
    %str=[str,sprintf('     []\n')];
    str='';
    return
  else
    error(['Internal error. Wrong object: it does not contain ',...
      'quantizer name, but is not [] or 0.'])
  end
else %name exists
  % reverse check
  if isempty(x)
    str='';
    %error('Internal error. Wrong object: it contains quantizer name, but is empty.')
  end
end

% request quantizer properties
[code,err] = qdspdemo('quantizers','get',name); error(err)
[code,err] = qdspdemo('quantizers',code.name); error(err)
eval(code)

% correct segnum in case when the quantizer in memory has changed
SEGNUM=size(x,1);

% filter out when the object is not vector
if prod(siz)~=len
  % generating the size string
  csiz = '';
  for k = 1:length(siz)-1
    csiz = [csiz,sprintf('%dx',siz(k))];
  end
  csiz = [csiz,sprintf('%d',siz(end))];
  str=sprintf('[%s qdata]\n\n',csiz);
  return
end

% collect the displayed strings into cell
rec = cell(len,1);
imc = cell(len,1);
for k = 1:len
  rec{k} = intern_disp(real(x(:,k).'),code,gn);
  imc{k} = intern_disp(imag(x(:,k).'),code,gn);
end

% obtain screen width
scr = get(0,'ScreenSize');
scr = scr(3);
% available width in chars (optimized for 800x600, screen font: Fixedsys 11)
scr = fix(scr*93/800);

spa = ' ';
% display
for k = 1:len
  t = rec{k};
  if (length(t)+6)>scr
    u = round(length(t)/2);
    point = findstr(t,'.');
    % search for a group separator space on the screen
    sepa = findstr(t(u-gn:u+gn),' ');
    % select separator
    sepa = round(length(sepa)/2);
    % which space is the sepa
    sepa = length(findstr(t(1:u-gn-1),' '))+sepa;
    % which position;
    sepa2 = findstr(t,' ');
    sepa = sepa2(sepa);
    % 1st row
    str=[str,sprintf('      %-s...\n',t(1:sepa-1))];
    % 2nd row
    str=[str,sprintf('%s%-s\n',spa(ones(point+6,1)),t(sepa+1:end))];
  else
    str=[str,sprintf('      %-s\n',t)];
  end
  if isim
    t = imc{k};
    %OLD_RS if length(t)>scr
    if length(t)+6>scr
      u = round(length(t)/2);
      point = findstr(t,'.');
      % search for a group separator space at the end of screen
      %OLD_RS sepa = findstr(t(scr-2*gn:scr),' ');
      sepa = findstr(t(u-gn:u+gn),' ');
      % select separator
      %OLD_RS sepa = sepa(ceil(length(sepa)/2));
      sepa = round(length(sepa)/2);
      % which space is the sepa
      %OLD_RS sepa = length(findstr(t(1:scr-2*gn-1),' '))+sepa;
      sepa = length(findstr(t(1:u-gn-1),' '))+sepa;
      % which position;
      sepa2 = findstr(t,' ');
      sepa = sepa2(sepa);
      % 1st row
      str=[str,sprintf('  +j* %-s...\n',t(1:sepa-1))];
      % 2nd row
      %OLD_RS str=[str,sprintf('         %-s}\n',t(sepa+1:end))];
      str=[str,sprintf('%s%-s\n',spa(ones(point+6,1)),t(sepa+1:end))];
    else
      str=[str,sprintf('  +j*[%-s]\n\n',imc{k})];
    end
  end
end
while strcmp(str(1),' '), str(1)=''; end %eliminate first space
while strcmp(str(end),'.')|strcmp(str(end),' ')|strcmp(str(end),setstr(10)), str(end)=''; end %eliminate last . or space
%ind=find((str==10)|(str==13)); if ~isempty(ind), str(ind)=''; end
%
%two's complement adding 1
%if strcmp(CODING,'twos-comp')&strcmp(str(1),'1')
%  for ii=length(str):-1:1
%    if (ii==length(str)), str(end)=setstr(str(end)+1); end
%    if strcmp(str(ii),'2'), str(ii)='0'; 
%      if ii>1, str(ii-1)=setstr(str(ii-1)+1); else str=[str(1),'1',str(2:end)]; end  
%    else break
%    end
%  end
%end