#include "mex.h"
#include <math.h>


double absz(double D)
{
	if(D<0) return -1*D;
	return D;
}

bool isBFPNumber(mxArray *who, const number)
{

	//deciding whenever the input argument is a NUMBER part long double array
	//if who is a 2 dimensional matrix (this could be an array, but more dims would
	//prevent it.
	if(mxGetNumberOfDimensions(who)==2 &\
	//this test whenever one of the dims range must be one end the other must be the
	//expected number
	(((mxGetM(who)==number) & (mxGetN(who)==1)) | ((mxGetM(who)==1) & (mxGetN(who)==number)))&\
	//this check if its not a double format number array or its complex.
	mxIsDouble(who) & !mxIsComplex(who))
		return true;
	else
		return false;
}

double* getAllMantissa(double BPFarray[], int num,int disp)
/*
 Return the mantissas of the the input double precission array
*/
{
	int *exponent;
	int i;
	double *array;

	exponent = mxCalloc(1,sizeof(int));
	array = mxCalloc(num,sizeof(double));

	for(i=0;i<num;i++)
	{
	 array[i] = frexp(BPFarray[i],exponent);
	 if(disp>0)mexPrintf("man(%d):  %.20f\n",i,array[i]);
	}
	mxFree(exponent);
	return array;
}

bool *getMantbool(double *who_mant,int *who_exp,int num,int mant_hossza)
{
	bool *eredmeny;
	double s,akkumulator;
	int i,j,exp_eltolas;


	eredmeny = (bool *)mxCalloc(num*mant_hossza,sizeof(bool));


	for(j=0;j<num;j++)
	{
		if(who_mant[j]<0) s = -1;
		else s=1;
		akkumulator = s*who_mant[j];
//ellenrzs a kezd nullk kiirshoz
		exp_eltolas = who_exp[0]-who_exp[j];
		if(exp_eltolas<0)
		{
			exp_eltolas = 0;
		}
		for(i=exp_eltolas;i<mant_hossza;i++)
		{
			akkumulator = akkumulator * 2;
			if(akkumulator >= 1)
			{
				akkumulator = akkumulator - 1;
				eredmeny[j*mant_hossza+i] = 1;
			}
			else
			{
				eredmeny[j*mant_hossza+i] = 0;
			}
		}
	}

	return eredmeny;

}



int* getAllExponent(double BPFarray[], int num,int disp)
/*
 Return the expontnts of the the input double precission array
*/
{
	int* array;
	double mantissza;
	int i;

	array = mxCalloc(num,sizeof(int));

	for(i=0;i<num;i++)
	{
	 mantissza = frexp(BPFarray[i],&array[i]);
	 if(disp>0)mexPrintf("exp(%d):  %d\n",i,array[i]);
	}
	return array;
}


void printbool(bool *who,int marker,int offset,int mant_number)
{
	int i;
	for(i=0;i<offset;i++)//offszetnyi nulla kirsa
		mexPrintf(" ");
	//mexPrintf("0.");
	for(i=marker;i<marker+mant_number;i++)
		if(who[i])
			mexPrintf("1");
		else
			mexPrintf("0");

	mexPrintf("\n");
}

void printBFP(double *BFP,int number,int mant_length,int mant_offset,int disp)
{
	bool *mantBool;
	int *exponens,exp_eltolas;
	int offszet,i;
	double *mantissas;

	mantissas = getAllMantissa(BFP,number,disp-1);
	exponens = getAllExponent(BFP,number,disp-1);
	mantBool = getMantbool(mantissas,exponens,number,mant_length);

	for(i=0;i<number;i++)
	{
		exp_eltolas = exponens[0]-exponens[i];
		if(exp_eltolas > 0) exp_eltolas = 0;
		offszet = exp_eltolas+i*mant_offset;
		printbool(mantBool,i*mant_length,offszet,mant_length);
	}
}


double *osszeadBFP(double*a, double*b, int* number, int mant_length, int disp)
{
	double *nagyobb,*kisebb,*nagyobb_kit,*kisebb_kit;
	int *a_exps,*b_exps;
	int exp_kul,exp_kul_mod,exp_kul_egesz,nagyobb_hossz;
	int i,j,k;
	j=0;k=0;
	/*
		Els kivtel lehetsg: ha az egyik is nulla
	*/
	if(disp>2)mexPrintf("------sszeads-------\n\n");
	for(i=0;i<*number;i++)
	{

		if(a[i]!=0)
		{
			j++;//ha van nem nulla akkor j rtke nem nulla
			if(disp>2)mexPrintf("van aban nem nulla:%d\n",j);
		}
		if(b[i]!=0)
		{
			k++;//ha van nem nulla akkor k rtke nem nulla
			if(disp>2)mexPrintf("van bben nem nulla:%d\n",k);
		}

	}
	if((j==0) || (k==0))//ha brmelyik is tiszta nulla akkor mst kell tenni
	{
		int l;
		if(disp>2)mexPrintf("valamelyik is tiszta nulla\n");
		if(j==0)//a nulla
		{
			if(disp>2)mexPrintf("a nulla\n");
			nagyobb_kit = (double*)mxCalloc(2*(*number),sizeof(double));
			for(l=0;l<*number;l++)
				nagyobb_kit[l] = b[l];
		}
		else//b nulla (legalbb)
		{
			if(disp>2)mexPrintf("b nulla\n");
			nagyobb_kit = (double*)mxCalloc(2*(*number),sizeof(double));
			for(l=0;l<*number;l++)
				nagyobb_kit[l] = a[l];
		}
		return nagyobb_kit;
	}
	//egybknt folytatjuk
	if(disp>2)mexPrintf("egyik se tiszta nulla\n");
	//1. nagyobb kisebb kivlasztsa
	a_exps = getAllExponent(a,*number,disp-1);
	b_exps = getAllExponent(b,*number,disp-1);
	if(a_exps[0]>=b_exps[0])
	{
		if(disp>2)mexPrintf("a nagyobb egyenlo\"\n");
		nagyobb = a;
		kisebb = b;
	}
	else
	{
		if(disp>2)mexPrintf("b nagyobb\n");
		nagyobb = b;
		kisebb = a;
	}
	//2. eltrsek szmostsa
	exp_kul = abs(a_exps[0]-b_exps[0]);
	if(disp>2)mexPrintf("exponensek klnbsge:%d\n",exp_kul);
	exp_kul_mod = exp_kul % mant_length;
	if(disp>2)mexPrintf("exponensek klnbsgnek moduloja numberrel:%d (mant_length:%d)\n",exp_kul_mod,mant_length);
	exp_kul_egesz = (int)(exp_kul / mant_length);
	if(disp>2)mexPrintf("exponensek klnbsgnek egszrsze:%d (mant_length:%d)\n",exp_kul_egesz,mant_length);
	//3.a. nagyobb_kiterjesztse
	// az sszeadst pontosan vgezzk el. az kt tag sszege olyan hossz lesz, hogy biztosan pontos legyen
	nagyobb_hossz = 2*(*number)-1;
	if(exp_kul_egesz>=*number) nagyobb_hossz = *number+exp_kul_egesz;
	nagyobb_kit = (double*)mxCalloc(nagyobb_hossz,sizeof(double));
	for(i=0;i<*number;i++)
	{
		nagyobb_kit[i] = nagyobb[i];//gy a nagyobb teteje marad, de hozzadunk mg a maradk nullt
		if(disp>2)mexPrintf("nagyobb %d. rsze:\t%.20f\n",i,nagyobb_kit[i]);
	}
	//3.b. kisebb_kiterjesztse
	/*
		Msodik kivtel lehetsg: nem rnek ssze, nincs igazi sszeadand feladat
	*/
	if(exp_kul_egesz>=*number)//annyira nincsenek kzel, hogy nem kell sszeadni
	{
		j=0;
		if(disp>2)mexPrintf("2.szm kivtel: nincs sszeadand\n");
		//akkor mr nincs ms feladat mint a megfelel mennyisg kisebbiket beiileszteni a nagyobbikba
		*number = nagyobb_hossz;
		for(i=exp_kul_egesz;i<nagyobb_hossz;i++)
		{
			nagyobb_kit[i]=kisebb[j++]*pow(2,exp_kul_egesz*mant_length);;
			if(disp>2)mexPrintf("nagyobb %d. rsze:\t%.20f\n",i,nagyobb_kit[i]);
		}
		return nagyobb_kit;//visszakldjk
	}
	for(i=*number;i<nagyobb_hossz;i++)
	{
		nagyobb_kit[i] = 0;
		if(disp>2)mexPrintf("nagyobb %d. rsze:\t%.20f\n",i,nagyobb_kit[i]);
	}
	/*
		A kisebb kiterjesztsnl el kell toljuk megfelelen a kisebbiket.
		exp_kul_egesz-nyi nulla rsz kell legyen az elejn

	*/
	kisebb_kit = (double*)mxCalloc(2*(*number)-1,sizeof(double));//ha mgis szksg van r akkor inicializljuk
	//mivel ha sszernek maximum 2*number-1 db tag keletkezhet ezrt ide elg csak ennyit inicializlni
	//s a nagyobbik_kiterjesztettbl se hasznljuk fel a teljes tmbt innentl!
	for(i=0;i<exp_kul_egesz;i++)
	{
		kisebb_kit[i] = 0;//eleje 0
		if(disp>2)mexPrintf("kisebb %d. rsze:\t%.20f\n",i,kisebb_kit[i]);
	}
	for(i=exp_kul_egesz;i<exp_kul_egesz+*number;i++)
	{
		kisebb_kit[i] = kisebb[i-exp_kul_egesz]*pow(2,exp_kul_egesz*mant_length);//aztn a szmok
		/*
		 a kisebbiket fel kell szorozni kett megfelel hatvnyval, mert mr eltoltuk valamennyivel
		 mennyivel? egszpontosan az exponensek klnbsgnl a rszeken belli darab kivtelvel
		 amit az exp_kul_egesz * mant_length brzol
		*/
		if(disp>2)mexPrintf("kisebb %d. rsze:\t%.20f\n",i,kisebb_kit[i]);
	}
	for(i=exp_kul_egesz+*number;i<2*(*number)-1;i++)
	{
		kisebb_kit[i] = 0;//majd mg nulla a biztonsg kedvrt.
		if(disp>2)mexPrintf("kisebb %d. rsze:\t%.20f\n",i,kisebb_kit[i]);
	}
	//4. brutal force sszeads
	for(i=0;i<2*(*number)-1;i++)
	{
		nagyobb_kit[i] = nagyobb_kit[i] + kisebb_kit[i];
		if(disp>2)mexPrintf("eredmny %d. rsze:\t%.20f\n",i,nagyobb_kit[i]);
	}
	//2*number-1 hossz vektor visszaadsa
	*number = nagyobb_hossz;
	return nagyobb_kit;
}





double* unnormBFP2normBFP(double *unnormBFP,int number,int mant_length,int mant_bp,int disp)//mantissa_breakingpoint
{

	/*
	egy plda a konvolci utnra
  0.
	1000100000000000
	        0111011100000000
	                0000000000000000
	                        0000001000010000
	                                0000000011101110
	                                        0000000000000000
	                                                0000000000000010
	                                                					exp 15

	ennek eredmnye
  0.
	10001000
	        01110111
	                00000000
	                        00000010
	                                00010000
	                                        11101110
	                                                00000000
	                                                        00000010
	kell legyen.
	azonban neknk szmok vannak s szmokkal dolgozunk.
	man(0):  0.531250
	man(1):  0.929688
	man(2):  0.000000
	man(3):  0.515625
	man(4):  0.929688
	man(5):  0.000000
	man(6):  0.500000
	exp(0):  15
	exp(1):  14
	exp(2):  0
	exp(3):  9
	exp(4):  7
	exp(5):  0
	exp(6):  1
	vagy normlisan kirva
	17408       15232           0         264         119           0           1
		*/
	int i,k;//segdvltozk
	double *szamsor,*unnormBFP2;//a normalizlt szmsor
	int *exponens,exponens_eltolas;//a normalizlatlan szmsor exponensei, hny bitenknt kell a mantisszt darabolni, az ered exponens
	double *mantissas,iszam,iszam_egeszresze,atvitel;//a unnorm mantisszk, az iedik pp vizsglt szm, egszrsze s a belle kpzett tvitel
	int elojel;
	int exponens_javito;

	unnormBFP2 = (double *)mxCalloc(number,sizeof(double));
	//meg kell vizsglni, hogy mi van az elejn. mivel lehet hogy negatv szm az egyik lehet hogy nullkkal kezddik, de mshol
	//pozitv s negatv is van. ezrt a legels nemnulla szm eljelhez kell igaztani a tbbit
    k=0;
	for(i = 0;i<number;i++)
	{
		if(unnormBFP[i]!=0)
		 k++;
	}
	if(k==0)//nincs nem nulla
	{
		szamsor = (double *)mxCalloc(number+1,sizeof(double));
		for(i = 0;i<number+1;i++)
		 szamsor[i] = 0;
		if(disp>0) mexPrintf("csak nullak vannak! visszatrs");
		return szamsor;
	}
	//amgy ha van javtjuk az elejn lv nullkat
	//javtjuk az elejn lv nullkat
	while(unnormBFP[0]==0)
	{
		if(disp>0)mexPrintf("egy nulla a elejerol torolve s az exponensek javitva\n");
		for(i=1;i<number;i++)
			unnormBFP[i-1] = unnormBFP[i]*pow(2,-mant_bp);
		unnormBFP[number-1] = 0;
	}


	//eljel megllaptsa, ered exponens megllaptsa
	if(unnormBFP[0]<0)
		elojel = -1;
	else
		elojel = +1;
	if(disp>1)mexPrintf("Sign recognised:%d\n",elojel);



//vektrorok
	mantissas = getAllMantissa(unnormBFP,number,disp);
	exponens = getAllExponent(unnormBFP,number,disp);


	//majd hrulrl visszafel mg egyet igaztunk
	//az igazts:
	//	ha az eljelnek nem megfelel szmot tallunk akkor kivonjuk egybl, s az eltte lev szegmensbl pedig levonunk a szmnl eggyel nagyobb bitet
	// vagyis: fogjuk a fordtott szmot: s az  exponensvel vonunk le.
	for(i=number-1;i>=1;i--)//a legels eljele biztos eljelhelyes!!
	{
		if((mantissas[i]<0)&&(elojel == 1))//ha negatv de az eljel pozitv
		{
			if(disp>0)mexPrintf("Elojel korrigalas (v1.2):\nmelyik szegmens:%d\n",i);
			if(disp>0)mexPrintf("mi volt a %d. mantissza:%.20f\n",i,mantissas[i]);
			mantissas[i] = 1+mantissas[i]; //hozzadunk egyet(ne felejtsuk, hogy negatv a szm) hoszabb nem lesz, mert ezzel sszeadva kapunk pont 1et.
			if(disp>0)mexPrintf("mi lett az %d. mantissza:%.20f\n",i,mantissas[i]);
			if(unnormBFP[i-1] == 0) //ha teljesen nulla a kvetkez szm akkor a javts nem j
			//javts on 2005.05.12 Happy birthday Eszter darling//
			{
                exponens_javito = exponens[i]-exponens[0]-mant_bp;		 
    			if(disp>0)mexPrintf("mi az elozo mantissza korriglsi helye#2:%.10d\n",exponens_javito);
				if(disp>0)mexPrintf("decimlisan:%.20f\n",pow(2,exponens_javito));
                exponens[i-1] = exponens[0];
			}
			else
			{
			    exponens_javito = exponens[i]-exponens[i-1]-mant_bp;
    			if(disp>0)mexPrintf("mi az elozo mantissza korriglsi helye:%.10d\n",exponens_javito);
				if(disp>0)mexPrintf("decimlisan:%.20f\n",pow(2,exponens_javito));
			}
			if(disp>0)mexPrintf("mi volt a %d. mantissza:%.20f\n",i-1,mantissas[i-1]);
			/*ha az i-1 negav akkor hozzadni, amgy levonni kell egyet.*/
			/*if((mantissas[i-1]<0))

			{
				mantissas[i-1] = mantissas[i-1] - pow(2,exponens[i]-exponens[i-1]-mant_bp);
			}
			else
			{
				mantissas[i-1] = mantissas[i-1] - pow(2,exponens[i]-exponens[i-1]-mant_bp);
			}*/

			mantissas[i-1] = mantissas[i-1] - pow(2,exponens_javito);

			if(disp>0)mexPrintf("mi lett a %d. mantissza:%.20f\n",i-1,mantissas[i-1]);



		}
		else
		if(mantissas[i]>0&&elojel == -1)//ha pozitiv s nem nulla(akkor nincs dolgunk, de az eljel negatv kne legyen.)
		{
			if(disp>0)mexPrintf("Elojel korrigalas (v1.2):\nmelyik szegmens:%d\n",i);
			if(disp>0)mexPrintf("mi volt a %d. mantissza:%.20f\n",i,mantissas[i]);
			mantissas[i] = -1+mantissas[i]; //levonunk egyet.(ill hozzadjuk) hoszabb nem lesz, mert ezzel sszeadva kapunk pont 1et.
			if(disp>0)mexPrintf("mi lett az %d. mantissza:%.20f\n",i,mantissas[i]);
			
            if(unnormBFP[i-1] == 0) //ha teljesen nulla a kvetkez szm akkor a javts nem j
			//javts on 2005.05.12 Happy birthday Eszter darling//
			{
                exponens_javito = exponens[i]-exponens[0]-mant_bp;		 
    			if(disp>0)mexPrintf("mi az elozo mantissza korriglsi helye#2:%.10d\n",exponens_javito);
				if(disp>0)mexPrintf("decimlisan:%.20f\n",pow(2,exponens_javito));
                exponens[i-1] = exponens[0];
			}
			else
			{
			    exponens_javito = exponens[i]-exponens[i-1]-mant_bp;
    			if(disp>0)mexPrintf("mi az elozo mantissza korriglsi helye:%.10d\n",exponens_javito);
				if(disp>0)mexPrintf("decimlisan:%.20f\n",pow(2,exponens_javito));
			}			
			if(disp>0)mexPrintf("mi volt a %d. mantissza:%.20f\n",i-1,mantissas[i-1]);
			/*ha az i-1 negav akkor levonni, amgy hozzadni kell egyet.*/
			/*if((mantissas[i-1]<0))
				mantissas[i-1] = mantissas[i-1] + pow(2,exponens[i]-exponens[i-1]-mant_bp);
			else
				mantissas[i-1] = mantissas[i-1] + pow(2,exponens[i]-exponens[i-1]-mant_bp);
			*/
			mantissas[i-1] = mantissas[i-1] + pow(2,exponens_javito);
			if(disp>0)mexPrintf("mi lett a %d. mantissza:%.20f\n",i-1,mantissas[i-1]);
		}
		if(mantissas[i-1]!=0)
		if(mantissas[i-1]>1 || mantissas[i-1]<-1)
		{
			if(disp>0)mexPrintf("szint korrigls a%d. szegmensben le\n",i-1);
			mantissas[i-1]=mantissas[i-1]/2;
			exponens[i-1]++;
		}
		else if(mantissas[i-1]<0.5 && mantissas[i-1]>-0.5)
		{
			if(disp>0)mexPrintf("szint korrigls a%d. szegmensben fel\n",i-1);
			mantissas[i-1]=mantissas[i-1]*2;
			exponens[i-1]--;
		}
	}
	if(disp>0)
	for(i=0;i<number;i++)
	{
	 mexPrintf("mantissza(%d):  %.20f\n",i,mantissas[i]);
	}
	if(disp>0)
	for(i=0;i<number;i++)
	{
	 mexPrintf("exponens(%d):  %d\n",i,exponens[i]);
	}




	for(i=0;i<number;i++)
	{
		unnormBFP2[i] = ldexp(mantissas[i],exponens[i]);
	}

    k=0;
	for(i = 0;i<number;i++)
	{
		if(unnormBFP2[i]!=0)
		 k++;
	}
	if(k==0)//nincs nem nulla
	{
		szamsor = (double *)mxCalloc(number+1,sizeof(double));
		for(i = 0;i<number+1;i++)
		 szamsor[i] = 0;
		if(disp>0) mexPrintf("csak nullak vannak! visszatrs");
		return szamsor;
	}
	//amgy ha van javtjuk az elejn lv nullkat
	//javtjuk az elejn lv nullkat
	while(unnormBFP2[0]==0)
	{
		if(disp>0)mexPrintf("(2)egy nulla a elejerol torolve s az exponensek javitva\n");
		for(i=1;i<number;i++)
			unnormBFP2[i-1] = unnormBFP2[i]*pow(2,-mant_bp);
		unnormBFP2[number-1] = 0;
	}


/*
-----------------------------------------------------------------------------------------------------------------------------------
*/


	mantissas = getAllMantissa(unnormBFP2,number,disp);
	exponens = getAllExponent(unnormBFP2,number,disp);
//vltozk
	atvitel = 0;//kezdeti tvitel 0
	iszam = 0;//kezdeti iszam 0
	iszam_egeszresze = 0;//s az egszrsze is 0
//lladk
	k = number+1;//k db szmbl maximum k+1 szm keletkezik
	exponens_eltolas = mant_bp;//a darabolst fent kaptuk meg (lehet hogy felesleges vltoz deklarci)
//kimenet
	szamsor = mxCalloc(k,sizeof(double));//memria hely lefoglals
//normalizls
	for(i = number-1;i>=0;i--)
	{
		/*
		az i. mantisszt felszorozzuk egssz. ezt gy tehetjk meg, hogy tudjuk az exponensen klnbsgt
		pl ha az exp(0) = 15 s az exp(i) = 7 akkor ez aezt jelenti, hogy 8db bit az elejn 0 volt.
		ennyivel leosztunk (ugye exp(i)-exp(0)van, de termszetesen ez elhet negatv is, s akkor szorunk)
		s akkor kerl az i.mantissza a megfelel helyre.
		az gy kapott szmok(a pldban)
		0.		0.531250 * 2^(15-15) =	0.53125000000000   binrisan 	0.1000100000000000 --> a helyre kerltek	0.1000100000000000
		1.		0.929688 * 2^(14-15) =  0.46484400000000				0.1110111000000000							0.0111011100000000
		2.		0.000000 * 2^(0-15)  =	0.00000000000000				0.0											0.0000000000000000
		3.		0.515625 * 2^(9-15)  =	0.00805664062500				0.1000010000000000							0.0000001000010000
		4.		0.929688 * 2^(7-15)  =  0.00363159375000				0.0000000011101110							0.0000000011101110
		5.		0.000000 * 2^(0-15)  =	0.00000000000000				0.0											0.0000000000000000
		6.		0.500000 * 2^(1-15)  =	0.000030517578125				0.1000000000000000							0.0000000000000010
		majd eltoljuk felfel mg annyi bittel(felszorozzuk) amennyi az exp_eltols(darabols)
		itt ez 8
		.1000100000000000 -->	10001000.00000000
		.0111011100000000		01110111.00000000
		.0000000000000000		00000000.00000000
		.0000001000010000		00000010.00010000
		.0000000011101110		00000000.11101110
		.0000000000000000		00000000.00000000
	    .0000000000000010		00000000.00000010

	    szmokkal
	    6.	0.007813
		5.	0.000000
		4.	0.929688
		3.	2.062500
		2.	0.000000
		1.	119.000000
		0.	136.000000
		*/
		iszam = mantissas[i]*pow(2,(exponens[i]-exponens[0]))*pow(2,exponens_eltolas);
		if(disp>0)mexPrintf("\t%d.iszam: %.20f\n",i,iszam);
		/*
		ekkor hozzadhatjuk az eddigi eltolst!
		majd kiszmoljuk az tvitelt: ennek a szmnak az egszrsze visszaosztva exp exp_eltolssal.
		ami a pont utn van (a trtrsz) az lesz a k. szm (ne felejtsk el, hogy eggyel tbb elemet adunk vissza s
		hogy a legutols darab(amit legelsnek szmolunk ki)alja kell legyen a legutols s a legelsp szm (amit legutoljra
		szmolunk ki) alja lesz a 2. darab, illetve az eredeti darabszmmal megegyez legels, s hogy ami marad tvitel
		lsd lejjeb, az lesz a plusz egy rsz.)
		*/
		iszam = iszam + atvitel;
		if(disp>1)mexPrintf("\t%d.iszam hozzadva az tvitelt: %.20f\n",i,iszam);
		if(iszam<0)iszam_egeszresze = ceil(iszam);
		else iszam_egeszresze = floor(iszam);
		if(disp>1)mexPrintf("\t%d.iszam egszrsze: %.20f\n",i,iszam_egeszresze);
		iszam -= iszam_egeszresze;
		if(disp>1)mexPrintf("\t%d.iszam maradka: %.20f\n",i,iszam);
		szamsor[--k] = iszam;
		if(disp>1)mexPrintf("\t%d.szam: %.20f\n",k,szamsor[k]);
		atvitel = iszam_egeszresze * pow(2,-1*exponens_eltolas);
		if(disp>1)mexPrintf("\t%d.tvitel: %.20f\n",i,atvitel);
		/*
		plda

		1.kr:
			eredeti tvitel:			.00000000	(0)
			eredeti szm:		00000000.00000010	(0.0078125)
			hozzadva:			00000000.00000010	(0.0078125)
			egszrsz(tvitel):	00000000.			(0)
			szm(trtrsz): 			.00000010	(0.0078125)
		2.kr:
			eredeti tvitel:			.00000000	(0)
			eredeti szm:		00000000.00000010	(0.000000)
			hozzadva:			00000000.00000000	(0.000000)
			egszrsz(tvitel):	00000000.			(0)
			szm(trtrsz): 			.00000000	(0.000000)
		3.kr:
			eredeti tvitel:			.00000000	(0)
			eredeti szm:		00000000.11101110	(0.929688)
			hozzadva:			00000000.11101110	(0.929688)
			egszrsz(tvitel):	00000000.			(0)
			szm(trtrsz): 			.11101110	(0.929688)
		4.kr:
			eredeti tvitel:			.00000000	(0)
			eredeti szm:		00000010.00010000	(2.062500)
			hozzadva:			00000000.00000010	(0.007813)
			egszrsz(tvitel):	00000010.			(2)
			szm(trtrsz): 			.00010000	(0.062500)
		5.kr:
			eredeti tvitel:			.00000010	(0.0078125)
			eredeti szm:		00000000.00000000	(0.000000)
			hozzadva:			00000000.00000010	(0.0078125)
			egszrsz(tvitel):	00000000.			(0)
			szm(trtrsz): 			.00000010	(0.0078125)
		6.kr:
			eredeti tvitel:			.00000000	(0)
			eredeti szm:		01110111.00000000	(119.0000)
			hozzadva:			01110111.00000000	(119.0000)
			egszrsz(tvitel):	01110111.			(119)
			szm(trtrsz): 			.00000000	(0.000000)
		7.kr:
			eredeti tvitel:			.01110111	(0.46484375)
			eredeti szm:		10001000.00000000	(136.0000)
			hozzadva:			10001000.01110111	(136.46484375)
			egszrsz(tvitel):	10001000.			(136)
			szm(trtrsz): 			.01110111	(0.46484375)
		vgn
			tvitel-->szm:				.10001000	(0.53125)

		a keletkez kimenet gy:
			.10001000	(0.53125)		-> normalizltan jelenik meg a Matlab-ban ->	0.53125			exp 0
			.01110111	(0.46484375)													0.9296875		exp -1
			.00000000	(0.000000)														0				exp 0
			.00000010	(0.0078125)														0.5				exp -6
			.00010000	(0.062500)														0.5				exp -3
			.11101110	(0.929688)														0.929688		exp 0
			.00000000	(0.000000)														0				exp 0
			.00000010	(0.0078125)														0.5				exp -6
			*/

	}
	//az utols tvitelt javtani kell
	szamsor[0] = atvitel;


	//majd javtani kell az exponenseket. mindegyikhez hozzadjuk az eredeti exp(0)-t
	//ha itt valamirt az utols tvitel nem 1xxxxx el kezddne akkor baj lenne:) de ez nem lehetsges. ezrt itt most
	//nincs tovbbi feladatunk a normlizlssal. sszeadsnl mr lehet hogy kelleni fog.
	for(i = 0;i<number+1;i++)
	{
		szamsor[i] = szamsor[i] * pow(2,exponens[0]);
	}

	return szamsor;




}

void mexFunction( int nlhs, mxArray *plhs[],
                  int nrhs, const mxArray *prhs[] )
{
	int mant_length,number,display;
	int *pnumber;
	double *z,*znorm,*a,*b;


	/*Check that it has two output argument, or none to display the result*/
	if(!(nlhs == 2 ||nlhs == 1 || nlhs==0))
	mexErrMsgTxt("Two or one output argument required or none to just display");

	/*Check that both inputs are row vectors*/
	if(!(nrhs == 2 | nrhs == 3 | nrhs == 4 | nrhs == 5))
	mexErrMsgTxt("Must be 2,3,4 or 5 argument. \n\t 1--> one ot the BFP array\n\t 2--> the other BFP array\n\t optional 3--> the numbers of the mantissa (degault is 22)\n\t optional 4--> the number of the elemnets in the BFPs. (default value is 5)\n\t optional 5--> display");

	/*if there are 3 input than the third must be a scalar int, to identify the dimension
	of the arrays*/
	/*the second is the number of bits in the BFP e.eg 22...44)*/
	//defaults;
	number = 5;
	pnumber = mxCalloc(1,sizeof(double));
	*pnumber = number;
	display = 0;
	mant_length = 22;
	//and now if it prefered to not use defaults
	if(nrhs>2)
	{
		double *length;
		length = mxGetPr(prhs[2]);
		mant_length = (int)*length;
	}
	if(nrhs>3)
	{
		double *d;
		d = mxGetPr(prhs[3]);
		number = (int)*d;
		*pnumber = number;

	}
	if(nrhs>4)
	{
		double *d;
		d = mxGetPr(prhs[4]);
		display = (int)*d;
	}
	if(nlhs==0) display=4;

	/*checking the proper format of the input vectors*/
    if(!isBFPNumber(prhs[0],number))
    mexErrMsgTxt("Input[0] must be a Big Floating Point format number");

	if(display>0)mexPrintf("first:\n");
	if(display>0)printBFP((double *)mxGetPr(prhs[0]),number,mant_length,mant_length,display);
	a = (double *)mxGetPr(prhs[0]);
	if(display>0)mexPrintf("second:\n");
	if(display>0)printBFP((double *)mxGetPr(prhs[1]),number,mant_length,mant_length,display);
	b = (double *)mxGetPr(prhs[1]);

	z = osszeadBFP(a,b,pnumber,mant_length,display);

	if(display>0)mexPrintf("after raw addition:\n");
	if(display>0)printBFP(z,*pnumber,(2*mant_length),mant_length,display);
	if(display>0)mexPrintf("normalizing:\n");
	znorm = unnormBFP2normBFP(z,*pnumber,(2*mant_length),mant_length,display);
	if(display>0)mexPrintf("after normalization:\n");
	if(display>0)printBFP(znorm,*pnumber+1,(mant_length),mant_length,display);





    //Defining output vectors


	if(nlhs==1)
	{
    	plhs[0] = mxCreateDoubleMatrix(1,*pnumber+1,mxREAL);
    	mxSetPr(plhs[0],znorm);
    }
    else
    {
		plhs[0] = mxCreateDoubleMatrix(1,*pnumber+1,mxREAL);
		mxSetPr(plhs[0],znorm);
    	plhs[1] = mxCreateScalarDouble(*pnumber+1);
	}
}
