function y = bindec(x)
%BINDEC            Simple binary to decimal conversion.
%  X must be a vector containing 1's and 0's. No other
%     numbers or characters are supported so BINDEC
%     able to convert only integers.
%     First position: MSB
%     Last position:  LSB
%
%BINDEC is used by the vector-to-segment function 'str2seg_core'

% Copyright (C) 2003, 2004 by Laszlo JUHASZ

error(nargchk(1,1,nargin))

% check input
if ~isa(x,'double') | (~isempty(x) & (prod(size(x))~=length(x) | ~all(x==0 | x==1)))
   error('Internal error. Bad arguments.')
end

y = sum(pow2(find(x(end:-1:1))-1));
