function bitovfgen_test
%BITOVFGEN_TEST    Test function for BITOVFGEN.

% Copyright (C) 2004 by Laszlo JUHASZ

testvect = {...
      % inputs: sign,code                       outputs: mant,exp
   0,'TYPE=''fixed-point'';CODING=''unsign'';PRECISION=[5];FRACTION=[0];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],4;                                      % fixed-point - unsign
   1,'TYPE=''fixed-point'';CODING=''unsign'';PRECISION=[5];FRACTION=[0];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],4;
   0,'TYPE=''fixed-point'';CODING=''unsign'';PRECISION=[5];FRACTION=[1];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],3;
   1,'TYPE=''fixed-point'';CODING=''unsign'';PRECISION=[5];FRACTION=[1];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],3;
   0,'TYPE=''fixed-point'';CODING=''unsign'';PRECISION=[5];FRACTION=[2];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],2;
   1,'TYPE=''fixed-point'';CODING=''unsign'';PRECISION=[5];FRACTION=[2];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],2;
   0,'TYPE=''fixed-point'';CODING=''unsign'';PRECISION=[5];FRACTION=[3];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],1;
   1,'TYPE=''fixed-point'';CODING=''unsign'';PRECISION=[5];FRACTION=[3];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],1;
   0,'TYPE=''fixed-point'';CODING=''unsign'';PRECISION=[5];FRACTION=[4];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],0;
   1,'TYPE=''fixed-point'';CODING=''unsign'';PRECISION=[5];FRACTION=[4];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],0;
   0,'TYPE=''fixed-point'';CODING=''unsign'';PRECISION=[5];FRACTION=[5];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],-1;
   1,'TYPE=''fixed-point'';CODING=''unsign'';PRECISION=[5];FRACTION=[5];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],-1;
   0,'TYPE=''fixed-point'';CODING=''ones-comp'';PRECISION=[5];FRACTION=[0];OVERFLOW=''clip'';', ...
      [1,1,1,1],3;                                        % fixed-point - ones-comp
   1,'TYPE=''fixed-point'';CODING=''ones-comp'';PRECISION=[5];FRACTION=[0];OVERFLOW=''clip'';', ...
      [1,1,1,1],3;
   0,'TYPE=''fixed-point'';CODING=''ones-comp'';PRECISION=[5];FRACTION=[1];OVERFLOW=''clip'';', ...
      [1,1,1,1],2;
   1,'TYPE=''fixed-point'';CODING=''ones-comp'';PRECISION=[5];FRACTION=[1];OVERFLOW=''clip'';', ...
      [1,1,1,1],2;
   0,'TYPE=''fixed-point'';CODING=''ones-comp'';PRECISION=[5];FRACTION=[2];OVERFLOW=''clip'';', ...
      [1,1,1,1],1;
   1,'TYPE=''fixed-point'';CODING=''ones-comp'';PRECISION=[5];FRACTION=[2];OVERFLOW=''clip'';', ...
      [1,1,1,1],1;
   0,'TYPE=''fixed-point'';CODING=''ones-comp'';PRECISION=[5];FRACTION=[3];OVERFLOW=''clip'';', ...
      [1,1,1,1],0;
   1,'TYPE=''fixed-point'';CODING=''ones-comp'';PRECISION=[5];FRACTION=[3];OVERFLOW=''clip'';', ...
      [1,1,1,1],0;
   0,'TYPE=''fixed-point'';CODING=''ones-comp'';PRECISION=[5];FRACTION=[4];OVERFLOW=''clip'';', ...
      [1,1,1,1],-1;
   1,'TYPE=''fixed-point'';CODING=''ones-comp'';PRECISION=[5];FRACTION=[4];OVERFLOW=''clip'';', ...
      [1,1,1,1],-1;
   0,'TYPE=''fixed-point'';CODING=''ones-comp'';PRECISION=[5];FRACTION=[5];OVERFLOW=''clip'';', ...
      [1,1,1,1],-2;
   1,'TYPE=''fixed-point'';CODING=''ones-comp'';PRECISION=[5];FRACTION=[5];OVERFLOW=''clip'';', ...
      [1,1,1,1],-2;
   0,'TYPE=''fixed-point'';CODING=''twos-comp'';PRECISION=[5];FRACTION=[0];OVERFLOW=''clip'';', ...
      [1,1,1,1],3;                                        % fixed-point - twos-comp
   1,'TYPE=''fixed-point'';CODING=''twos-comp'';PRECISION=[5];FRACTION=[0];OVERFLOW=''clip'';', ...
      [1],4;
   0,'TYPE=''fixed-point'';CODING=''twos-comp'';PRECISION=[5];FRACTION=[1];OVERFLOW=''clip'';', ...
      [1,1,1,1],2;
   1,'TYPE=''fixed-point'';CODING=''twos-comp'';PRECISION=[5];FRACTION=[1];OVERFLOW=''clip'';', ...
      [1],3;
   0,'TYPE=''fixed-point'';CODING=''twos-comp'';PRECISION=[5];FRACTION=[2];OVERFLOW=''clip'';', ...
      [1,1,1,1],1;
   1,'TYPE=''fixed-point'';CODING=''twos-comp'';PRECISION=[5];FRACTION=[2];OVERFLOW=''clip'';', ...
      [1],2;
   0,'TYPE=''fixed-point'';CODING=''twos-comp'';PRECISION=[5];FRACTION=[3];OVERFLOW=''clip'';', ...
      [1,1,1,1],0;
   1,'TYPE=''fixed-point'';CODING=''twos-comp'';PRECISION=[5];FRACTION=[3];OVERFLOW=''clip'';', ...
      [1],1;
   0,'TYPE=''fixed-point'';CODING=''twos-comp'';PRECISION=[5];FRACTION=[4];OVERFLOW=''clip'';', ...
      [1,1,1,1],-1;
   1,'TYPE=''fixed-point'';CODING=''twos-comp'';PRECISION=[5];FRACTION=[4];OVERFLOW=''clip'';', ...
      [1],0;
   0,'TYPE=''fixed-point'';CODING=''twos-comp'';PRECISION=[5];FRACTION=[5];OVERFLOW=''clip'';', ...
      [1,1,1,1],-2;
   1,'TYPE=''fixed-point'';CODING=''twos-comp'';PRECISION=[5];FRACTION=[5];OVERFLOW=''clip'';', ...
      [1],-1;
   0,'TYPE=''floating-point'';OVERFLOW=''inf'';', ...
      [1],Inf;                                        % inf - test
   1,'TYPE=''floating-point'';OVERFLOW=''inf'';', ...
      [1],Inf;
   0,'TYPE=''floating-point'';CODING=''ones-comp'';FRACTION=[4];EMAX=[100];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],100;                                % ones-comp
   1,'TYPE=''floating-point'';CODING=''ones-comp'';FRACTION=[4];EMAX=[100];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],100;
   0,'TYPE=''floating-point'';CODING=''sign-mag'';FRACTION=[4];EMAX=[100];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],100;                                % ones-comp
   1,'TYPE=''floating-point'';CODING=''sign-mag'';FRACTION=[4];EMAX=[100];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],100;
   0,'TYPE=''floating-point'';CODING=''twos-comp'';FRACTION=[4];EMAX=[100];OVERFLOW=''clip'';', ...
      [1,1,1,1,1],100;                                % ones-comp
   1,'TYPE=''floating-point'';CODING=''twos-comp'';FRACTION=[4];EMAX=[100];OVERFLOW=''clip'';', ...
      [1],101;
};

for k = 1:size(testvect,1)
   [t,u] = bitovfgen(testvect{k,1:2});
   if length(t)~=length(testvect{k,3}) | length(u)~=length(testvect{k,4}) | ...
         ~all(t==testvect{k,3}) | ~all(u==testvect{k,4})
      fprintf('!!! bitovfgen_test: %d. row error (test program row: %d)\n',k,2*k+6)
   end
end
