function bitup_test
%BITUP_TEST        Test function for BITUP.

% Copyright (C) 2004 by Laszlo JUHASZ

testvect = {...
      % inputs             outputs
   [0],0,1,                [0],0;
   [0,0,0],0,3,            [0,0,0],0;
   [0,0,1],0,3,            [0,0,1],0;
   [0,0,1],0,2,            [0,1],0;
   [0,0,1],0,1,            [1],0;
   [0,0,1],0,0,            [1],1;
   [0,0,1],0,-1,           [1],2;
   [0,0,1],0,-2,           [1],3;
   [0,1,1],0,3,            [0,1,1],0;
   [0,1,1],0,2,            [1],0;
   [0,1,1],0,1,            [1],0;
   [0,1,1],0,0,            [1],1;
   [0,1,1],0,-1,           [1],2;
   [0,1,0,1,0,1,1,0],0,10, [0,1,0,1,0,1,1,0],0;
   [0,1,0,1,0,1,1,0],0,9,  [0,1,0,1,0,1,1,0],0;
   [0,1,0,1,0,1,1,0],0,8,  [0,1,0,1,0,1,1,0],0;
   [0,1,0,1,0,1,1,0],0,7,  [0,1,0,1,0,1,1,0],0;
   [0,1,0,1,0,1,1,0],0,6,  [0,1,0,1,1],0;
   [0,1,0,1,0,1,1,0],0,5,  [0,1,0,1,1],0;
   [0,1,0,1,0,1,1,0],0,4,  [0,1,1],0;
   [0,1,0,1,0,1,1,0],0,3,  [0,1,1],0;
   [0,1,0,1,0,1,1,0],0,2,  [1],0;
   [0,1,0,1,0,1,1,0],0,1,  [1],0;
   [0,1,0,1,0,1,1,0],0,0,  [1],1;
   [0,1,0,1,0,1,1,0],0,-1, [1],2;
   [0,1,0,1,0,1,1,0],0,-2, [1],3;
   [0,0,0,1,1,1,1,1],0,9,  [0,0,0,1,1,1,1,1],0;
   [0,0,0,1,1,1,1,1],0,8,  [0,0,0,1,1,1,1,1],0;
   [0,0,0,1,1,1,1,1],0,7,  [0,0,1],0;
   [0,0,0,1,1,1,1,1],0,6,  [0,0,1],0;
   [0,0,0,1,1,1,1,1],0,5,  [0,0,1],0;
   [0,0,0,1,1,1,1,1],0,4,  [0,0,1],0;
   [0,0,0,1,1,1,1,1],0,3,  [0,0,1],0;
   [0,0,0,1,1,1,1,1],0,2,  [0,1],0;
   [0,0,0,1,1,1,1,1],0,1,  [1],0;
   [0,0,0,1,1,1,1,1],0,0,  [1],1;
};

for k = 1:size(testvect,1)
   [t,u] = bitup(testvect{k,1:3});
   if length(t)~=length(testvect{k,4}) | length(u)~=length(testvect{k,5}) | ...
         ~all(t==testvect{k,4}) | ~all(u==testvect{k,5})
      fprintf('!!! bitup_test: %d. row error (test program row: %d)\n',k,k+7)
   end
end
