function celldisint_test
%CELLDISINT_TEST   Test function for CELLDISINT.

% Copyright (C) 2004 by Laszlo JUHASZ

testvect = {...
      % inputs             outputs
   0,                                  {0};
   [],                                 {};
   [0,0],                              {[0,0]};
   {[0,0]},                            {[0,0]};
   {{{[0,0]}}},                        {[0,0]};
   {{{{{[0,0]}}}}},                    {[0,0]};
   {{0,{{{[0,0]}}}}},                  {0,[0,0]};
   {{1,{{2,{[3,4]}}}},5},              {1,2,[3,4],5};
   {{2,{{4,{[5,6]}},3}},1},            {2,4,[5,6],3,1};
};

for k = 1:size(testvect,1)
   t = celldisint(testvect{k,1});
   if ~isa(t,'cell') | (~isempty(t) & size(t,1)~=1)
      fprintf('!!! celldisint_test: %d. row error (tst prg. #%d): out isn''t cell\n',k,k+7)
   end
   u = testvect{k,2};
   for m = 1:length(t)
      if ~all(t{m} == u{m})
         fprintf('!!! celldisint_test: %d. row error (test program row: %d)\n',k,k+7)
      end
   end
end
