function y = clipgen(bits,exp,segnum)
%CLIPGEN           Segment-form clipped output
%Usage:
% Y = CLIPGEN(BITS,EXP,SEGNUM)
% Input arguments:
%     BITS   - how many ones in the clipped output
%     EXP    - exponent to be raised to
%     SEGNUM - number of segments -> the bits after BITS number of ones will be
%              padded with zero
%
% The output will be multiplied with two raised to EXP power, where the format
% of MANT is 1.111... so the output will be (1.111...)*2^(EXP)

% Copyright (C) 2003,2004 by JUHASZ Laszlo

fullone = sum(pow2(-1:-1:-22));
partone = sum(pow2(-1:-1:-rem(bits-1,22)-1));
nul = 0;
y = pow2([fullone(1,ones(floor(bits/22),1)),partone,...      % fullones + part one
      nul(1,ones(segnum-ceil(bits/22),1))].',exp+1);           % zeros
