function demo2
clc
disp('Demonstration of denormalized segments in case of extended ''double'' numbers')
disp('with precision 66, ''standard'' Emin -1022 and ''fix'' rounding.')

x = -1000:-1:-1200;
for k = 1:5
   for m = 1:length(x)
      y(k,m) = bitinseg(x(m),k)-22*(k-1);
   end
end
plot(x,y(1,:),'k-'),hold('on'),plot(x,y(2,:),'k--'),plot(x,y(3,:),'k-'),plot(x,y(4,:),'k--')
plot(x,y(5,:),'k-'),axis('auto')
title(sprintf(['Az egyes szegmensek bitszma az exponens fggvnyben\n',...
      'denormalizlt szmok esetn']))

for exp = -1020:-1:-1090
   % calculate length of mant
   if exp>=-1022
      mant = ones(1,66);
   else
      mant = ones(1,exp+1088);
      mant(66)=0;
   end
   %fprintf('%d %s\n',exp,char(mant+'0'))
   %fprintf('%d ',exp)
   % calculate mant segments
   segs = {};
   for k = 1:3
      segs = {segs{:},mant(1:bitinseg(exp,k))};
      mant(1:bitinseg(exp,k)) = [];
      %length(mant)
      %bitinseg(exp,k)
   end
   for k = 1:length(segs)
      t = segs{k};
      t = char(t+'0');
      if length(t)>=2
         u = t(2:end);
         t(end+1) = 0;
         t(2) = '.';
         t(3:end) = u;
      elseif length(t)==1
         t(2) = '.';
      end
      if ~isempty(t)
         fprintf('%23s @',t)
         if exp>=-1053
            fprintf('%5d ',exp)
         else
            fprintf('%5d ',exp+22*(k-1))
         end
      else
         fprintf('%23s        ',t)
      end
   end
   fprintf('\n')
end
