function [binvectout,e,longstr]=fixbin(binvect,qname,sign_k,e_ab)
%FIXBIN  Fix binary vector (leading, trailing, non-[0,1] elements, round)

error(nargchk(2,4,nargin))
e=0;
%-1's
ind=find(binvect<0);
while ~isempty(ind)
  binvect(ind)=binvect(ind)+2;
  binvect(ind-1)=binvect(ind-1)-1;
  ind=find(binvect<0);
end
if any(binvect>1)
  for k=length(binvect):-1:2
    if binvect(k)>1, binvect(k-1)=binvect(k-1)+floor(binvect(k)/2); binvect(k)=rem(binvect(k),2); end
  end
end
while (length(binvect)>0)&(binvect(1)>1)
  binvect=[floor(binvect(1)/2),binvect]; e=e+1;
  binvect(2)=rem(binvect(2),2); 
end
if isa(qname,'qdata'), qname=qname.name; end
prec=qget(qname,'precision');
if length(binvect)<prec, binvect=[binvect,zeros(1,prec-length(binvect))]; end
%Eliminate elements not equal to [0,1]
for k = length(binvect):-1:-prec
  if rem(binvect(max(k,1)),1)~=0, error('Non-integer element in vector'), end
  if binvect(max(k,1)) > 1
    if k>1
      binvect(k-1) = binvect(k-1) + floor(binvect(k)./2);
      binvect(k) = mod(binvect(k),2);
    else
      e=e+1;
      binvect=[floor(binvect(1)./2) binvect];
      binvect(2) = mod(binvect(2),2);
    end
  elseif binvect(max(k,1)) < 0
    if k>1
      binvect(k-1) = binvect(k-1) + floor(binvect(k)./2);
      binvect(k) = abs(mod(binvect(k),2));
    else
      error('Negative binvect')
    end
  end
end %for k

if nargout>=3
  if nargin<4, error('Not enough input arguments'), end
  longstr=setstr('0'+binvect);
  ei=-(e_ab+e);
  if ei>=0
    longstr=[longstr(1:ei+1),'(.)',longstr(ei+2:end)];
  elseif ei<0
    longstr=[longstr(1:-ei+1),'(.)',longstr(-ei+2:end)];  
  %elseif length(longstr)-1==-ei
  %else error('Cannot add ''(.)'' to string')
  end
  if isequal(sign_k,1), longstr=['+',longstr]; else longstr=['-',longstr]; end
  ind=find(longstr==')');
  if isempty(ind), ind=length(longstr)+1; end
  if ~isempty(ind),
    iv=[fliplr(ind+5:4:length(longstr)),ind-2-4:-4:2];
    for ii=iv, longstr=[longstr(1:ii-1),' ',longstr(ii:end)]; end
  end
end

%Leading zeros
while (length(binvect)>0)&(binvect(1)==0), e=e-1; binvect(1)=[]; end

%now round
if length(binvect)>prec
  if all(binvect(1:prec+1)==1)&any(binvect(prec+2:end)==1)
    %all ones
    e=e-1;
    binvect=[1,zeros(prec-1)];
  else
    if all(binvect(prec+1:end)==0) %zero
      %e=e-length(binvect(prec+1:end));
      binvect(prec+1:end)=[];
    elseif (binvect(prec+1)==0)&any(binvect(prec+2:end)==1) %0<x<0.5
      %e=e-length(binvect(prec+1:end));
      binvect(prec+1:end)=[];
    elseif (binvect(prec+1)==1)&all(binvect(prec+2:end)==0) %x=0.5
      if binvect(prec)==1, binvect(prec)=binvect(prec)+1; end
      binvect(prec+1:end)=[];
    else %>0.5
      binvect(prec)=binvect(prec)+1; binvect(prec+1:end)=[];
    end
  end
end 
%Elmininate again elements over 1
for k = length(binvect) : -1 : 2
  if(binvect(k) > 1)
    binvect(k-1) = binvect(k-1) + floor(binvect(k)./2);
    binvect(k) = mod(binvect(k),2);
  end
end
while (length(binvect)>0)&(binvect(1) > 1)
  binvect=[floor(binvect(1)./2) binvect];
  e=e+1;
  binvect(2) = mod(binvect(2),2);
end

%while binvect(1) > 1
%  binvect = [0 binvect];
%  binvect(1) = floor(binvect(2)./2);
%  binvect(2) = mod(binvect(2),2);
%end
%binvect = [binvect 0];
%e=e-1;
while (length(binvect)>1)&(binvect(1)==0)
  binvect(1)=[]; e=e-1;
end

binvectout=binvect;
