function procexp_test
%PROCEXP_TEST      Test function for PROCEXP.

% Copyright (C) 2004 by Laszlo JUHASZ

testvect = {...
      % inputs                                     outputs
   '1',                                            [],1;          % general
   '',                                             [],1;
   '0',                                            [],1;
   '1b',                                           1,0;           % binary
   '01b',                                          1,0;
   '00001b',                                       1,0;
   '-1b',                                          -1,0;
   '-01b',                                         -1,0;
   '-00001b',                                      -1,0;
   '010b',                                         2,0;
   '-010b',                                        -2,0;
   '-01d',                                         -1,0;          % decimal
   '01d',                                          1,0;
   '02d',                                          2,0;
   '20d',                                          20,0;
   '-32768d',                                      -32768,0;
   '01o',                                          1,0;           % octal
   '001o',                                         1,0;
   '002o',                                         2,0;
   '0020o',                                        16,0;
   '-20o',                                         -16,0;
   '01x',                                          1,0;           % hexadecimal
   '-011x',                                        -17,0;
   '-100x',                                        -256,0;
};

for k = 1:size(testvect,1)
   [t,u] = procexp(testvect{k,1});
   if (testvect{k,3} & (isempty(u) | ~isempty(t))) | ...
         (~testvect{k,3} & (~isempty(u) | isempty(t)))
      fprintf('!!! procexp_test: %d. row error (test program row: %d) error failure\n',k,k+7)
   elseif ~isempty(t) | ~isempty(testvect{k,2})
      if length(t)~=length(testvect{k,2}) | ~all(t==testvect{k,2})
         fprintf('!!! procexp_test: %d. row error (test program row: %d)\n',k,k+7)
      end
   end
end
