function [egesz,tort,err] = procmant_kp(mant)
%PROCMANT          Process mantissa.
%  Usage: [SIGN,MANT,EXPCORR,ERR] = PROCMANT(MANT)

% Copyright (C) 2004 by JUHASZ Laszlo

error(nargchk(1,1,nargin))

egesz = []; tort = [];  mant2 = []; err = '';

if ~ischar(mant) | (~isempty(mant) & size(mant,1)~=1)
   error('Bad arguments.')
end

if isempty(mant)
   err = 'Empty mantissa.';
   return
end

% filter out zeros
% if all(mant=='0')
%    sign = 1;
%    mant2 = 0;
%    return
% end

% deblank mant
mant(mant==' ') = '';
if isempty(mant), err = 'Mantissa contains only space(s).'; return, end

frpoint = findstr(mant,'.');
if isempty(frpoint), err = 'Mantissa does not contain any fractional point.'; return, end

egesz=mant(1:frpoint-1);
tort=mant(frpoint+1:end);

