function procmant_test
%PROCMANT_TEST     Test function for PROCMANT.

% Copyright (C) 2004 by Laszlo JUHASZ

testvect = {...
      % inputs                                     outputs
   '1',                                            [],[],[],1;          % general
   '',                                             [],[],[],1;
   '0',                                            [],[],[],1;
   '1d',                                           [],[],[],1;
   '1d.',                                          [],[],[],1;
   '1b',                                           1,[1],0,0;           % binary
   '01b',                                          1,[1],0,0;
   '00001b',                                       1,[1],0,0;
   '-1b',                                          -1,[1],0,0;
   '-01b',                                         -1,[1],0,0;
   '-00001b',                                      -1,[1],0,0;
   '010b',                                         1,[1],1,0;
   '-010b',                                        -1,[1],1,0;
   '-010101b',                                     -1,[1,0,1,0,1],4,0;
   '-010101.b',                                    -1,[1,0,1,0,1],4,0;
   '-01010.1b',                                    -1,[1,0,1,0,1],3,0;
   '-0101.01b',                                    -1,[1,0,1,0,1],2,0;
   '-010.101b',                                    -1,[1,0,1,0,1],1,0;
   '-01.0101b',                                    -1,[1,0,1,0,1],0,0;
   '-0.10101b',                                    -1,[1,0,1,0,1],-1,0;
   '-.010101b',                                    -1,[1,0,1,0,1],-2,0;
   '01o',                                          1,[1],0,0;           % octal
   '001o',                                         1,[1],0,0;
   '002o',                                         1,[1],1,0;
   '0020o',                                        1,[1],4,0;
   '-20o',                                         -1,[1],4,0;
   '-23402o',                                      -1,[1,0,0,1,1,1,0,0,0,0,0,0,1],13,0;
   '-23402.o',                                     -1,[1,0,0,1,1,1,0,0,0,0,0,0,1],13,0;
   '-2340.2o',                                     -1,[1,0,0,1,1,1,0,0,0,0,0,0,1],10,0;
   '-234.02o',                                     -1,[1,0,0,1,1,1,0,0,0,0,0,0,1],7,0;
   '-23.402o',                                     -1,[1,0,0,1,1,1,0,0,0,0,0,0,1],4,0;
   '-2.3402o',                                     -1,[1,0,0,1,1,1,0,0,0,0,0,0,1],1,0;
   '-.23402o',                                     -1,[1,0,0,1,1,1,0,0,0,0,0,0,1],-2,0;
   '01x',                                          1,[1],0,0;           % hexadecimal
   '-011x',                                        -1,[1,0,0,0,1],4,0;
   '-100x',                                        -1,[1],8,0;
   '-1001x',                                       -1,[1,0,0,0,0,0,0,0,0,0,0,0,1],12,0;
   '-1001.x',                                      -1,[1,0,0,0,0,0,0,0,0,0,0,0,1],12,0;
   '-100.1x',                                      -1,[1,0,0,0,0,0,0,0,0,0,0,0,1],8,0;
   '-10.01x',                                      -1,[1,0,0,0,0,0,0,0,0,0,0,0,1],4,0;
   '-1.001x',                                      -1,[1,0,0,0,0,0,0,0,0,0,0,0,1],0,0;
   '-.1001x',                                      -1,[1,0,0,0,0,0,0,0,0,0,0,0,1],-4,0;
};

for k = 1:size(testvect,1)
   [sign,mant,expcorr,err] = procmant(testvect{k,1});
   if (testvect{k,5} & (isempty(err) | ~isempty(mant))) | ...
         (~testvect{k,5} & (~isempty(err) | isempty(mant)))
      fprintf('!!! procmant_test: %d. row error (test program row: %d) error failure\n',k,k+7)
   elseif ~isempty(mant) | ~isempty(testvect{k,3})
      if length(sign)~=length(testvect{k,2}) | ~all(sign==testvect{k,2}) | ...
            length(mant)~=length(testvect{k,3}) | ~all(mant==testvect{k,3}) | ...
            length(expcorr)~=length(testvect{k,4}) | ~all(expcorr==testvect{k,4})
         fprintf('!!! procmant_test: %d. row error (test program row: %d)\n',k,k+7)
      end
   end
end
