function [y,e2] = rmnull(x,e1)
%RMNULL            Remove leading and trailing zeros from a binary vector.
%   Usage: [MANT2,EXP2] = RMNULLSTART(MANT1,EXP1)
%   During operation EXP1 is corrected and returned in EXP2

% Copyright (C) 2003,2004 by JUHASZ Laszlo

error(nargchk(2,2,nargin))

% checking input
if isempty(x) | isempty(e1) | prod(size(x))~=length(x) | prod(size(e1))~=1 |...
      ~(isa(x,'double')|isa(x,'logical')) | ~isa(e1,'double') | ~all(x==(~~x)) |...
      ~all(isfinite(x)) | ~isfinite(e1) | rem(e1,1)
   error('Bad arguments.')
end

ones = find(x);
if isempty(ones)
   y = 0;
   e2 = 0;
   return
end

y = x(min(ones):max(ones));
e2 = e1-min(ones)+1;
