function rmnull_test
%RMNULL_TEST       Test function for RMNULL.

% Copyright (C) 2004 by Laszlo JUHASZ

testvect = {...
      % inputs             outputs
   [0],0,                  [0],0;
   [0,0],0,                [0],0;
   [0,0,0,0],0,            [0],0;
   [1,0,0,0],0,            [1],0;
   [0,1,0,0],0,            [1],-1;
   [0,0,1,0],0,            [1],-2;
   [0,0,0,1],0,            [1],-3;
   [0,0,1,1],0,            [1,1],-2;
   [0,1,1,0],0,            [1,1],-1;
   [1,1,0,0],0,            [1,1],0;
   [1,1,1,0,0],0,          [1,1,1],0;
   [0,1,1,1,0,0],0,        [1,1,1],-1;
   [0,0,1,1,0,0],0,        [1,1],-2;
   [0,0,1,1,0,0],2000,     [1,1],1998;
   [0,0,0,0,0,1],-2000,    [1],-2005;
};

for k = 1:size(testvect,1)
   [t,u] = rmnull(testvect{k,1:2});
   if length(t)~=length(testvect{k,3}) | length(u)~=length(testvect{k,4}) | ...
         ~all(t==testvect{k,3}) | ~all(u==testvect{k,4})
      fprintf('!!! rmnull_test: %d. row error (test program row: %d)\n',k,k+7)
   end
end
