function str2seg_test
%STR2SEG_TEST      Test function for STR2SEG.

% Copyright (C) 2004 by Laszlo JUHASZ

testvect = {...
      % inputs: string, code             outputs: segment, of, uf, inv, warn, err
   '1b', ...                                 % some general tests
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [1,0;0,0],0,0,0,0,0;
   '0b', ...                                 % 2
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [0,0;0,0],0,0,0,0,0;
   'j10b@2d', ...                            % 3
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [0,0;8,0],0,0,0,0,0;
   'j', ...                                  % 4
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      0,0,0,0,0,1;
   '.', ...                                  % 5
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      0,0,0,0,0,1;
   'j.', ...                                 % 6
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      0,0,0,0,0,1;
   'infnan', ...                             % 7
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      0,0,0,0,0,1;
   'naninf', ...                             % 8
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      nan,0,0,0,0,0;
   'infinf', ...                             % 9
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      0,0,0,0,0,1;
   'nannan', ...                             % 10
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      0,0,0,0,0,1;
   '1.11111111111111111111111b@-126d', ...   % 11        denorm test with 'fix' rounding
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''fix'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [pow2(sum(pow2(0:-1:-21)),-126),pow2(sum(pow2(0:-1:-1)),-126);0,0],0,0,0,0,0;
   '1.11111111111111111111111b@-127d', ...   % 12
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''fix'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [pow2(sum(pow2(0:-1:-21)),-127),pow2(sum(pow2(0)),-127);0,0],0,0,0,0,0;
   '1.11111111111111111111111b@-128d', ...   % 13
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''fix'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [pow2(sum(pow2(0:-1:-21)),-128),0;0,0],0,0,0,0,0;
   '1.11111111111111111111111b@-129d', ...   % 14
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''fix'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [pow2(sum(pow2(0:-1:-20)),-129),0;0,0],0,0,0,0,0;
   '1.11111111111111111111111b@-130d', ...   % 15
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''fix'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [pow2(sum(pow2(0:-1:-19)),-130),0;0,0],0,0,0,0,0;
   '1.11111111111111111111111b@-131d', ...   % 16
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''fix'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [pow2(sum(pow2(0:-1:-18)),-131),0;0,0],0,0,0,0,0;
   '1.11111111111111111111111b@-132d', ...   % 17
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''fix'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [pow2(sum(pow2(0:-1:-17)),-132),0;0,0],0,0,0,0,0;
   '1.11111111111111111111111b@-148d', ...   % 18
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''fix'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [pow2(sum(pow2(0:-1:-1)),-148),0;0,0],0,0,0,0,0;
   '1.11111111111111111111111b@-149d', ...   % 19
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''fix'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [pow2(sum(pow2(0)),-149),0;0,0],0,0,0,0,0;
   '1.11111111111111111111111b@-150d', ...   % 20
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''fix'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [0,0;0,0],0,1,0,1,0;
   '1.11111111111111111111111b@127d', ...   % 21        overflow test
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''fix'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [pow2(sum(pow2(0:-1:-21)),127),pow2(sum(pow2(0:-1:-1)),127);0,0],0,0,0,0,0;
   '1.11111111111111111111111b@128d', ...   % 22
      ['SEGNUM=[2];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[24];',...
         'FRACTION=[23];INVSIGNAL=''neglect+nan'';OVERFLOW=''inf'';',...
         'OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
         'UFSIGNAL=''warning+count'';ROUNDING=''fix'';TREATHALF=''toeven'';',...
         'EMAX=[127];EMIN=[-126];QNOISE=''off'';'], ...
      [inf,inf;0,0],1,0,0,1,0;
};

for k = 1:size(testvect,1)
   [y,of,uf,inv,warn,err] = str2seg(testvect{k,1:2});
   if (testvect{k,8} & isempty(err)) | (~testvect{k,8} & ~isempty(err))
      fprintf('!!! str2seg_test: %d. row error: error failure\n',k)
      fprintf('real outputs are:\n')
      y,of,uf,inv,warn,err
   elseif (testvect{k,7} & isempty(warn)) | (~testvect{k,7} & ~isempty(warn))
      fprintf('!!! str2seg_test: %d. row error: warning failure\n',k)
   elseif (~isempty(y) | ~isempty(testvect{k,3})) & isempty(err) & ...
         ~any(any(isnan(testvect{k,3})))
      if ~all(size(y)==size(testvect{k,3})) | ~all(all(y==testvect{k,3})) | ...
            of~=testvect{k,4} | uf~=testvect{k,5} | inv~=testvect{k,6}
         fprintf('!!! str2seg_test: %d. row error\n',k)
         fprintf('expected outputs are:\n')
         testvect{k,3:end}
         fprintf('real outputs are:\n')
         y,of,uf,inv,warn,err
      end
   end
end
