function err = strchk_kp(x,valid,where)
%STRCHK            Check a string for valid characters.
%   ERR = STRCHK(X,VALID,WHERE) checks string X for valid characters that are
%      stored in VALID string. When string contains only valid characters then
%      ERR is empty else the error message is:
%      'Illegal character(s) 'xyz' in WHERE.'

% Copyright (C) 2004 by JUHASZ Laszlo

error(nargchk(3,3,nargin))

if ~ischar(x) | ~ischar(valid) | ~ischar(where) | isempty(valid) | ...
      isempty(where) | size(valid,1)~=1 | size(where,1)~=1
   error('Internal error. Bad arguments.')
end

err = '';
t = zeros(size(x));

for k = 1:length(valid)
   t = t | (x==valid(k));
end

if ~all(t)
   if sum(~t)>1
      err = ['Illegal characters ''',x(~t),''' in ',where,'.'];
   else
      err = ['Illegal character ''',x(~t),''' in ',where,'.'];
   end
end
