function [y,err] = strreplace(x)
%STRREPLACE        Replace / \ characters.
%  Usage: [X,ERR] = STRREPLACE(X)

% Copyright (C) 2004 by JUHASZ Laszlo

error(nargchk(1,1,nargin))

err = '';
y = '';

change = {
   '/'   '1'
   '\'   '0'
};

% generating slices
for k = 1:size(change,1)
   old = change{k,1};                % old value
   new = change{k,2};                % new value
   while any(findstr(x,old))
      pos = findstr(x,old);
      if rem(length(pos),2)
         err = ['Not even number of ''',old,''' replacement characters.'];
         return
      end
      if pos(2)<pos(1)+2
         err = ['Empty area between two ''',old,''' replacement characters.'];
         return
      end
      slice = x(pos(1)+1:pos(2)-1);       % the string containing decimal number
      %                                     between two replacement character
      x(pos(1)) = '%';                    % temporary change the actual repl. char
      % trying to feed input with sscanf
      [ssx,ssn,sserr] = sscanf(slice,'%d');
      % checking value
      if ~isempty(sserr)
         err = ['Error by sscanf in slice ',old,slice,old,': ',sserr];
         return
      end
      if ssn~=1
         err = ['The number of values in slice ',...
               old,slice,old,' read by sscanf is not 1.'];
         return
      end
      if isempty(ssx) | ~isa(ssx,'double') | (prod(size(ssx))~=1)
         err=['Empty, not numeric or not scalar value in slice ',old,slice,old,'.'];
         return
      end
      if ~isfinite(ssx) | (rem(ssx,1)~=0) | ssx<1
         err = ['Nonfinite, noninteger or smaller than one value in slice ',...
               old,slice,old,'.'];
         return
      end
      % change the already processed slice to protect from further processing
      x = strrep(x,['%',slice,old],repmat(new,1,ssx));
   end
end

y = x;
