function strreplace_test
%STRREPLACE_TEST   Test function for STRREPLACE.

% Copyright (C) 2004 by Laszlo JUHASZ

testvect = {...
      % inputs                      outputs
   'abcdefghijklmnop',              'abcdefghijklmnop',0;
   'abcdefgh/ijklmnop',             '',1;
   'abcdefgh//ijklmnop',            '',1;
   'abcdefgh/a/ijklmnop',           '',1;
   'abcdefgh/0/ijklmnop',           '',1;
   'abcdefgh/inf/ijklmnop',         '',1;
   'abcdefgh/2e3/ijklmnop',         '',1;
   'abcdefgh/3/ijklmnop',           'abcdefgh111ijklmnop',0;
   'abcdefgh/10/ijk\2\lmnop',       'abcdefgh1111111111ijk00lmnop',0;
   'ab\8\cdefgh/10/ijk\2\lmno/4/p', 'ab00000000cdefgh1111111111ijk00lmno1111p',0;
};

for k = 1:size(testvect,1)
   [t,u] = strreplace(testvect{k,1});
   if (testvect{k,3} & isempty(u)) | ...     % there should be error and there isn't
         (~testvect{k,3} & ~isempty(u))      % there shouldn't be error and there is
      fprintf('!!! strreplace_test: %d. row error (test program row: %d) error failure\n',k,k+7)
   elseif ~isempty(t) | ~isempty(testvect{k,2})
      if length(t)~=length(testvect{k,2}) | ~all(t==testvect{k,2})
         fprintf('!!! strreplace_test: %d. row error (test program row: %d)\n',k,k+7)
      end
   end
end
