function out = randn(obj,mod)
%RANDN   Normally distributed quantized data

if nargin<2, mod=''; end
data=obj.data;

prec=qget(obj.name,'precision');
if strcmp(mod,'range')
  xmax=get(obj,'maximum');
  if isempty(xmax), xmax=pow2(2-2^(-prec+1),Emax); end
  xmin=get(obj,'minimum');
  if isempty(xmin), xmin=-pow2(2-2^(-prec+1),Emax); end
  xmean=(xmax+xmin)/2;
  xscale=(xmax-xmin)/2;
  xscale=xscale/4; %max random number: 4*sigma RANDN/RAND
elseif isempty(mod)
  xmean=0; xscale=1;
else error(['mod = ''',mod,''' is not allowed'])
end
out.data=inf;
while any(~isfinite(out.data))
  data=xscale*randn(size(data(1,:,:,:)))+xmean; %RANDN/RND
  out=qdata(data,obj.name);
end

if prec>53
  out=out+pow2(xscale,-53)*rand(size(obj.data(1,:,:,:)));
end
if prec>106
  out=out+pow2(xscale,-106)*rand(size(obj.data(1,:,:,:)));
end
