function y = isquant(x)
%ISQUANT   Checks whether a string is a valid quantizer name or not.
%   ISQUANT returns 1 if the given string is a valid quantizer name and 0 if not.

% Copyright (C) 2003 by JUHASZ Laszlo

error(nargchk(1,1,nargin))
y = 0;

if ~ischar(x) | isempty(x) | size(x,1)~=1
   return
   error('Empty or not row character string input.')
end

try
  Q=quantizers('get',x);
  if ~isempty(Q), y=1;
  else y=0;
  end
catch
  y=0;
end
return

% get quantizers
[t,err] = quantizers('get','-all');
if isempty(t), y=0; err=''; return, end %not found
if ~isempty(err), error('Internal error 1'), end
for k = 1:length(t)
   if strcmp(x,t(k).name)
      y = 1;
      return
   end
end
