function y = celldisint(x)
%CELLDISINT        Recursive disintegration of a cell into parts and recomposing into one big cell.
%     WARNING!: This function has TWO instances in the qdsp distrib so if you alter
%               one please overwrite the other with the altered new one.

% Copyright (C) 2003, 2004 by Laszlo JUHASZ

error(nargchk(1,1,nargin))

if isa(x,'cell')
   if isempty(x)
      y = x;
   else
      y = {};
      for k = 1:length(x)
         addend = celldisint(x{k});
         y = {y{:}, addend{:}};
      end
   end
else
   if isempty(x)
      y = {};
   else
      y = {x};
   end
end
