function err = check_fraction(x,s)
%CHECK_FRACTION    Checker function for the 'fraction' property

% Copyright (C) 2003,2004 by JUHASZ Laszlo

err = '';
switch s.type
case 'fixed-point'
   if x<0
      err = 'can''t be smaller than zero.';
      return
   end
   switch s.coding
   case 'unsign'
      if x>s.precision
         err = 'can''t be greater than ''precision''.';
         return
      end
   case {'ones-comp','twos-comp'}
      if x>(s.precision-1)
         err = 'can''t be greater than ''precision''-1.';
         return
      end
   otherwise
      error('Internal error 1')
   end
case 'floating-point'
   switch s.leadingbit
   case 'hidden'
      if x~=s.precision-1
         err = 'For leadingbit ''hidden'' fraction must be precision-1.';
         return
      end
   case 'shown'
      if x~=s.precision-2
         err = 'For leadingbit ''shown'' fraction must be precision-2.';
         return
      end
   end
otherwise
   error('Internal error 2')
end
