function y = codegen(q)
%CODEGEN           Generates short character-coded format from the long struct-coded format

% Copyright (C) 2003, 2004 by JUHASZ Laszlo

y = [];
if isempty(q) | ~isa(q,'struct'), error('Internal error 1'), end
% obtain fieldnames
fields = fieldnames(q);
% step by structure vector elements
for k = 1:length(q)
   u = '';
   % step by element's fieldnames
   for m = 1:length(fields)
      % obtain field data
      t = eval(['q(',num2str(k),').',fields{m}]);
      if m==1
         % 'name' must be treated separately
         name = t;
      else
         switch class(t)
         case 'char'
            % for example when CODING='sign-mag';
            u = [u,upper(fields{m}),'=''',t,''';'];
         case 'double'
            % for ex. EMAX=[15];
            if length(t)<=1
              u = [u,upper(fields{m}),'=[',num2str(t),'];'];
            else
              tstr=[];
              %for ii=1:length(t), tstr=[tstr,';',num2str(t(ii))]; end
              for ii=1:length(t), tstr=[tstr,';',sprintf('%.22g',t(ii))]; end
              tstr(1)='';
              u = [u,upper(fields{m}),'=[',tstr,'];'];              
            end
           otherwise error('Internal error 2')
         end
      end
   end
   u=[u,'FRACTION=FRACTIONBITS;'];
   % temporary executing variables to compute SEGNUM
   eval(u)
   switch TYPE
   case 'fixed-point'
      switch CODING
      case {'unsign','twos-comp'}
         segnum = ceil(PRECISION/22);
      case 'ones-comp'
         segnum = ceil((PRECISION-1)/22);
      otherwise
         error(['Internal error. Unsupported coding ',CODING])
      end
   case 'floating-point'
      segnum = ceil((FRACTION+1)/22);
   otherwise
      error(['Internal error. Unsupported type ',TYPE])
   end
   % generating the 'name' and 'segnum' component
   pluss = ['NAME=''',name,''';SEGNUM=[',num2str(segnum),'];'];
   % creating a struct with field names of quants' names
   eval(['y.',name,'=[pluss,u];'],'error(sprintf([''Internal error:\n%s'',lasterr]))')
end
