function eredm = dec2vbin(who)
%DEC2VBIN   Simple decimal to binary vector conversion.
%
%       eredm = dec2vbin(who)
%
% who may be a single double, vector or matrix with any dimension.
% the result will have binary places separeted
% so the size of the result will be : size(result) = size([who 54])
% if there is imag part and real part of the imput argument then the size
% will be : size(result) = size([who 54 2])
% the 54. element contains the exponent
%   First position: MSB
%   Last position:  LSB
%   54. position:   EXP
% example(1)
%   dec2vbin(343)
%   -> [1 0 1 0 1 0 1 1 1 ]
%
%
%
%
% Copyright (C) 2004 by Sndor Rvsz


%First determining the sizes
ndimsWho = ndims(who);
SizeWho = size(who);
%determining if there are any imag and real part
imagWho = imag(who);
realWho = real(who);

if (imagWho == 0 & realWho == 0)
    eredm = '';
    return
end
%if ~iszeros(imagWho)
if any(imagWho(:))
    doImag = 1;
else
    doImag = 0;
end
%if ~iszeros(realWho)
if any(realWho(:))
  doReal = 1;
else
    doReal = 0;
end

if(doReal)&(doImag)
    eredm = zeros([SizeWho 54 2]);
else
    eredm = zeros([SizeWho 54 1]);
end
    

%separating imag and real part
if(doReal)
    [rwhomant,rwhoexp] = log2(realWho);
end
if(doImag)
    [iwhomant,iwhoexp] = log2(imagWho);
end

%making dec2bin
if(doReal)
    rbinarystring = dec2bin(rwhomant*2^53,53);
    rbinarystring = reshape(rbinarystring,[SizeWho 53]);
end
if(doImag)
    ibinarystring = dec2bin(iwhomant*2^53,53);
    ibinarystring = reshape(ibinarystring,[SizeWho 53]);
end



%separating binaryplaces
if(doReal)
    rbin = binvect(rbinarystring);
end
if(doImag)
    ibin = binvect(ibinarystring);
end


if(doReal)&(doImag)
    %cat the exponent
    whoexp = cat(ndimsWho+2,rwhoexp,iwhoexp);
    %puting the output vectors together
    whobin = cat(ndimsWho+2,rbin,ibin);
else
    %only one part present
    if(doImag)
        %only imag part present
        whobin = ibin;
        whoexp = iwhoexp;
    else
        %only real part
        whobin = rbin;
        whoexp = rwhoexp;
    end
end

%cat the mant and thec exponent
eredm = cat(ndimsWho+1,whobin,whoexp);






function eredmeny = binvect(binstring)
%this function creates a binary vector from a string that contains only 1s and zeros, and the length is 53

if ~all(ischar(binstring))
%detects if there is a non-string
 warning('There is a non-string in dec2vbin.binvect.1');
end

%eredmeny = zeros(1,length(binstring));
eredmeny = binstring-48;

