function y = def_emax(s)
%DEF_EMAX          Default generator function for the 'emax' property

% Copyright (C) 2003, 2004 by JUHASZ Laszlo

switch s.type
case 'fixed-point', y = [];
case 'floating-point'
	if strcmp(s.name,'single')
		y=127;
	else
		switch s.expcoding
			case {'ones-comp' 'sign-mag' 'twos-comp'}
				if strcmp(s.overflow,'clip') & strcmp(s.nansignal,'error')
					% no need of clipping out the greatest possible value for nan or inf
					yesinput = max(-1053,min(1023,pow2(s.expbits-1)-1));
				else
					% the greatest possible value is reserved for inf or nan or both
					y = max(-1053,min(1023,pow2(s.expbits-1)-2));
				end
			case 'biased'
				if strcmp(s.overflow,'clip') & strcmp(s.nansignal,'error')
					% no need of clipping out the greatest possible value for nan or inf
					%y = max(-1053,min(1023,pow2(s.expbits)-1-s.expbias));
					y=1023;
				else
					% the greatest possible value is reserved for inf or nan or both
					%y = max(-1053,min(1023,pow2(expbits)-2-s.expbias));
					y=1023;
				end
			otherwise
				error('Internal error 1')
		end
		if strcmp(s.coding,'twos-comp')
			% protect from 2@1023 situation
			y = min(y,1022);
		end
	end
otherwise
	error('Internal error 2')
end