function y = def_emin(s)
%DEF_EMIN          Default generator function for the 'emin' property

% Copyright (C) 2003, 2004 by JUHASZ Laszlo

switch s.type
case 'fixed-point', y = [];
case 'floating-point'
  if strcmp(s.name,'single')
				y=-126;
	else
		switch s.expcoding
			case {'ones-comp' 'sign-mag'}
				% the smallest possible value is reserved for denorm numbers or zero
				%y = max(-1053,min(1023,-(pow2(s.expbits-1)-2)));
				y=-1022;
			case 'twos-comp'
				% the smallest possible value is reserved for denorm numbers or zero
				%y = max(-1053,min(1023,-(pow2(s.expbits-1)-1)));
				y=-1022;
			case 'biased'
				% the smallest possible value is reserved for denorm/zero
				%y = max(-1053,min(1023,1-s.expbias));
				y=-1022;
			otherwise
				error('Internal error 1')
		end
	end
otherwise
	error('Internal error 2')
end
