function y = def_expbias(s)
%DEF_EXPBIAS       Default generator function for the 'expbias' property

% Copyrigth (C) 2003 by JUHASZ Laszlo

switch s.type
case 'fixed-point'
   y = [];
case 'floating-point'
   if strcmp(s.expcoding,'biased')
      expbits=ceil(log2(s.emax-s.emin));
      y = pow2(expbits-1)-1;
      if isempty(y)
				if strcmp(s.name,'single'), y=127;
				else y=1023;
				end
			end
   else
      y = [];
   end
otherwise
   error('Internal error 1')
end
