function double_rounding
%DOUBLE_ROUNDING  Illustration of double rounding

qclear all
x1=(1+2^(-27))*2^3;
x2=bin2num('1.1111 1111 1111 1111 1111 1111 000','nowarning')*2^(-26);
%
%This is the erroneous calculation with double rounding
Q28=qstruct('Q28','precision',28);
disp('First number in roundoff:')
num2bin(x1,Q28)
disp('Second number in roundoff:')
num2bin(x2,Q28)
x=x1+x2;
disp('Sum in Matlab:')
num2bin(x)
xqr=roundq(x,Q28);
disp('Result rounded in roundoff:')
num2bin(xqr,Q28)
%
%This is the proper calculation using QDSP
qmake('QDSP','precision',56);
x1obj=qdata(x1,'QDSP');
x2obj=qdata(x2,'QDSP');
disp('Summation in QDSP:')
xobj=x1obj+x2obj
qmake('QDSP28','precision',28)
disp('Object rounded to 28 bits:')
xqd=qdata(xobj,'QDSP28')
disp('Difference:')
xdiff=xqr-double(xqd), epsr=lsb(xqr,Q28), epsd=lsb(xqd)