function Y = IIRD(B,A,X)
%IIRD  Simulation of IIR algorithm with quantized numbers

qnull = qdata(0,get(X,'name'));
M = length(B);
N = length(A);
K = length(X);

if(strcmp(class(X),'qdata'))
    Y = qnull;
else
    Y = 0;
end

for k = 0 : K-1
    
    if(strcmp(class(X),'qdata'))
        bx = qnull;
    else
        bx = 0;
    end
    for m = 0 : min(M-1,k)
        bx = bx + B(m+1)*X(k-m+1);
    end
    
    if(strcmp(class(X),'qdata'))
        ay = qnull;
    else
        ay = 0;
    end
    for n = 1 : min(N-1,k)
        ay = ay + A(n+1)*Y(k-n+1);
    end
    
    Y(k+1) = bx-ay;
end