function ki = mandelbrot(resx,resy,dep,x0,y0,x1,y1)
%MANDELBROT

if(nargin<1) resx = 100; end;
if(nargin<2) resy = 100; end;
ki = zeros(resx,resy);
k = 0
if(nargin<3) dep = 30; end;
if(nargin<4) x0 = 1; end;
if(nargin<5) y0 = 1; end;
if(nargin<6) x1 = 1; end;
if(nargin<7) y1 = 1; end;
for x = -x0 : 2/resx :x1
    for y = -y0 : 2/resy :y1
        u=round((x+x0)*resx+1);
        v=round((y+y0)*resy+1);
        szin = Iterate(x,y,dep)/dep;
        ki(u,v,1) = szin;
        ki(u,v,2) = szin;
        ki(u,v,3) = szin;
    end
    if(mod(x,resx/100)==0)
        k = k + 1
    end
end
return;



function i = Iterate(xi,yi,imax)
x = 0;
y = 0;
samecount = 0;
for i = 0: imax
    xnew = x * x - y * y + xi;
    ynew = 2 * x * y + yi;
    if (xnew*xnew + ynew*ynew > 4)
        return;
    end
    if (abs(xnew-x) < 0.0000001 & abs(ynew-y) < 0.0000001)
        samecount = samecount + 1;
    else
        samecount = 0;
    end
    if (samecount > 10)
        i = imax;
        return ;
    end
    x = xnew;
    y = ynew;
end
i = imax;
return ;