function valasz = mandelbrot2(resx,resy,x0,y0,x1,y1)
%MANDELBROT2

if(nargin<1) resx = 100; end;
if(nargin<2) resy = 100; end;
if(nargin<3) dep = 30; end;
if(nargin<4) x0 = 1; end;
if(nargin<5) y0 = 1; end;
if(nargin<6) x1 = 1; end;
if(nargin<7) y1 = 1; end;
k = 0;

global ki
global ertek
global jellemzok 
ki = zeros(2*resx+1,2*resy+1);%kiement, az itercik szma
ertek = zeros(2*resx+1,2*resy+1);%az u,v koordintly hely rtke
jellemzok = ones(2*resx+1,2*resy+1);%kell e szmolni az adott pontot vagy sem




%nullrtkek kitltse
    for x = -x0 : 2/resx :x1%vgig x-n
        for y = -y0 : 2/resy :y1%vgig y-n
              [u,v] = mutato(x,y,x0,y0,resx,resy);
              ertek(u,v) = x+j*y;
        end
    end



do_more  = true;
%ciklus 
for k = 0 : 10
    for x = -x0 : 2/resx :x1%vgig x-n
        for y = -y0 : 2/resy :y1%vgig y-n
            [u,v] = mutato(x,y,x0,y0,resx,resy);
            szamol(ertek(u,v),x+j*y,k,x0,y0,resx,resy);
        end
    end
    k
end
            
valasz = ki
return;
%--------------------------------------------
function z = f(z,z0)
    z = z^ 2 + z0;
return;
%--------------------------------------------
function szamol(z,z0,k,x0,y0,resx,resy)
    global ki
    global ertek
    global jellemzok 
    
    [u,v] = mutato(real(z),imag(z),x0,y0,resx,resy);
    z = f(z,z0);
    
    if(abs(z)>=2)%ha elszllt akkor
        jellemzok(u,v)=0;
        ki(u,v) = k;
        return;
    end
    
    [u_pointer,v_pointer] = mutato(real(z),imag(z),x0,y0,resx,resy);%akire mutatok nem ltezik, kimutat teht elszllt
    if(u_pointer>2*resx+1 | v_pointer>2*resy+1)
           jellemzok(u,v)=0;
            ki(u,v) = k;
            return;
    end
        
    if(jellemzok(u_pointer,v_pointer))
        %1 teht mg nem szllt el
        ertek(u,v) = z;
    else%akire mutat elszllt teht n is elszllok
        %0 teht elszllt
        jellemzok(u,v)=0;        
        ki(u,v) = k;
    end
return
%--------------------------------------------
function [u,v] = mutato(x,y,x0,y0,resx,resy)
if(x<0)
    u=floor((x+x0)*resx/2)+1;
else
    u=ceil((x+x0)*resx/2)+1;
end
if(y<0)
    v=floor((y+y0)*resy/2)+1;
else
    v=ceil((y+y0)*resy/2)+1;    
end
return
%--------------------------------------------