function ki = mandelbrot(resx,resy,dep,x0,y0,x1,y1)
%MANDELBROT_QDATA

if(nargin<1) resx = 100; end;
if(nargin<2) resy = 100; end;
ki = zeros(resx,resy);
k = 0;
if(nargin<3) dep = 30; end;
if(nargin<4) x0 = 1; end;
if(nargin<5) y0 = 1; end;
if(nargin<6) x1 = 1; end;
if(nargin<7) y1 = 1; end;
kmax = (resx*2+1)*(resy*2+1);
kmax = kmax/100;
percent = 0;
x_lepes = (x1-x0)/resx;
y_lepes = (y1-y0)/resy;

for x = x0 : x_lepes :x1
    for y = y0 : y_lepes :y1
        u=round((x-x0)/x_lepes+1);
        v=round((y-y0)/y_lepes+1);
        szin = Iterate(x+j*y,dep);
        ki(u,v) = szin;
    end
    k = k + 1
end
return;



function i = Iterate(z0,imax)
z = qdata(z0,'BigFP');
for i = 0 : imax
    z = z*z + z0;
    if (real(z)*real(z)+imag(z)*imag(z)>=4)
        return;
    end
end
return ;