function sin_test_main
%SIN_test_MAIN  Main routine to test sine

disp('Test sin_test_main is running ...')

disp('Testing sin function of the QDSP Toolbox')
disp('Basic idea:');
disp('sin(alpha+beta) = sin(alpha)*cos(beta)+cos(alpha)*sin(beta)');
disp('The maximum possible error:')
disp(' ')
disp('Maximum error of the left group')
disp('ulp(alpha+beta) ./ 2*abs(cos(alpha+beta)) + ulp(sin(alpha+beta))')
disp(' ')
disp('Maximum error of the right group')
disp('First term:')
disp('ulp(sin(alpha)) * abs(cos(beta)) + abs(sin(alpha)) * ulp(cos(beta)) ...');
disp('Second term:')
disp('+ ulp(cos(alpha)) * abs(sin(beta)) + abs(cos(alpha)) * ulp(sin(beta)) ...');
disp('Addition:')
disp('+ ulp(sin(alpha) * cos(beta)      + cos(alpha)      * sin(beta))./2');
disp(' ')
disp('Calculation is OK if the error is smaller than the sum of error limits.')
disp('Result returned: maximum error - actual error. (The error is really small.)');
disp('The test is running until the error is under the limit.');
disp('(The demo executes 10 evaluations.)')
k = 0;
z = 1;
while(k<10 & double(z)) 
    [z err] = q_sin_test
    k = k + 1;
end
