function test_all_roundoffs(mode)
%TEST_ALL_ROUNDOFFS  Test different roundoffs (roundoff, qdsp, fptb)

%       Last edited: 11-Apr-2007, IK

qclear all
if nargin==0, mode=''; end
Bv=15:111;
x=[]; xf=[]; xd=[];
disp('---------------------------------------')
disp('Test different toolboxes against each other ...')
for Qc={'Qint','Qfrac','Qfrac10','Qfloat'}
%for Qc={'Qfloat'}
  %for roundmode={'convergent'}
  for roundmode={'convergent','round','fix','floor','ceil','nearest'}
    roundmode=roundmode{1};
    disp(['Quantizer: ',Qc{1},', roundmode: ',roundmode])
    if strcmp(roundmode,'convergent'), roundingdir='round'; treathalf='toeven';
    elseif strcmp(roundmode,'round'), roundingdir='round'; treathalf='toinf';
    elseif strcmp(roundmode,'trunc'), roundmode='floor'; roundingdir='trunc'; treathalf='trunc';
    elseif strcmp(roundmode,'fix'), roundingdir='fix'; treathalf='fix';
    elseif strcmp(roundmode,'floor'), roundingdir='floor'; treathalf='floor';
    elseif strcmp(roundmode,'ceil'), roundingdir='ceil'; treathalf='ceil';
    elseif strcmp(roundmode,'nearest'), roundingdir='round'; treathalf='ceil';
    else error('cannot set roundmode')
    end
    if strcmp(mode,'fast'), Bv=15+round(10*rand(1,1)):31:111; end
    %if strcmp(mode,'fast'), Bv=17:31:111; end %for debugging
    for B=Bv
      p=B-1; fb=p-1;
      dig=ceil(log10(2^p)); fpform=[' = %',num2str(dig),'.4f\n'];
      if strcmp(Qc{1},'Qint')
        qtype='fixed-point'; fb=0;
      elseif strcmp(Qc{1},'Qfrac')
        qtype='fixed-point'; fb=B-1;
      elseif strcmp(Qc{1},'Qfrac10')
        qtype='fixed-point'; fb=10;
      elseif strcmp(Qc{1},'Qfloat')
        qtype='floating-point';
      else
        %1
      end
      qclear all
      if ~strcmp(Qc{1},'Qfloat')
        if B<=54
          Qround=qstruct('Qround','type',qtype,'Bits',B,'fractionbits',fb,'roundingdir',roundingdir,'treath',treathalf); %Qround
        end
        Qdsp=qmake('Qdsp','type',qtype,'bits',B,'fractionbits',fb,'roundingdir',roundingdir,'treath',treathalf);
        Qdsp111=qmake('Qdsp111','type',qtype,'bits',111,'fractionbits',min(110,fb+3),'roundingdir',roundingdir,'treath',treathalf);
        if exist('\fixedpoint\fixedpoint\quantizer')
          Qfptb=quantizer(struct('mode','fixed','format',[B,fb],'roundmode',roundmode));
          Qfptb111=quantizer(struct('mode','fixed','format',[111,min(110,fb+3)],'roundmode',roundmode));
        end
      else %fixed-point
        if B<=54
          Qround=qstruct('Qround','type',qtype,'precision',B-1,'roundingdir',roundingdir,'treath',treathalf); %Qround
        end
        Qdsp=qmake('Qdsp','type',qtype,'precision',B-1,'roundingdir',roundingdir,'treath',treathalf);
        %qdspmax
        Qdsp111=qmake('Qdsp111','type',qtype,'precision',110,'roundingdir',roundingdir,'treath',treathalf);
        %qdspmax
      end
      %if isequal(B,Bv(1)), fprintf('B ='), end
      fprintf('B = %.0f \n',B), %if rem(B,10)==0, fprintf('\n'), end
      iivect=1:10;
      if strcmp(mode,'fast'), iivect=[1,2]; end
      %qdspmax
      for ii=iivect
        for ix=1:2
          if ix==1, fprintf('%s, %s, ii = %.0f\n',Qc{1},roundmode,ii), end
          if B<=54
            x=2^(-fb)*2^p*(1-2^(-p))*(rand(1,1)-0.5);
            [xr,ovf,dxr]=roundq(x,Qround); %if isempty(dxr), dxr=[0,0]; end
          else %long number
            xobj=qdata(1,Qdsp111);
            if B<105, x=rand(xobj,2^(-fb)*[-2^(B-1),2^(B-1)-1]);
            else x=rand(xobj,2^(-fb)*2^(-(B-105))*[-2^(B-1),2^(B-1)-1]);
            end
            xbin=x.bin;
          end
          %qdspmax
          xd=qdata(x,Qdsp);
          %qdspmax
          if (B<=54)&(all(xr<double(xd)+2*dxr)|all(xr>double(xd)+2*dxr)) %~isequal(xr,double(xd))
            xdd=double(xd);
            ii, fprintf([' x',fpform],x), fprintf(['xr',fpform],xr), fprintf(['xd',fpform],double(xd))
            save
            error('Roundoff and qdsp differ')
          elseif exist('\fixedpoint\fixedpoint\quantizer')&~strcmp(Qc{1},'Qfloat')
            if isnumeric(x)
              xf=fi(x,Qfptb);
              if ~isequal(double(xf),double(xd))
                xfd=double(xf); xdd=double(xd);
                ii, fprintf([' x',fpform],x), fprintf(['xd',fpform],double(xd)), fprintf(['xf',fpform],double(xf))
                save
                error('qdsp and fixed-point toolboxes differ when converted to double')
              end
              xfbin=xf.bin; xdbin=xd.bin;
              if ~strcmp(xfbin,xdbin)
                ii
                num2bin(x)
                fprintf('xf = %s\n',xfbin)
                fprintf('xd = %s\n',xdbin)
                save
                error('qdsp and fixed-point binary strings differ')
              end
            else %qdsp
              xflong=fi(0,Qfptb111); xflong.bin=xbin;
              xf=fi(xflong,Qfptb);
              if ~strcmp(xf.bin,xd.bin)
                xfbin=xf.bin; xdbin=xd.bin;
                ii
                fprintf('x = %s\n',xbin)
                fprintf('x = %s ...\n     %s\n',xbin(1:6),xbin(7:end))
                fprintf('xf = %s\n',xfbin)
                fprintf('xd = %s\n',xdbin)
                save
                error('qdsp and fixed-point toolboxes differ')
              elseif ~isequal(qdata(xf),xd)
                xfq=qdata(xf);
                ii
                fprintf('x = %s\n',xbin)
                fprintf('x = %s ...\n     %s\n',xbin(1:6),xbin(7:end))
                %fprintf('xfq = %s\n',num2bin(xfq))
                %fprintf('xdb = %s\n',num2bin(xd))
                bdiff=setstr('0'+(num2bin(xfq)-num2bin(xd)));
                if ~all(bdiff=='0'), disp('qdata binary strings differ'), end
                fprintf('xfq = %s\n',get(xfq,'bin'))
                fprintf('xdb = %s\n',get(xd,'bin'))
                b2diff=setstr('0'+(get(xfq,'bin')-get(xd,'bin')));
                if ~all(b2diff=='0'), disp('binary strings differ'), end
                save
                error('qdsp and fixed-point toolboxes differ when converted to qdata')
              elseif ~isequal(double(xf),double(xd))
                xfbin=xf.bin; xdbin=xd.bin;
                ii
                fprintf('x = %s\n',xbin)
                fprintf('x = %s ...\n     %s\n',xbin(1:6),xbin(7:end))
                fprintf('xf = %s\n',xfbin)
                fprintf('xd = %s\n',xdbin)
                xdd=double(xd); xfd=double(xf);
                fprintf('xfd = %s\n',num2bin(xfd))
                fprintf('xdd = %s\n',num2bin(xdd))
                save
                error('qdsp and fixed-point toolboxes differ when converted to double')
              end
            end
            if ~isequal(xd,qdata(xf))
              xfd=qdata(xf);
              fprintf('\nxf = %s\n',xfbin)
              fprintf('xd = %s\n',xdbin)
              fprintf('xc = %s\n',get(qdata(xf),'bin'))
              save
              error('Improper conversion fi -> qdata')
            end
            if ~isequal(xf,fi(xd))
              fprintf('xd = %s\n',xdbin)
              fprintf('\nxf = %s\n',xfbin)
              fprintf('xc = %s\n',get(fi(xd),'bin'))
              save, error('Improper conversion qdata -> fi')
            end
          end %fixed-point toolbox exists
          y=xd; y(1)=x; %quantization through assignment 
          if ~isequal(y,xd)
            save
            error('assignment bad')
          end
          if ix==1
            x1=x; x1r=xr; x1d=xd; x1f=xf;
          else
            x2=x; x2r=xr; x2d=xd; x2f=xf;
          end
        end %for ix
        %
        %Operations:
        for in=[1:3]
          if in==1, y1d=x1d/2; y2d=x2d/2;
            y1r=roundq(x1r/2,Qround); y2r=roundq(x2r/2,Qround); 
          elseif in==2, y1d=x1d; y2d=x2d; y1r=x1r; y2r=x2r;
          elseif in==3
            y1d=sign(x1d)*sqrt(abs(x1d)); y2d=sign(x2d)*sqrt(abs(x2d)); 
            y1r=double(y1d); y2r=double(y2d);
          else error('in not allowed')
          end
          if exist('\fixedpoint\fixedpoint\quantizer')&~strcmp(Qc{1},'Qfloat')
            if in==1, y1f=fi(y1d); y2f=fi(y2d);
            elseif in==2, y1f=fi(y1d); y2f=fi(y2d);
            elseif in==3
              y1f=fi(y1d); y2f=fi(y2d);
            else error('in not allowed')
            end
          end
          %qdspmax
          if any(in==[1,2])
            yd=y1d+y2d;
            [yr,ovf,dyr]=roundq(y1r+y2r,Qround);
            if (B<=54)&(all(yr<double(yd)+3*dyr+[-1,1]*lsb(Qround))|all(yr>double(yd)+3*dyr+[-1,1]*lsb(Qround)))
              ydd=double(yd);
              error('roundoff and qdsp differ too much')
            end
            if exist('\fixedpoint\fixedpoint\quantizer')&~strcmp(Qc{1},'Qfloat')
              yf=y1f; yf(1)=y1f+y2f;
              yfd=qdata(yf);
              if ~isequal(yd.data,yfd.data)|~strcmp(yd.bin,yf.bin)
                %qdspmax
                save
                error('additions differ when fi object is converted to qdata')
              end
            end %fptb
          else %product
            yd=y1d*y2d;
            [yr,ovf,dyr]=roundq(y1r*y2r,Qround);
            if (B<=54)&(all(yr<double(yd)+3*dyr+[-1,1]*lsb(Qround))|all(yr>double(yd)+3*dyr+[-1,1]*lsb(Qround)))
              ydd=double(yd);
              error('roundoff and qdsp differ too much')
            end
            if exist('\fixedpoint\fixedpoint\quantizer')&~strcmp(Qc{1},'Qfloat')
              if B>64, y1f.maxproductwordlength=2*B; y2f.maxproductwordlength=2*B; end
              yf=y1f; yf(1)=y1f*y2f;
              yfq=qdata(yf);
              if ~isequal(get(qdata(yf),'data'),yd.data)|~strcmp(yf.bin,yd.bin)
                save
                warning('additions differ when fi converted to qdata')
              end
            end %fptb
          end %sum/product
        end %for in
      end %for ii
    end %for B
    disp(' ')
  end %rounding
end %for Qc
disp('Comparisons of roundoff methods are OK')
%
