function test_fptb_examples
%TEST_FPTB_EXAMPLES  Test qbook example for Fixed-Point Toolbox

%       Last edited: 13-May-2007, IK

%Example I

Q16=quantizer(struct('mode','fixed','format',[16,15],...
  'roundmode','convergent'));
u=0.25*sin([1:100]/100*2*pi*5);
b1=fi(0.6,Q16); a1=fi(-0.8,Q16); a2=fi(-0.21,Q16);
uq=fi(u,Q16); y=fi(zeros(size(u)),Q16);
%
for k=3:length(uq)
  y(k)=a1*y(k-1);
  y(k)=y(k)+a2*y(k-2);
  y(k)=y(k)+b1*uq(k-1);
end
yfix=y;
%
u=0.25*sin([1:100]/100*2*pi*5);
b1=0.6; a1=0.8; a2=0.21;
y=zeros(size(u)); uq=u;
%
for k=3:length(uq)
  y(k)=-a1*y(k-1);
  y(k)=y(k)-a2*y(k-2);
  y(k)=y(k)+b1*uq(k-1);
end
ydouble=y;
erry=double(yfix)-ydouble;

%Example II

%Type definitions:
Qmem=quantizer('fixed',[16,15],'convergent');
racc=fimath; racc.OverflowMode='wrap';
racc.ProductMode='KeepLSB';
racc.ProductWordLength=40; 
racc.SumMode='KeepLSB';
racc.SumWordLength=40;

%Variable definitions:
u=0.25*sin([1:100]/100*2*pi*5);
b1=fi(0.6,Qmem,'fimath',racc); 
a1=fi(-0.8,Qmem,'fimath',racc); 
a2=fi(-0.21,Qmem,'fimath',racc);
uq=fi(u,Qmem,'fimath',racc); 
y=fi(zeros(size(uq)),Qmem,'fimath',racc);

%Algorithm
for k=3:length(uq)
  y(k)=a1*y(k-1)+a2*y(k-2)+b1*uq(k-1);
end
yfix=y;
