function test_fptb_example_old
%TEST_FPTB_EXAMPLE  Test qbook example for Fixed-Point Toolbox

%       Last edited: 15-Apr-2007, IK

Q16=quantizer(struct('mode','fixed','format',[16,15],...
  'roundmode','convergent'));
u=0.25*sin([1:100]/100*2*pi*5);
b1=fi(0.6,Q16); a1=fi(0.8,Q16); a2=fi(0.21,Q16);
uq=fi(u,Q16); y=fi(zeros(size(u)),Q16);
%
for k=3:length(uq)
  y(k)=-a1*y(k-1);
  y(k)=y(k)-a2*y(k-2);
  y(k)=y(k)+b1*uq(k-1);
end
yfix=y;

u=0.25*sin([1:100]/100*2*pi*5);
b1=0.6; a1=0.8; a2=0.21;
y=zeros(size(u)); uq=u;
%
for k=3:length(uq)
  y(k)=-a1*y(k-1);
  y(k)=y(k)-a2*y(k-2);
  y(k)=y(k)+b1*uq(k-1);
end
ydouble=y;
erry=double(yfix)-ydouble;

%Definitions:
Qmem=quantizer(struct('mode','fixed','format',[16,15],...
  'roundmode','convergent'));
rmem=fimath; rmem.OverflowMode='wrap';
rmem.ProductMode='SpecifyPrecision';
rmem.ProductWordLength=40; rmem.ProductFractionLength=32;
rmem.SumMode='SpecifyPrecision';
rmem.SumWordLength=40; rmem.SumFractionLength=32;
Qacc=quantizer(struct('mode','fixed','format',[40,32],...
  'roundmode','convergent'));
racc=fimath; racc.OverflowMode='wrap';
racc.ProductMode='SpecifyPrecision';
racc.ProductWordLength=40; racc.ProductFractionLength=32;
racc.SumMode='SpecifyPrecision';
racc.SumWordLength=40; racc.SumFractionLength=32;
%
%Simulation:
u=0.25*sin([1:100]/100*2*pi*5);
b1=fi(0.6,Qmem); a1=fi(0.8,Qmem); a2=fi(0.21,Qmem);
uq=fi(u,Qmem); y=fi(zeros(size(uq)),Qmem);
acc=fi(0,Qacc,'fimath',racc);
acc2=acc; %redefine in acc2(1) bitlength of product
%
for k=3:length(uq)
  acc(1)=-a1*y(k-1);
  acc2(1)=-a2*y(k-2); acc(1)=acc+acc2;
  acc2(1)=b1*uq(k-1); acc(1)=acc+acc2;
  y(k)=acc;
end
yfix=y;
