function test_fptb_examples_old2
%TEST_FPTB_EXAMPLE  Modified test qbook example for Fixed-Point Toolbox

%Type definitions:
Qmem=quantizer('fixed',[16,15],'convergent');
racc=fimath; racc.OverflowMode='wrap';
racc.ProductMode='SpecifyPrecision';
racc.ProductWordLength=40; racc.ProductFractionLength=32;
racc.SumMode='SpecifyPrecision';
racc.SumWordLength=40; racc.SumFractionLength=32;

%Variable definitions:
u=0.25*sin([1:100]/100*2*pi*5);
b1=fi(0.6,Qmem,'fimath',racc); 
a1=fi(-0.8,Qmem,'fimath',racc); 
a2=fi(-0.21,Qmem,'fimath',racc);
uq=fi(u,Qmem,'fimath',racc); 
y=fi(zeros(size(uq)),Qmem,'fimath',racc);

%Algorithm
for k=3:length(uq)
  y(k) = a1*y(k-1) + a2*y(k-2) + b1*uq(k-1);
end
yfix=y;