function qclear(varargin)
%QCLEAR    Remove quantizer(s).
%   QCLEAR QUANTIZER_A ... removes the quantizer named/numbered QUANTIZER_A.
%   QCLEAR ALL removes all the quantizers.
%
%   Examples:
%     qclear quantizer_a quantizer_b quantizer_c
%     qclear -all
%
%   See also: QMAKE, QSAVE, QGET, QSET

% Copyright (C) 2003 by JUHASZ Laszlo

if isempty(varargin)
  %error('Not enough input arguments.')
  varargin={'all'};
end

if ischar(varargin{1})
   if strcmp(varargin{1},'-all')|strcmp(varargin{1},'all')
      [null,err] = quantizers('rem','-all'); 
      if ~strncmpi(err,'No quantizers in memory.',17), error(err), end      
      return
   end
end

[x,err] = str2int(varargin); error(err)
x = celldisint(x);

% get the quantizer
for k = 1:length(x)
   [null,err] = quantizers('rem',x{k}); 
   error(err)
end
