%QFORMATS  Rules & instructions for QDATA constructor method.
%
%Format indicators: must be present at the end of mantissa and exponent (if exists).
%  'b'   binary (0-1) (default)
%  'o'   octal (0-7)
%  'd'   decimal (0-9), at this moment usable only for the exponent
%  'x'   hexadecimal (0-9,a-f)
%Second character of format indicator (optional, not yet implemented):
%  's'   sign-magnitude format (first bit +/-, + may be omitted), default
%  'u'   unsigned
%  't'   two's complement (For 'b', 'o', and 'h' only, all bits must be given)
%  'o'   one's complement (For 'b', 'o', and 'h' only, all bits must be given)
%  'b'   biased exponent (bias given in quantizer, or bias is 1023 by default)
%
%'@' or '*2^'     separates mantissa from exponent.
%
%Short codes:
%        /<num>/ inserts <num> pieces of one (1). For instance /34/
%        \<num>\ inserts <num> pieces of zero (0). For instance \45\
%        WARNING!
%        The number of ones/zeros in equivalent binary representation
%        depends on the format of number. For example
%                \2\b = 00
%                \2\o = 000000        in binary representation.
%                \2\x = 00000000
%
%'i/j'   separates imaginary part from real part.
%          If missing, the number is considered as pure real.
%          If it is at starting or ending position number considered as pure imaginary,
%          else number is complex (contains both real and imaginary parts).
%
%VALID EXAMPLES:
%        qdata('1001 /4/ 01 b')   %1001111101 (binary)
%        qdata('.bb\3\fx @ -15d') %0.bb000f (hexadecimal) * 2^(-15 (decimal))
%        qdata('j34.o')           %j*[34 (octal)]
%
%   Default (always existing) quantizers:
%          BigFP, 110-bit floating-point
%          double 53-bit floating-point, IEEE standard double
%          single 24-bit floating-point, IEEE standard single
%          Q16bit fixed-point, two's complement 16-bit, integer
%          Q32bit fixed-point, two's complement 32-bit, integer
%          Q64bit fixed-point, two's complement 64-bit, integer

% Written by JUHSZ Lszl, 2003
% Modified by Istvn Kollr, 2006
%