function varargout=testqdsp(varargin)
%TESTQDSP  Call all test functions and scripts for QDSP

%Call individual tests
if (nargin>=1)
  if (length(varargin)==1)&strcmp(varargin{1},'help'), help qdsp/private, return, end
  if isstr(varargin{1})&exist(['qdsp',filesep,'private',filesep,varargin{1},'.m'])
    if (length(varargin)==1)&strcmp(varargin{1},'testqmake'), testqmake, return, end
    if nargout==0, feval(varargin{:});
    elseif nargout==1, out1=feval(varargin{:}); varargout={out1};
    else error('Unrecognized call')
    end
    return
  else
    error('Invalid call')
  end
end

%Call all tests

%Accept default answers, switch off pause:
global yesinpacceptdef
yesinpacceptdef='yes'; pause off

qclear
c0=clock;

testqmake
test_bin2num
qclear
test_qdsp_calls
testqdsp_rand(5)

%b_add_test %hibs!!!
b_times_test
%b_divide_test %hibs!!!

fftd_test_2
sin_test_main
fftd_test         
sin_test
iird_test
%Mandelbrot
close all

qdspdemo(1)
qdspdemo(2) %FFT see above
qdspdemo(3) %IIR see above
qdspdemo(4) %testqmake, sin_test_main

test_all_roundoffs fast %profound test

close all
%Switch back to normal run
clear global yesinpacceptdef
pause on

disp('testqdsp finished OK.')
et=etime(clock, c0);
fprintf('Elapsed time: %.0f min %.0f s\n',fix(et/60),rem(et,60))
