function [y]=filter_dirii_q(b,a,x,Q,imp)
%FILTER_DIRII_Q  Filter, direct II, quantized
%
%imp: 1:3: left 3;2;1, 4:6: right, 6;5;4

Nx=length(x);
y=zeros(size(x));
AR=zeros(3,1); %Present value of memories: w(1); w(2); w(3)
if nargin<2, error('a is not given'), end
if nargin<4, Q=''; end
if isempty(Q), i1=1; else i1=max(1,lsb(Q)); end
if nargin<5, imp=[]; end
if ~isempty(imp)&~ismember(imp,[1:6]), error('imp invalid'), end
if ismember(imp,[4:6]), AR(imp-3)=i1; end
if a(1)~=1, error('a(1) is not equal to 1'), end
for n=1:Nx
  sleft=roundq(-a(4)*AR(3),Q);
  sleft=roundq(sleft+roundq(-a(3)*AR(2),Q),Q);
  sleft=roundq(sleft+roundq(-a(2)*AR(1),Q),Q);
  sleft=roundq(sleft+x(n),Q);
  sright=roundq(b(4)*AR(3),Q);
  sright=roundq(sright+roundq(b(3)*AR(2),Q),Q);
  sright=roundq(sright+roundq(b(2)*AR(1),Q),Q);
  y(n)=roundq(sright+roundq(b(1)*sleft,Q),Q);
  AR(3)=AR(2); AR(2)=AR(1); AR(1)=sleft;
end
