function [dnumber,dfunm,m,flag]=add_dither(number,Q,mod)
%ADD_DITHER Add dither to sample(s)
%
%  Input arguments:
%    number: input number
%    Q: quantizer
%    mod: maybe 'complex', to execute complex addition in any case
%  Output arguments:
%    dnumber: number + dither
%    dfunm: value of dither added
%    m: index in cyclic dither
%    flag: ??? bellts komplex esetben???

%  Last modified: 24-Oct-2006, by IK

if nargin<3, mod=''; end
lsbx=lsb(number,Q,mod);
L=Q.Number_of_DitherBits;
lsbd=lsbx*2^(-L); %maybe complex

dfun=Q.Other.Sdith;
sequenceperm=Q.Sequenceperm;
numberofusage=Q.Other.NumberOfUsage;
hmtimes=Q.Other.Hmtimes;
probab=Q.Other.Probab;

differ = hmtimes-numberofusage;
sumhmtimes2 = sum(differ);

if strcmpi(sequenceperm,'enabled')
        if (sumhmtimes2 == 0)
            probab2 = probab;
        else
        probab2=differ./sumhmtimes2;
        end
else
    probab2=probab;
end
    

flag = 0;
if imag(number), div=1:2;
elseif strcmp(mod,'complex'), div=1:2;
else div=1;
end

for di=div
  if strncmpi(sequenceperm,'disabled',3)
    %pseudorandom dither
    m = rand(1,1);
    ind=min(find([cumsum([probab2]),1.1]>m)); m=ind;
    while (m>length(probab2))
        m = rand(1,1);
        ind=min(find([cumsum([probab2]),1.1]>m)); m=ind;
    end
  else
    %repetitive dither
    if (sumhmtimes2 == 0)
    flag = 1;
    m = rand(1,1);
    ind=min(find([cumsum([probab2]),1.1]>m)); m=ind;
    while (m>length(probab2))
        m = rand(1,1);
        ind=min(find([cumsum([probab2]),1.1]>m)); m=ind;
    end
 else
     m = rand(1,1);
     ind=min(find([cumsum([probab2]),1.1]>m)); m=ind;
    while ((numberofusage(m) >= hmtimes(m)) | (m>length(probab2)))
        m = rand(1,1);
       ind=min(find([cumsum([probab2]),1.1]>m)); m=ind;
    end
    end
 end
  
  if di==1
    dfunm=dfun(m)*real(lsbd);
  else
    dfunm=dfunm+j*dfun(m)*imag(lsbd);
  end
end 
dnumber = number + dfunm;
