function dither_hist(N)
%DITHER_HIST  Plot histogram of dither

global list_quant_details
list_quant_details=0;
if nargin<1, N=[]; end, if isempty(N), N=1600; end
%
figi=0;
for dt={'qfloat','qfix'}
  if strcmp(dt,{'qfix'})
    Q=qstruct('32-bit');
  else
    Q=qstruct('double','prec',48);
  end
  for tod={'u1','u2','u3','t1','t2','t3'} %
    fprintf('Dither type: %s, number representation: %s, samples: %0.f\n',tod{1},dt{1},N)
    %if isequal(dt,{'qfloat'}), fprintf(', precision: %.0f\n',Q.Precision)
    %elseif isequal(dt,{'qfix'}), fprintf(', bit number: %.0f\n',Q.Bits)
    %end
    figi=figi+1;
    figure(figi), clf
    Q=qstructset(Q,'dither','on','tod',tod{1},'L',3);
    d=zeros(N,1); x=2.5; L=Q.Number_of_DitherBits;
    for ii=1:N
      [xprime,overflow,dv]=roundq(x,Q); if length(dv)~=1, error('Size of dv is wrong'), end
      if isstruct(dv), dv=dv.d; end %eliminate structure
      d(ii)=dv/lsb(x,Q)*2^L;
    end
    hist(d,[-8:0.5:8])
    hold on
    plot(Q.Other.Sdith,Q.Other.Probab*N,'+r')
    hold off
    shg
    fprintf('Press any key to continue ...'), pause, disp(' ')
  end %tod
end %fix/float