function str=num2sigexp(xprime,runmod)
%NUM2SIGEXP  Illustrate contents of a fp number (exp as digital number)
%
%   str=num2sigexp(xprime,runmod)
%
%   The value of the exponent is illustrated as a digital number
%
%   Examples:
%     num2sigexp(1)
%     num2sigexp(qfloat(realmin,struct('Ebias',511),'list'));
%     num2sigexp(0,struct('p',24,'Emin',-26,'Ebias',27,'lb','shown'))
%     num2sigexp(0,'single')
%     num2sigexp(1+double(eps('single')),'single')
%         %this returns +(1)(.)0000 0000 0000 0000 0000 001 2^[+0d]

%	Copyright (c) I. Kollar, 1995-2005, all rights reserved
%	Last modified: 15-Nov-2005

%Just call num2bin with modifying argument
if nargin<2, runmod=[]; end
if nargout>0, str=num2bin(xprime,runmod,'decimal');
else num2bin(xprime,runmod,'decimal')
end
%
%End of num2sigexp