function test_fft_dft
%TEST_FFT_DFT  Test rounded fft's and DFT's
%
%   Last modified: 31-Nov-2006, IK

disp('Test of FFT/DFT algorithms')
%disp('  First step: reset random generators to make test repeatable')
%rand('seed',0), randn('seed',0)
disp(' ')
%for alg={'rounddft-chirp'}
for alg={'rounddft-chirp','roundfft','roundfft-dif','rounddft','rounddft-grouped'}
  alg=alg{1};
  for dither={'off','on'}
    dither=dither{1}; tod='t1';
    if strcmp(dither,'on'), dstr=' with dither (t1)'; spv={'disabled'}; %,'enabled' enabled: cyclic
    else dstr=''; spv={'disabled'};
    end
    for sequenceperm=spv
      sequenceperm=sequenceperm{1};
      if strcmp(sequenceperm,'enabled'), sstr=' (cyclic)'; else sstr=''; end
      for typ={'block-float','float','fix'}
        typ=typ{1};
        runmod=struct('algorithm','');
        if strcmp(typ,'float')
          Qs=qstruct('single');
          Qs=qstructset(Qs,'dither',dither,'tod',tod); runmod.sign_of_life=1;
          if strcmp(alg,'roundfft')|strcmpi(alg,'roundfft-dit')
            dx=roundifft(roundfft([1:32],Qs),Qs)-[1:32];
          elseif strcmp(alg,'roundfft-dif')
            runmod=struct('algorithm','dif');
            dx=roundifft(roundfft([1:32],Qs,runmod),Qs,runmod)-[1:32];
          elseif strcmp(alg,'rounddft-chirp')
            dx=roundifft(roundfft([1:23],Qs,runmod),Qs,runmod)-[1:23];
          elseif strcmp(alg,'rounddft')
            dx=roundidft(rounddft([1:8],Qs,runmod),Qs,runmod)-[1:8];
          elseif strcmp(alg,'rounddft-grouped')
            runmod.algorithm='grouped';
            dx=roundidft(rounddft([1:8],Qs,runmod),Qs,runmod)-[1:8];
          else
            error(['algorithm ''',alg,''' is unrecognized'])
          end
          if strcmp(dither,'on'), elim=1.7e-5; else elim=22*2^(-23); end
          if strcmp(alg,'rounddft-chirp'), elim=4*elim; end
          if any(abs(dx)>elim)
            save
            x_xr=[x,xr,x-xr,(x-xr)./abs(x)]
            max(abs(dx)), elim
            error(sprintf('Single precision %s%s%s - error is too large',alg,dstr,sstr))
          else disp(sprintf('Test of single-precision %s%s%s is OK',alg,dstr,sstr))
          end
          %
        elseif strncmp(typ,'fix',3)
          Qf=qstruct('32-bit');
          Qf=qstructset(Qf,'dither',dither,'tod',tod);
          if strcmp(alg,'roundfft')|strcmpi(alg,'roundfft-dit')
            x=roundq(32*randn(128,1),Qf);
            x2=roundifft(roundfft(x,Qf),Qf);
          elseif strcmp(alg,'rounddft-chirp')
            x=roundq(32*randn(61,1),Qf);
            x2=roundifft(roundfft(x,Qf,runmod),Qf,runmod);
          elseif strcmp(alg,'roundfft-dif')
            runmod=struct('algorithm','dif');
            x=roundq(32*randn(128,1),Qf);
            x2=roundifft(roundfft(x,Qf,runmod),Qf,runmod);
          elseif strcmp(alg,'rounddft')
            x=roundq(32*randn(32,1),Qf); runmod.sign_of_life=1;
            x2=roundidft(rounddft(x,Qf,runmod),Qf,runmod);
          elseif strcmp(alg,'rounddft-grouped')
            x=roundq(32*randn(32,1),Qf); runmod.sign_of_life=1; roundmod.algorithm='grouped';
            x2=roundidft(rounddft(x,Qf,runmod),Qf,runmod);
          else
            error(['algorithm ''',alg,''' is unrecognized'])
          end
          dx=x2-x;
          if strcmp(dither,'on'), elim=7.5; else elim=1; end
          if strcmp(alg,'rounddft-chirp'), elim=25*elim; end
          if any(abs(dx)>elim)
            x_xr=[x,xr,x-xr,(x-xr)./abs(x)]
            save
            maxdx=max(abs(dx)), elim
            error(sprintf('Fixed-point %s%s%s - error is too large',alg,dstr,sstr))
          else disp(sprintf('Test of fixed-point %s%s%s is OK',alg,dstr,sstr))
          end
        elseif strcmp(typ,'block-float')
          Qf=qstruct('16-bit'); %Qf=qstructset(Qf,'Bits',18);
          Qf=qstructset(Qf,'dither',dither,'tod',tod);
          x=roundq(320*randn(8,1),Qf);
          if strcmp(alg,'roundfft')|strcmpi(alg,'roundfft-dit')
            runmod=struct('algorithm','','exponent','block-float');
            x2=roundifft(roundfft(x,Qf,runmod),Qf,runmod);
          elseif strcmp(alg,'rounddft-chirp')
            x=roundq(320*randn(9,1),Qf);
            runmod=struct('algorithm','','exponent','block-float');
            x2=roundifft(roundfft(x,Qf,runmod),Qf,runmod);
            %xr=pow2(x2.bfe)*x2.data;
            %x2=struct('data',x,'bfe',0); warning('Manual bypass') %%%%% ***  %%%%%%%%%%%%%%%
          elseif strcmp(alg,'roundfft-dif')
            runmod=struct('algorithm','dif','exponent','block-float');
            x2=roundifft(roundfft(x,Qf,runmod),Qf,runmod);
          elseif strcmp(alg,'rounddft')
            runmod.exponent='block-float'; runmod.sign_of_life=1;
            x2=roundidft(rounddft(x,Qf,runmod),Qf,runmod);
          elseif strcmp(alg,'rounddft-grouped')
            runmod.exponent='block-float'; runmod.sign_of_life=1; runmod.algorithm='grouped';
            x2=roundidft(rounddft(x,Qf,runmod),Qf,runmod);
          else
            error(['algorithm ''',alg,''' is unrecognized'])
          end
          xr=pow2(x2.bfe)*x2.data;
          dx=xr-x;
          if strcmp(dither,'on'), elim=280; else elim=25; end
          if strcmp(alg,'rounddft-chirp'), elim=5*elim; end
          if any(abs(dx)>elim)
            save
            x_xr=[x,xr,x-xr,(x-xr)./abs(x)]
            maxdx=max(abs(dx)), elim
            error(sprintf('Block-float %s%s%s - error is too large',alg,dstr,sstr))
          else disp(sprintf('Test of block-float %s%s%s is OK',alg,dstr,sstr))
          end
        else
          error('typ is not recognized')
        end
      end %for typ
    end %for sequenceperm
  end %for dither
  disp(' ')
end %for alg
