function moment=qmoments(contfile)
%QMOMENTS Evaluate errors of moments of quantized random variables
%
% The calculations evaluate series expansion of the error 
% on the basis of the characteristic function method.
%
% No inputs, no outputs, just question-answer sequences or saved files
% By default, tries to plot from a saved file

%	Copyright (c) I. Kollar, 1995-2006
%	All rights reserved
%	Last modified: 17-Mar-2006

%Teendok:
% M3, M4 szamitasa
%enve tisztazasa
%
%load
if (nargin==1)&isstr(contfile), eval(['load ',contfile]), end
disp('qmoments is running ...')
%contrun='n';
%dist='g'; ord=2; mtype='n'; ptype='m'; q=1; sigm=1/3;
if ~exist('dmu'), dmu=0.01; end %resolution of mu; default, may be changed later
arg2str='''''';
enveder=1; %def: derivative disappears with that lower power of 1/amp than cf
if ~exist('mumin'), mumin=[]; end, if isempty(mumin), mumin=0; end
clear c
clear datstr
%
if ~exist('L'), L=[]; end
if ~exist('contrun'), contrun=''; end, if isempty(contrun), contrun='p'; end
if ~exist('ptype'), ptype=''; end
if strcmp(ptype,'m'), contrun='n'; else contrun='n'; end
contrun=yesinput(['New run, continue, re-run, last cycle, or just plot',...
    ' results, n|c|r|l|p'], contrun,'c|r|l|n|p');
if strcmp(contrun,'n')
  overwroldfq='y';
  disp(' ')
  disp('  Possible distributions:')
  disp('  chi-squared (c), exponential (e), gamma (a), Gaussian (g)')
  disp('  Laplace (l), Rayleigh (r), sinusoidal (s)')
  disp('  uniform (u), triangular (t), house (h), binary (b)') %, sampled uniform (w)
  if ~exist('dist','var'), dist=''; end, if isempty(dist), dist='u'; end
  dist=lower(yesinput('Distribution',dist,'c|e|a|g|G|l|L|r|R|s|t|h|u|b'));
  amprec=''; %parameter need not be reciproced
  if strcmp(dist,'c'), distn='chi-square'; fn='cfchi2';
    amp='sigma';
    if ~exist('sigm'), sigm=[]; end
    if length(sigm)>1, sigm=[]; end
    if isempty(sigm), sigm=1; end
    if isempty(L), L=100; end
    if ~exist('k'), k=[]; end, if isempty(k), k=2; end
    k=yesinput('Degrees of freedom',k,[1,inf]);
    arg2str='k';
    if k<2, dmu=0.005; end
    Ex0str='sigma*k'; stdxstr='sigma*sqrt(2*k)'; enve=k/2;
    enveder=0; %derivative disappears with that lower power of 1/amp than cf
  elseif strcmp(dist,'e'), distn='exponential'; fn='cfexponential';
    amp='lambda';
    if isempty(L), L=100; end
    if ~exist('lambda'), lambda=[]; end
    if length(lambda)>1, lambda=[]; end
    if isempty(lambda), lambda=1; end
    amprec='1/';
    Ex0str='1/lambda'; stdxstr='1/lambda'; enve=1;
    enveder=0; %derivative disappears with that lower power of 1/amp than cf
  elseif strcmp(dist,'a'), distn='gamma'; fn='cfgamma';
    amp='lambda';
    if ~exist('lambda'), lambda=[]; end
    if length(lambda)>1, lambda=[]; end
    if isempty(lambda), lambda=1; end
    if isempty(L), L=100; end
    if ~exist('alpha_rayleigh'), alpha_rayleigh=[]; end
    if isempty(alpha_rayleigh), alpha_rayleigh=1; end
    alpha_rayleigh=yesinput('alpha_rayleigh',alpha_rayleigh,[0,inf]);
    arg2str='alpha_rayleigh';
    amprec='1/';
    if alpha_rayleigh<=0.5, dmu=0.005; end
    Ex0str='alpha_rayleigh/lambda'; 
    stdxstr='sqrt(alpha_rayleigh)/lambda'; enve=alpha_rayleigh;
    enveder=0; %derivative disappears with that lower power of 1/amp than cf
  elseif strcmpi(dist,'g'), distn='Gaussian'; fn='cfgaussian';
    amp='sigma'; 
    if ~exist('sigm'), sigm=[]; end
    if length(sigm)>1, sigm=[]; end
    if isempty(sigm), sigm=0.5; end
    if isempty(L), L=10; end
    Ex0str='0'; stdxstr='sigma'; enve=0;
  elseif strcmpi(dist,'l'), distn='Laplacian'; fn='cflaplace';
    amp='alpha_rayleigh';
    if isempty(L), L=100; end
    if ~exist('alpha_rayleigh'), alpha_rayleigh=[]; end
    if length(alpha_rayleigh)>1, alpha_rayleigh=[]; end
    if isempty(alpha_rayleigh), alpha_rayleigh=1; end
    amprec='1/';
    Ex0str='0'; stdxstr='sqrt(2)/alpha_rayleigh'; enve=2;
    enveder=-1; %derivative disappears with that lower power of 1/amp than cf
  elseif strcmpi(dist,'r'), distn='Rayleigh'; fn='cfrayleigh';
    amp='alpha_rayleigh';
    if isempty(L), L=100; end
    if ~exist('alpha_rayleigh'), alpha_rayleigh=[]; end
    if length(alpha_rayleigh)>1, alpha_rayleigh=[]; end
    if isempty(alpha_rayleigh), alpha_rayleigh=1; end
    calc='f'; %no analytic calculation yet
    Ex0str='alpha_rayleigh*sqrt(pi/2)'; stdxstr='sqrt(2-pi/2)*alpha_rayleigh'; enve=2;
    enveder=0; %derivative disappears with that lower power of 1/amp than cf
    fprintf('Empirical enveder=%.2g\n',enveder)
  elseif strcmp(dist,'s'), distn='sinusoidal'; fn='cfsine';
    amp='A';
    if isempty(L), L=100; end
    if ~exist('A'), A=[]; end
    if length(A)>1, A=[]; end
    if isempty(A), A=7.6; end
    if dmu>0.005, dmu=0.005; end
    Ex0str='0'; stdxstr='A/sqrt(2)'; enve=0.5;
    enveder=1; %derivative disappears with that lower power of 1/amp than cf
  elseif strcmp(dist,'t'), distn='triangular'; fn='cftriangular';
    amp='A';
    if isempty(L), L=100; end
    if ~exist('A'), A=[]; end
    if length(A)>1, A=[]; end
    if isempty(A), A=1.7; end
    Ex0str='0'; stdxstr='A/sqrt(6)'; enve=2;
    enveder=1; %derivative disappears with that lower power of 1/amp than cf
  elseif strcmp(dist,'h'), distn='house'; fn='cfhouse';
    arg2str='alpha_house';
    amp='A';
    if isempty(L), L=100; end
    if ~exist('A'), A=[]; end
    if length(A)>1, A=[]; end
    if isempty(A), A=2; end
    if ~exist('alpha_house'), alpha_house=[]; end
    if length(alpha_house)>1, alpha_house=[]; end
    if isempty(alpha_house), alpha_house=1; end
    alpha_house=yesinput('Alpha parameter (0,inf)',alpha_house,[0,inf]);
    Ex0str='0'; stdxstr='A/sqrt(6)'; enve=1;
    enveder=1; %derivative disappears with that lower power of 1/amp than cf
  elseif strcmp(dist,'u'), distn='uniform'; fn='cfuniform';
    amp='A';
    if isempty(L), L=100; end
    if ~exist('A'), A=[]; end
    if length(A)>1, A=[]; end
    if isempty(A), A=1.7; end
    if ~exist('dmu'), dmu=[]; end, if isempty(dmu), dmu=0.005; end
    Ex0str='0'; stdxstr='A/sqrt(3)'; enve=1;
    enveder=1; %derivative disappears with that lower power of 1/amp than cf
  elseif strcmp(dist,'b'), distn='binary'; fn='cfbinary';
    amp='A';
    if isempty(L), L=500; end
    if ~exist('A'), A=[]; end
    if length(A)>1, A=[]; end
    if isempty(A), A=1.7; end
    dmu=0.005;
    Ex0str='0'; stdxstr='A'; enve=0;
    enveder=1; %derivative disappears with that lower power of 1/amp than cf
  elseif strcmp(dist,'w'), distn='sampled uniform'; fn='cfsampleduniform';
    amp='A';
    if isempty(L), L=500; end
    if ~exist('A'), A=[]; end
    if length(A)>1, A=[]; end
    if isempty(A), A=1.7; end
    if ~exist('k'), k=[]; end, if isempty(k), k=10; end
    k=yesinput('Degrees of freedom',k,[2,inf]);
    dmu=0.005;
    Ex0str='0'; stdxstr='A/sqrt(3)'; enve=0;
    enveder=1; %derivative disappears with that lower power of 1/amp than cf
  end
  if ~isempty(amprec), amprecl='1./'; else amprecl=''; end
  %
  if ~exist('ord'), ord=[]; end, if isempty(ord), ord=1; end
  ord=yesinput('Order of moment',ord,[1,inf]);
  %
  if ~exist('mtype'), mtype=''; end, if isempty(mtype), mtype='s'; end
  mtypeold=mtype;
  if ord>1 
    mtype=yesinput('Sheppard correction, or noise moment, or kind correction, s|n|k',mtype,'s|n|k'); 
  else 
    if strcmp(mtype,'k'), mtype='s'; end
    mtype=yesinput('Sheppard correction or noise moment, s|n',mtype,'s|n');
  end
  if strcmp(mtype,'k')&~strcmp(Ex0str,'0'), enveder=1; end
  if ~strcmp(mtypeold,mtype), mumax=[]; end
  %
  if ~exist('mj'), mj=''; end, if isempty(mj), mj='s'; end
  if ord==2
    if strcmp(mtype,'s')|strcmp(mtype,'k')
      if strcmp(mj,'w')|strcmp(mj,'v')|strcmp(mj,'e'), mj='s'; end
      mj=yesinput(['Simple moment, R2/S2, corr, cov, corrc, cc/sqrt(q^2/12),',...
          ' s|S|R|c|r|q'], mj,'s|S|R|c|r|q');
    elseif strcmp(mtype,'n')
      if strcmp(mj,'R')|strcmp(mj,'c')|strcmp(mj,'r')|strcmp(mj,'q'), mj='s';
      end
      mj=yesinput('R of simple moment or var; energy or var, s|v|e|w',mj,...
        's|v|e|w');
    end
  elseif strcmp(mtype,'n')
    if strcmp(mj,'R')|strcmp(mj,'c')|strcmp(mj,'r')|strcmp(mj,'q')|strcmp(mj,'v')
      mj='s';
    end
    %mj=yesinput('Simple moment or var, s|v',mj,'s|v');
  elseif (ord==4) %E{x^2nu^2} or E{tilde x^2nu^2}
    if strcmp(mj,'R')|strcmp(mj,'r')|strcmp(mj,'q')|strcmp(mj,'v')|...
        strcmp(mj,'w')|strcmp(mj,'e'), mj='s';
    end
    mj=yesinput('Simple moment or M4/S4 or "cov" (x^2nu^2), s|S|c',...
      mj,'S|s|c');
  else
    mj='s';
  end
  %
  if ~exist('calc'), calc=''; end, if isempty(calc), calc='a'; end
  calc=yesinput('Analytic cf calculations or fft, a|f',calc,'a|f'); 
  %
  if ~exist('ptype'), ptype=''; end, if isempty(ptype), ptype='a'; end
  ptype=yesinput('Plot as function of mu or of amplitude, m|a',ptype,'m|a');
  %
  if ~exist('q'), q=[]; end, if isempty(q), q=1; end
  q=yesinput('Value of q',q,[eps,inf]);
  if ~exist('qoffs'), qoffs=[]; end, if isempty(qoffs), qoffs=0; end
  qoffs=yesinput('Quantizer offset',qoffs);
  a_zero_limit=(1-eps)*1e-3*q;
  if strcmp(ptype,'m')
    if strcmp(amp,'sigma'),
      eval(['sigm','=yesinput(''Value of ','sigma',...
        sprintf(' (zero limit: <%.0e)',a_zero_limit),...
        ''',','sigm',');'])
    else
      eval([amp,'=yesinput(''Value of ',amp,...
        sprintf(' (zero limit: <%.0e)',a_zero_limit),...
        ''',',amp,');'])
    end
    if strcmp(dist,'g')
      if sigm>=a_zero_limit
        Lsugg=ceil(2/sigm/(2*pi/q));
        if Lsugg>=L
          fprintf('\nSuggested minimum value of L=%.0f, for sigma=%.2g\n',...
            Lsugg,sigm)
          L=Lsugg;
        end
      else
        disp('sigma under zero limit')
      end
    end
    if ~exist('mumax'), mumax=[]; end
    if isempty(mumax)
      if strcmp(mtype,'s')&(ord>1), mumax=5*q; else mumax=q; end
    end
    mumin=yesinput('Minimum value of mu',mumin);
    mumax=yesinput('Maximum value of mu',mumax);
    dmu=yesinput('Resolution of mu',dmu);
    mu=[mumin:dmu:mumax];
  else %amplitude
    clear mu
    if ~exist('mumax'), mumax=[]; end, if isempty(mumax), mumax=q; end
    if strcmp(mtype,'s')
      mumax=yesinput('Maximum value of mu',mumax);
      if mumax~=q, mumin=yesinput('Minimum value of mu',mumin); end
    else fprintf('\nRange of mu is [0,q]')
    end
    dmu=yesinput('Resolution of mu',dmu);
    if ~exist('amin'), amin=[]; end, if isempty(amin), amin=0.01*q; end
    amin=yesinput('Minimum amplitude',amin,[0,inf]);
    if ~exist('amax'), amax=[]; end, if isempty(amax), amax=10*q; end
    amax=yesinput('Maximum amplitude',amax,[1e-4,inf]);
    if ~exist('da'), da=[]; end, if isempty(da), da=0.01*q; end
    da=yesinput('Steps in the amplitude vector',da,[1e-4,inf]);
  end
  %
  Lques=1;
  if strcmpi(dist,'g')&strcmp(ptype,'m')
    if sigm<a_zero_limit, Lques=0; end
  end
  if ~exist('L'), L=[]; end, if isempty(L), L=10; end
  if Lques
    if exist('Lsugg')
      fprintf('\nSuggested number of terms: %.0f',Lsugg)
    end
    L=yesinput('Number of cf terms in the series',L,[1,inf]);
  end
  clear Lsugg
  %
  if strcmp(ptype,'m')
    if strcmp(amp,'sigma')
      eval(['Av=',amprec,'sigm',';'])
    else
      eval(['Av=',amprec,amp,';'])
    end
  else
    Av=sort([0,amin,[1:amax/da]*da]);
    ind=find(diff(Av)==0); Av(ind)=[];
    ind=find(Av<amin); %if (min(Av)==0)&(amin>0), ind(1)=[]; end
    Av(ind)=[];
  end
  ind=min(find(Av>=a_zero_limit)); Anzmin=Av(ind);
  if ~isempty(Anzmin)
    if strcmpi(dist,'g')
      if sigm>=a_zero_limit
        Lsugg2=ceil(2/Anzmin(1)/(2*pi/q));
        if Lsugg2>L
          fprintf('WARNING! L is not large enough, suggested: %.0f\n',Lsugg2)
        end
      end
    end
  end
  %
  if ord==1, sc='q';
  elseif ord==2
    if strcmp(mj,'S')|strcmp(mj,'r')|strcmp(mj,'q'), sc='1'; else sc='q^2'; end
  elseif ord==3, sc='q^3';
  elseif ord==4, if strcmp(mj,'S'), sc='1'; else sc='q^4'; end
  end
  sco=sc;
  if ~exist('scnew'), scnew=''; end %modified scaling expression
  if ~isempty(scnew)
    if ~isstr(scnew), error('scnew is not a string'), end
    sc=scnew;
    fprintf(['sc redefined as  ',sc])
  end
  clear scnew
  if (strcmp(mtype,'s')|strcmp(mtype,'k'))&strcmp(ptype,'m')
    fprintf('\nCorrection vector is given as S%.0f',ord)
    fprintf(['\nExpressions containing it can be given like S%.f.^2'],ord)
    fprintf('\nVector of mean values is given as muv')
    fprintf('\nVector of the values of the moment is given as M%.0f',ord)
    fprintf('\nStandard deviation is given as stdx')
    eval(sprintf('S%.0f=1;',ord))
  elseif strcmp(ptype,'a')
    fprintf(['\nVector of different amplitudes is denoted by ',amp,''])
    fprintf(['\nExpressions containing it can be given like  ',amp,'.^2'])
    fprintf('\nVector of the standard deviations is given as stdxv')
  end
  sc=yesinput('Expression for scaling of plotted error function',sc);
  eval(['dummy=',sc,';']);
  envemod=0;
  clear dummy
  %
  %Output string for cf calculation, e.g. [Phi,Phi1]
  ostr='Phi0'; %Phi0=zeros(L+1,1);
  for i=1:ord-1
    Pn=['Phi',int2str(i)]; %eval([Pn,'=Phi0;'])
    ostr=[ostr,',',Pn];
  end
  ostr=['[',ostr,']'];
  %
  Psi=2*pi/q;
  %
  Rmin=NaN*zeros(size(Av)); Rmax=Rmin;
  ai=0; timprev=clock; ailast=0;
  if strcmp(ptype,'a')
    specfile=['qm',lower(dist),int2str(ord),mtype,mj,ptype];
    specfile=...
      yesinput('File for saving the run parameters and the data',specfile);
    if exist('fnamanal.m','file'), specfile=feval('fnamanal',specfile,'mat');
    elseif strcmp(specfile(end),'.'), specfile=[specfile,'mat']; 
    elseif ~any(findstr(specfile,'.')), specfile=[specfile,'.mat']; 
    end
  end
  %contrun='c';
  contfile='qmoments';
  stdxv=zeros(size(Av));
else %continue run
  if ~exist('contfile'), contfile=''; end
  if strcmp(contrun,'r')|strcmp(contrun,'l'), %contfile='';
  elseif isempty(contfile),  contfile='qmoments';
  end
  contfile=yesinput('File name',contfile);
  while isempty(contfile)
    contfile=yesinput('File name',contfile);
  end
  if ~any(contfile=='.'), contfile=[contfile,'.mat']; end
  if strcmp(contrun,'p')
    eval(['load ',contfile]) %load from file
    if ~strcmp(contfile,specfile)
      disp(['specfile: ',specfile])
      load(specfile)
    end
    Av=Av(1:ai); Rmin=Rmin(1:ai); Rmax=Rmax(1:ai); %plot only
    contrun='c';
  elseif strcmp(contrun,'c')|strcmp(contrun,'r')|strcmp(contrun,'l')
    if strcmp(contrun,'c'), eval(['load ',contfile]) %load from file
    elseif strcmp(contrun,'r'), eval(['load ',contfile]), ai=0; %re-run
    elseif strcmp(contrun,'l'), eval(['load ',contfile]), ai=ai-1; %last cyc
    end
    disp(' ')
    if ~strcmp(contfile,'qmoments.mat')&~strcmp(contfile,'qmoments')
      specfile=contfile;
    end
    if exist('fnamanal.m','file'), specfile=feval('fnamanal',specfile,'mat');
    elseif strcmp(specfile(end),'.'), specfile=[specfile,'mat']; 
    elseif ~any(findstr(specfile,'.')), specfile=[specfile,'.mat']; 
    end
    if ai<length(Av)
      if ai==length(Av)-1, disp(['Repeat last cycle for file ',specfile])
      elseif ai>0, disp(['Continue calculations of file ',specfile])
      else
        disp(['Re-run calculations for file ',specfile])
      end
    else disp(['Calculations have already been finished for file ',specfile])
    end
  end
  %clear contfile
  overwroldfq='n';
  if ~exist('scnew'), scnew=''; end %modified scaling expression
  if ~isempty(scnew)
    if ~isstr(scnew), error('scnew is not a string'), end
    sc=scnew;
    fprintf(['sc redefined as  ',sc])
    if ~strcmpi(dist,'g') %other than Gaussian
      %envemod=yesinput(['Power of amplitudes in scaling expression  ',sc],0);
    end
  end
  clear scnew
  ailast=ai; timprev=clock;
  if ~strcmp(contrun,'c'), contrun='p'; end
  if ~exist('stdxv'), stdxv=zeros(size(Av)); end
end %contrun
if ~exist('qoffs'), qoffs=[]; end, if isempty(qoffs), qoffs=0; end
timprevsave=timprev;
%
for a=Av(ai+1:length(Av))
  if strcmp(ptype,'a') %save only for amplitude plots
    clear contrun
    if ~exist('plotdens'), plotdens=inf; end
    pldsav=plotdens; clear plotdens
    if a==Av(1), save qmoments.mat, end
    if exist(specfile)&strcmp(overwroldfq,'y')
      overwresp=yesinput(['Overwrite old file ',specfile],'y','y|n');
      if strcmp(overwresp,'y')
        if exist([specfile,'~']), delete([specfile,'~']); end
        try
          if isunix
            unix(['cp ',specfile,' ',specfile,'~']);
            disp(['Old file saved to ',specfile,'~'])
          else
            dos(['copy ',specfile,' ',specfile,'~']);
            disp(['Old file saved to ',specfile,'~'])
          end
        catch
        end
      end
    else
      overwresp='y';
    end
    if strcmp(overwresp,'y')&(a==Av(1))
      eval(['save ',specfile])
      disp(' ')
      disp(['Run parameters saved to file ',specfile,''])
    end
    plotdens=pldsav;
  end
  overwroldfq='n';
  %
  ai=ai+1;
  if ((etime(clock,timprev)>10)|(ai==length(Av)))&strcmp(ptype,'a')
    fprintf('Cycle %.0f, total: %.0f, %.1f/min\n',...
      ai,length(Av),60/etime(clock,timprev)*(ai-ailast))
    timprev=clock; ailast=ai;
    if strcmp(get(0,'diary'),'on'), diary off, diary on, end
  end
  if (a==0)&~isempty(amprec) %parameter is infinity
    eval([amp,'=inf;'])
  else
    eval([amp,'=',amprec,'a;']) %get value of sigma-parameter
  end
  eval(['arg2=',arg2str,';']) %get value of second parameter
  eval(['Ex0=',Ex0str,';'])
  eval(['stdx=',stdxstr,';'])
  stdxv(ai)=stdx;
  %
  muv=[mumin:dmu:mumax,mumax];
  if length(muv)==2, muv(2)=[]; end
  l=[1:L]';
  a_is_zero=(a<a_zero_limit); %very small spread of pdf, practically zero
  if ~a_is_zero
    if (length(muv)>1)&(a<dmu)
      %amplitude still small; problem can occur around quant levels
      qlev=([round(mumin/q):round(mumax/q)-1]+0.5)*q;
      dmua=a/(q/dmu);
      for qlevi=qlev
        muv=[muv,qlevi+[-2.5*a:dmua:-dmua/2,-dmua/100,0,...
              dmua/100,dmua/2:dmua:2.5*a]];
      end %for qlevi
      muv=sort(muv);
    end
    %calculation of Phi0, Phi1...
    if strcmp(calc,'a')
      if (a==0)&~isempty(amprec), arec=inf;
      else eval(['arec=',amprec,'a;'])
      end
      if strcmp(dist,'a')|strcmp(dist,'c')|strcmp(dist,'h') %gamma or chi2 or house
        eval([ostr,'=',fn,'([0;l*Psi],arec,arg2,-Ex0);'])
      else %all other distributions
        eval([ostr,'=',fn,'([0;l*Psi],arec,-Ex0);'])
      end
    else %fft
      eval([ostr,'=cfcalc([0;l*Psi],''',dist,''',a,arg2,-Ex0);'])
    end
    dcf0=Phi0(1); Phi0(1)=[];
    if ord>=2, dcf1=Phi1(1); Ex1tilde=real(dcf1/(-j)); Phi1(1)=[]; end
    if ord>=3, dcf2=Phi2(1); Ex2tilde=real(dcf2/(-j)^2); Phi2(1)=[]; end
    if ord>=4, dcf3=Phi3(1); Ex3tilde=real(dcf3/(-j)^3); Phi3(1)=[]; end
    if qoffs~=0 %quantizer is not midtread
      Phi0=exp(+j*qoffs*l*Psi).*Phi0;
      if ord>=2, Phi1=exp(+j*qoffs*l*Psi).*Phi1; end
      if ord>=3, Phi2=exp(+j*qoffs*l*Psi).*Phi2; end
      if ord>=4, Phi3=exp(+j*qoffs*l*Psi).*Phi3; end
    end
  else %a is zero
    ind=find( abs( abs(rem(muv+Ex0-qoffs,q))-q/2 ) <dmu/2.001);
    if ~isempty(ind)
      ind2=find(diff(muv(ind))<q/4); ind3=ind; ind3(ind2)=[];
      muv=[muv,q*round((muv(ind3)-(q/2-qoffs))/q)+q/2+qoffs]; muv(ind)=[];
    end
    %J1max calculation may follow
    Phi0=ones(L,1);
  end
  R=zeros(1,length(muv)); %residual errors
  S=zeros(1,length(muv)); %corrections
  M=zeros(1,length(muv)); %moments
  muc=0; muidel=[];
  m1lpl=(-1).^l./l;
  for mu=muv+Ex0
    muc=muc+1;
    mui=muc;
    expml=exp(+j*mu*l*Psi);
    J1=0; J2=0; J3=0; J4=0;
    %
    if ~a_is_zero %nonzero a
      munu=q/pi*sum(imag(expml.*Phi0).*(m1lpl));
      if strcmp(mtype,'s')|strcmp(mtype,'n')
        if ord==4, [Phi0m,Phi1m,Phi2m,Phi3m]=cfmu(l*Psi,mu,Phi0,Phi1,Phi2,Phi3);
        elseif ord==3, [Phi0m,Phi1m,Phi2m]=cfmu(l*Psi,mu,Phi0,Phi1,Phi2);
        elseif ord==2, [Phi0m,Phi1m]=cfmu(l*Psi,mu,Phi0,Phi1);
        elseif ord==1, [Phi0m]=cfmu(l*Psi,mu,Phi0);
        end
      end
    end %~a_is_zero
    %
    if strcmp(mtype,'s')&~a_is_zero
      if (ord==1)|(ord==3) %Sheppard, 1st and 3rd moment
        J1=q/pi*sum(imag(Phi0m).*(m1lpl));
      end
      %
      if (ord==2)|(ord==4) %Sheppard, 2nd and 4th moment
        J2=q^2/pi^2*sum(real(Phi0m).*m1lpl./l);
        J2=J2+2*q/pi*sum(real(Phi1m).*(-m1lpl));
      end
      %
      if ord==2 %2nd joint moment
        if strcmp(mj,'R')|strcmp(mj,'c')|strcmp(mj,'r')|strcmp(mj,'q')
          %correlation needed
          Exnu=q/pi*sum(real(Phi1m).*(-m1lpl));
        end
      end
      %
      if ord==3 %Sheppard, 3rd moment
        J3=J3-3*q*sum(imag(Phi2m).*m1lpl/pi);
        J3=J3-3*q^2*sum(imag(Phi1m).*(-m1lpl)./l/pi^2);
        J3=J3-q^3/4*sum(imag(Phi0m).*((-m1lpl)/pi+6*m1lpl./l.^2/pi^3));
      end
      %
      if ord==4 %Sheppard, 4th moment
        if strcmp(mj,'s')|strcmp(mj,'S')
          J4=J4+4*q*sum(real(Phi3m).*m1lpl/pi);
          J4=J4+6*q^2*sum(real(Phi2m).*(-m1lpl)./l/pi^2);
          J4=J4+q^3*sum(real(Phi1m).*((-m1lpl)/pi-6*(-m1lpl)./l.^2/pi^3));
          J4=J4+q^4/2*sum(real(Phi0m).*(m1lpl./l/pi^2-6*m1lpl./l.^3/pi^4));
        elseif strcmp(mj,'c')
          J4=q^2/pi^2*sum(real(Phi2m).*(-m1lpl)./l);
        end
      end
    elseif strcmp(mtype,'k')&~a_is_zero
      %
      if (ord==1)|(ord==3) %kind, 1st and 3rd moment
        J1=0;
      end
      %
      if (ord==2)|(ord==4) %kind, 2nd and 4th moment
        J2=J2+q^2/pi^2*sum(real(expml.*Phi0).*m1lpl./l);
        J2=J2-munu^2;
        J2=J2-2*q/pi*sum(real(expml.*Phi1).*(m1lpl));
      end
      %
      if (ord==2)&(strcmp(mj,'R')|strcmp(mj,'c')|strcmp(mj,'r')|strcmp(mj,'q'))
        %2nd joint moment,  correlation needed
        [Phi0m,Phi1m]=cfmu(l*Psi,mu,Phi0,Phi1);
        Exnu=q/pi*sum(real(Phi1m).*(-m1lpl))-mu*munu;
      end
      %
      if ord==3 %kind, 3rd moment
        if L>1
          J3=J3+2*munu^3; %else it stays 0
        end
        J3=J3-3*Ex2tilde*munu;
        if L>1, J3=J3+6*q/pi*sum(real(expml.*Phi1).*(m1lpl))*munu; end
        J3=J3-3*q^2/12*munu;
        if L>1
          J3=J3-3*q^2/pi^2*sum(real(expml.*Phi0).*m1lpl./l)*munu;
        end
        J3=J3-3*q/pi*sum(imag(expml.*Phi2).*m1lpl);
        J3=J3-3*q^2/pi^2*sum(imag(expml.*Phi1).*(-m1lpl)./l);
        J3=J3-q^3/4*sum(imag(expml.*Phi0).*(-m1lpl).*(1/pi-(6)./l.^2/pi^3));
      end
      %
      if ord==4 %kind, 4th moment
        if strcmp(mj,'s')|strcmp(mj,'S')
          if L>1
            J4=J4-3*munu^4;
            J4=J4+6*Ex2tilde*munu^2;
            J4=J4-12*q/pi*sum(real(expml.*Phi1).*m1lpl)*munu^2;
            J4=J4+6*q^2/12*munu^2;
            J4=J4-6*q^2/pi^2*sum(real(expml.*Phi0).*(-m1lpl)./l)*munu^2;
            J4=J4-4*Ex3tilde*munu;
            J4=J4+12*q/pi*sum(real(expml.*Phi2).*m1lpl)*munu;
            J4=J4+12*q^2/pi^2*sum(imag(expml.*Phi1).*(-m1lpl)./l)*munu;
            J4=J4+q^3*sum(imag(expml.*Phi0).*(-m1lpl).*...
              (1/pi-6/(pi^3)./l.^2))*munu;
          end
          J4=J4+4*q/pi*sum(real(expml.*Phi3).*m1lpl);
          J4=J4+6*q^2/pi^2*sum(real(expml.*Phi2).*(-m1lpl)./l);
          J4=J4+q^3*sum(real(expml.*Phi1).*((-m1lpl)/pi + 6*m1lpl./l.^2/pi^3));
          J4=J4+q^4/2*sum(real(expml.*Phi0).*m1lpl.*(1/(pi^2)./l-6/(pi^4)./l.^3));
        elseif strcmp(mj,'c')
          J4=q^2/pi^2*sum(real(expml.*Phi2).*(-m1lpl)./l);
        end
      end
    elseif strcmp(mtype,'n')&~a_is_zero
      if strcmp(mj,'w')|strcmp(mj,'v'), munuv=munu;
      elseif strcmp(mj,'s')|strcmp(mj,'e'), munuv=zeros(size(munu));
      end
      if (ord==1) %noise, 1st moment
        J1=q/pi*sum(imag(exp(-j*l*Psi.*munuv).*Phi0m).*(m1lpl));
      end
      if ord==2 %noise, 2nd moment
        J2=q^2/pi^2*sum(real(exp(-j*l*Psi.*munuv).*Phi0m).*(m1lpl./l));
      end
      if ord==3 %noise, 3rd moment
        J3=q^3/4*sum(imag(exp(-j*l*Psi.*munuv).*Phi0m)...
          .*(m1lpl).*(1/pi-6/pi^3./l./l));
      end
      if ord==4 %noise, 4th moment
        J4=q^4/2*sum(real(exp(-j*l*Psi.*munuv).*Phi0m)...
          .*(m1lpl).*(1/pi^2./l-6/pi^4./l.^3));
      end
    end
    %
    if a_is_zero
      xq0=floor((mu-qoffs)/q)*q+qoffs; xq1=xq0+q;
      if abs(abs(rem(mu-qoffs,q))-q/2)<dmu/2.001 %a=0, mu=q/2+k*q
        dp=min(1,dmu/q);
        %dp=0.1;
        Np=ceil(1/dp); pv=[0:Np]/Np;
      else %not at quantum level
        dp=1;
        if (round((mu-qoffs)/q)*q+qoffs)>mu, pv=1; else pv=0; end
      end
      munu=pv*xq1+(1-pv)*xq0-mu;
      if strcmp(mtype,'s') %Sheppard
        if (ord==1)|(ord==3), J1=munu; end
        if (ord==2)|(ord==4), J2=pv*xq1^2+(1-pv)*xq0^2-mu^2-q^2/12; end
        if ord==2
          if strcmp(mj,'R')|strcmp(mj,'c')|strcmp(mj,'r')|strcmp(mj,'q')
            Exnu=pv*mu*(xq1-mu)+(1-pv)*mu*(xq0-mu);
          end
        end
        if ord==3, J3=pv*xq1^3+(1-pv)*xq0^3-mu^3-3*mu*q^2/12; end
        if ord==4
          if strcmp(mj,'s')
            J4=pv*xq1^4+(1-pv)*xq0^4-mu^4-6*mu^2*q^2/12-q^4/80;
          elseif strcmp(mj,'c')
            J4=pv*mu^2*(xq1-mu)^2+(1-pv)*mu^2*(xq0-mu)^2-mu^2*q^2/12;
          end
        end
      elseif strcmp(mtype,'k') %kind
        J1=zeros(size(pv));
        if (ord==2)|(ord==4)
          J2=pv.*(xq1-mu-munu).^2+(1-pv).*(xq0-mu-munu).^2-q^2/12;
        end
        if ord==3
          J3=pv.*(xq1-mu-munu).^3+(1-pv).*(xq0-mu-munu).^3;
        end
        if ord==4
          if strcmp(mj,'s')
            J4=pv.*(xq1-mu-munu).^4+(1-pv).*(xq0-mu-munu).^4-q^4/80;
          elseif strcmp(mj,'c')
            J4=zeros(size(pv));
          end
        end
      elseif strcmp(mtype,'n') %noise
        J1=zeros(size(pv));
        if ((ord==1)|(ord==3))&strcmp(mj,'s'), J1=munu; end
        if (ord==2)|(ord==4)
          if strcmp(mj,'s')|strcmp(mj,'e')
            J2=pv*(xq1-mu)^2+(1-pv)*(xq0-mu)^2-q^2/12;
          elseif strcmp(mj,'w')|strcmp(mj,'v')
            J2=pv.*(xq1-mu-munu).^2+(1-pv).*(xq0-mu-munu).^2-q^2/12;
          end
        end
        if ord==3
          if strcmp(mj,'s')
            J3=pv*(xq1-mu)^3+(1-pv)*(xq0-mu)^3;
          elseif strcmp(mj,'v')
            J3=pv.*(xq1-mu-munu).^3+(1-pv).*(xq0-mu-munu).^3;
          end
        end
        if ord==4
          if strcmp(mj,'s')
            J4=pv*(xq1-mu)^4+(1-pv)*(xq0-mu)^4-q^4/80;
          elseif strcmp(mj,'v')
            J4=pv.*(xq1-mu-munu).^4+(1-pv).*(xq0-mu-munu).^4-q^4/80;
          end
        end
      end %strcmp(mtype,...
      %
      if ( length(pv)>1 ) %a=0, mu=q/2+k*q
        muidel=[muidel,muc];
        mui=length(muv)+1+pv/dp;
        muv=[muv,mu+(pv-0.5)/dp*q*10*eps];
        R=[R,zeros(1,length(pv))];
        S=[S,zeros(1,length(pv))];
        M=[M,zeros(1,length(pv))];
      end
    end %a_is_zero
    %
    %CALCULATION OF THE RESIDUALS
    if ord==1
      R(mui)=J1;
      if strcmp(mj,'s'), S(mui)=zeros(size(mui)); M(mui)=mu*ones(size(mui)); end
    elseif ord==2
      if strcmp(mj,'r')
        if ~a_is_zero, Enu2=q^2/12+q^2/pi^2*sum(real(Phi0m).*(m1lpl./l));
        else Enu2=pv*(xq1-mu)^2+(1-pv)*(xq0-mu)^2;
        end
      end
      %
      if strcmp(mj,'s')|strcmp(mj,'S')
        R(mui)=J2; S(mui)=q^2/12*ones(size(mui)); M(mui)=S(mui)+stdx^2;
        if strcmp(mj,'S'), R(mui)=R(mui)./S(mui); end
      elseif (strcmp(mj,'e')|strcmp(mj,'w'))&strcmp(mtype,'n')
        R(mui)=J2+q^2/12;
      elseif strcmp(mj,'v')
        if strcmp(mtype,'s'), error('mtype=s and mj=v invalid')
        elseif strcmp(mtype,'k'), error('mtype=k and mj=v invalid')
        elseif strcmp(mtype,'n'), R(mui)=J2;
        end
      elseif strcmp(mj,'R')
        if strcmp(mtype,'s'), R(mui)=Exnu;
        elseif strcmp(mtype,'k'), R(mui)=Exnu;
        elseif strcmp(mtype,'n'), error('mtype=n and mj=R invalid')
        end
      elseif strcmp(mj,'c')
        if strcmp(mtype,'s'), R(mui)=Exnu-mu*munu;
        elseif strcmp(mtype,'k'), R(mui)=Exnu;
        elseif strcmp(mtype,'n'), error('mtype=n and mj=c invalid')
        end
      elseif strcmp(mj,'q')
        if strcmp(mtype,'s')
          R(mui)=(Exnu-mu*munu)/stdx/sqrt(q^2/12);
        elseif strcmp(mtype,'k')
          R(mui)=Exnu/stdx/sqrt(q^2/12);
        elseif strcmp(mtype,'n')
          error('mtype=n and mj=q invalid')
        end
      elseif strcmp(mj,'r')
        if strcmp(mtype,'s')
          R(mui)=(Exnu-mu*munu)/stdx./sqrt(Enu2-munu.^2);
        elseif strcmp(mtype,'k'), R(mui)=Exnu/stdx/sqrt(Enu2-munu.^2);
        elseif strcmp(mtype,'n'), error('mtype=n and mj=r invalid')
        end
      end
    elseif ord==3
      if strcmp(mtype,'n')|strcmp(mtype,'k'), R(mui)=J3;
      else  R(mui)=J3-q^2/4*J1;
        if strcmp(mtype,'s')&strcmp(mj,'s'), S(mui)=1/4*(mu+munu)*q^2; end
      end
    elseif ord==4
      if strcmp(mtype,'n'), R(mui)=J4;
      elseif strcmp(mj,'c'), R(mui)=J4;
      else R(mui)=J4-J2*q^2/2; %Sheppard or kind
        if strcmp(mj,'s')|strcmp(mj,'S')
          if strcmp(mtype,'s')
            S(mui)=1/2*q^2*(mu.^2+stdx^2+q^2/12+J2)-7/240*q^4;
          elseif strcmp(mtype,'k')
            S(mui)=1/2*q^2*(stdx^2+q^2/12+J2)-7/240*q^4;
          end
        end
        if strcmp(mj,'S'), R(mui)=R(mui)./S(mui); end
      end
    end
  end %for mu
  muv(muidel)=[]; R(muidel)=[]; S(muidel)=[]; M(muidel)=[];
  [muv,ind]=sort(muv); R=R(ind); S=S(ind); M=M(ind);
  eval(sprintf('M%.0f=M;',ord))
  eval(sprintf('S%.0f=S;',ord))
  %
  if isempty(R), error('R is empty at the end of cycle'), end
  Rmin(ai)=min(R); Rmax(ai)=max(R);
  %
  if ~exist('plotdens'), plotdens=[]; end
  if isempty(plotdens), plotdens=inf; end
  if strcmp(ptype,'a')&((etime(clock,timprevsave)>60)|(ai==2)|(ai==length(Av)))
    timprevsave=clock;
    if ai==length(Av) %Several variables can be cleared
      clear Phi0 Phi1 Phi2 Phi3
      clear Phi0m Phi1m Phi2m Phi3m
      clear expml ind R m1lpl l
      clear scv scvl
      clear S S1 S2 S3 S4
    end
    cl=timprevsave;
    datstr=sprintf([date,', %2.0f:%02.0f'],cl(4),cl(5));
    %do not save plotdens
    pldsav=plotdens; clear plotdens
    save qmoments.mat
    if strcmp(overwresp,'y')
      eval(['save ',specfile])
      overwroldfq='n';
    end
    plotdens=pldsav;
  end
  if strcmp(ptype,'a')&(ai==length(Av))
    fprintf('Last cycle accomplished\n')
  end
  if isfinite(plotdens)&((ai==3)|(rem(ai,plotdens)==0))&strcmp(ptype,'a')
    eval(['scv=',sc,';'])
    if length(scv)==1, scvl=scv*ones(size(Av)); else scvl=scv; end
    if strcmp(dist,'g') %Gaussian envelope
      clg, semilogy(Av(1:ai),Rmax(1:ai)./scvl(1:ai),'-')
      if ord>1
        %hold on, semilogy(Av(1:ai),-Rmin(1:ai)./scvl(1:ai),'--'), hold off
      end
      if length(Av)<=10
        hold on, semilogy(Av(1:ai),Rmax(1:ai)./scvl(1:ai),'o'), hold off
      end
      xlabel(sprintf('Zero limit for sigma: %.3g',a_zero_limit))
    else
      clg, plot(Av(1:ai),Rmax(1:ai)./scvl(1:ai),'-',...
        Av(1:ai),Rmin(1:ai)./scvl(1:ai),'-')
      if length(Av)<=10
        hold on, plot(Av(1:ai),Rmax(1:ai)./scvl(1:ai),'o',...
          Av(1:ai),Rmin(1:ai)./scvl(1:ai),'o'), hold off
      end
    end
    grid, figure(gcf), drawnow
  end
end %for a
%
%PLOTTING
%
if strcmp(ptype,'a')
  eval(['ampsav=',amp,';'])
  eval([amp,'=',amprecl,'(Av+realmin);']) %amplitude vector for modified scaling
end
eval(['scv=',sc,';'])
if length(scv)==1, scvl=scv*ones(size(Av)); else scvl=scv; end
titl=[distn];
if strcmp(mj,'e'), titl=[titl,sprintf(', E%.0f',ord)];
elseif strcmp(mj,'w'), titl=[titl,', var'];
else titl=[titl,sprintf(', R_%.0f',ord)];
end
if strcmp(mtype,'k'), titl=[titl,'(x_{tilde})']; end
if strcmp(mtype,'n'), titl=[titl,'(noise)']; end
if ord==2
  if strcmp(mj,'v'), titl=[titl,'(var)'];
  elseif strcmp(mj,'R'), titl=[titl,'(corr)'];
  elseif strcmp(mj,'c'), titl=[titl,'(cov)'];
  elseif strcmp(mj,'r'), titl=[titl,'(r)'];
  elseif strcmp(mj,'q'), titl=[titl,'(r-q)'];
  elseif strcmp(mj,'S'), titl=[titl,'/S2'];
  end
elseif (ord==4)&strcmp(mj,'S'), titl=[titl,'/S4'];
end
titl=[titl,sprintf(', q=%.0f',q)];
if qoffs~=0, titl=[titl,sprintf(', qoffs=%.2g',qoffs)]; end
if strcmp(ptype,'m')
  amptxt=amp; if strcmp(amp,'alpha_rayleigh'), amptxt='alpha_{Rayleigh}'; end
  titl=[titl,sprintf([', ',amprec,amptxt,'=%.4g'],a)];
end
if strcmp(dist,'c')|strcmp(dist,'a')|strcmp(dist,'w')
  titl=[titl,sprintf([', ',arg2str,'=%.4g'],arg2)];
end
titl=[titl,sprintf([', L=%.0f'],L)];
%
if strcmp(ptype,'a')|(dmu<=(mumax-mumin))
  clf, hold off
  plh=gca;
  txth=axes('Position',[0,0,1,1]); axis('off')
  axes(plh)
end
%
if strcmp(ptype,'m')&(length(muv)==1)
  fprintf('R/scv = %.6g\n',R/scv)
  if nargout>0, moment=R/scv; end
  doplot=0;
elseif strcmp(ptype,'m')&(length(muv)>1)
  doplot=1;
  plot(muv,R./scv)
  if exist('Rsav')&exist('muvsav')
    hold on, plot(muvsav,Rsav/scv,':','linewidth',0.7), hold off
  end
  if Ex0==0, xlabel(sprintf('mu   (dmu=%.3g)',dmu))
  else xlabel(sprintf('mu-Ex0   (Ex0=%.3g, dmu=%.3g)',Ex0,dmu))
  end
  hold on, plot([mumin,mumax],[0,0],':','linewidth',0.7), hold off
  ax=axis;
  if (ord==1)&(1==1)&all(scv==scv(1))&~strcmp(dist,'g')
    J1min=q/pi*sqrt(sum(1/2*abs(Phi0).^2./l.^2));
    J1max=q/pi*sum(abs(Phi0)./l);
    hold on
    rlh=plot(ax(1:2),J1max*[1,1],'-.',ax(1:2),-J1max*[1,1],'-.',...
      ax(1:2),J1min*[1,1],'--',ax(1:2),-J1min*[1,1],'--');
    hold off
    ax=axis; 
  end
  ax(1)=mumin; ax(2)=mumax;
  if ax(3)<0
    ax(3:4)=max(abs(ax(3:4)))*[-1,1];
  else
    ax(3:4)=max(abs(ax(3:4)))*[0,1];
  end
  axis(ax), hold off
  if nargout>0, moment=R./scv; end
elseif strcmp(ptype,'a') %function of amplitude
  doplot=1;
  clear Rsav
  if (mumin==0)&(mumax==q)
    if dmu~=q
      titl=[titl,sprintf([', dmu=%.3g, mu=[0,q]'],dmu)];
    else
      titl=[titl,sprintf([', mu=0'])];
    end
  else
    titl=[titl,sprintf([', dmu=%.3g, mu=[%.3g,%.3g]'],dmu,mumin,mumax)];
  end
  Ex0strm=Ex0str;
  ind=find(Ex0strm=='_');
  if ~isempty(ind), Ex0strm=[Ex0strm(1:ind-1),'\',Ex0strm(ind:end)]; end
  if Ex0~=0, titl=[titl,', Ex0=',Ex0strm]; end
  if strcmp(dist,'g')&~(strcmp(mj,'e')|strcmp(mj,'w')) %Gaussian envelope
    semilogy(Av,Rmax./scvl,'-')
    if length(Av)<=10
      hold on, semilogy(Av,Rmax./scvl,'o'), hold off
    end
    %if ord>1, hold on, semilogy(Av,-Rmin./scvl,'--'), hold off, end
    if (length(Av)<=10)&(ord>1)
      hold on, semilogy(Av,-Rmin./scvl,'o'), hold off
    end
    envv0=exp(-2*pi^2*sigm.^2/q^2);
    emin=NaN; emax=NaN;
    if strcmp(mtype,'s')
      if ord==1, emax=q/pi;
      elseif ord==2
        if strcmp(mj,'s'), emax=sqrt((q^2/pi^2+4*sigm.^2).^2+(2*q*q/pi)^2);
        elseif strcmp(mj,'R')|strcmp(mj,'c'), emax=2*sigm.^2;
        elseif strcmp(mj,'r')|strcmp(mj,'q'), emax=2*sigm/(q/sqrt(12));
        end
      else emax=NaN;
      end
    elseif strcmp(mtype,'k')
      if ord==1, emax=0;
      elseif ord==2,
        if strcmp(mj,'s'), emax=q^2/pi^2+4*sigm.^2; 
        elseif strcmp(mj,'R')|strcmp(mj,'c'), emax=2*sigm.^2;
        elseif strcmp(mj,'r')|strcmp(mj,'q'), emax=2*sigm/(q/sqrt(12));
        end
      elseif ord==3
        emax=12*pi*sigm.^4/q+6/pi*sigm.^2*q+3/2/pi^2*q^3;
      elseif ord==4
        emax=32*pi^2*sigm.^6/q^2+6/pi^2*sigm.^2*q^2+3*q^4/pi^4;
      end
    elseif strcmp(mtype,'n')
      if ord==1, emax=q/pi;
      elseif ord==2, emax=q^2/pi^2;
      elseif ord==3, emax=q^3/4*(1/pi-6/pi^3);
      elseif ord==4, emax=q^4/2/pi^4*(pi^2-6);
      end
    end %mtype
    if length(emax)==1, emax=emax(ones(size(Av))); end
    if isnan(emin), emin=-emax; end
    ax=axis;
    hold on
    lA=length(Av); Ai=[1:max(1,round(lA/100)):lA];
    semilogy(Av,emax./scvl.*envv0,':','linewidth',0.7)
    %if 0
      %semilogy(Av(Ai),emax(Ai)./scvl(Ai).*envv0(Ai),'.')
      %semilogy(Av,emin./scvl.*envv0,':','linewidth',0.7)
    %end
    if any(ax~=axis), axis(ax), end
    hold off
  else %other than Gaussian
    plot(Av(1:ai),Rmax(1:ai)./scvl(1:ai),'-',...
      Av(1:ai),Rmin(1:ai)./scvl(1:ai),'-'), drawnow
    if length(Av)<=10
      hold on, plot(Av(1:ai),Rmax(1:ai)./scvl(1:ai),'o',...
        Av(1:ai),Rmin(1:ai)./scvl(1:ai),'o'), hold off
    end
    indn0=find( (Av~=0)&(Av~=1) );
    if length(indn0)>1
      envemod=mean( diff(log(scvl(indn0)))./diff(log(Av(indn0))) );
    else
      envemod=0;
    end
    if abs(envemod-round(envemod))>1e-5
      disp('envemod cannot be calculated!'), keyboard
      envemod=NaN;
    else
      envemod=round(envemod);
    end
    if strcmp(mtype,'s')|strcmp(mj,'S')
      Aexp=enve+envemod-max(0,(ord-1)*enveder);
      if (strcmp(dist,'e')|strcmp(dist,'r'))&strcmp(mj,'c'), Aexp=Aexp-1; end
      if (ord==4)&strcmp(mj,'S'), Aexp=Aexp+2; end
    elseif strcmp(mtype,'k')
      Aexp=enve+envemod-max(0,(ord-1)*enveder);
    else  %noise moment
      Aexp=enve+envemod;
    end
    if ord==2, if strcmp(mj,'r')|strcmp(mj,'q'), Aexp=enve; end, end
    %ind=find(Av>(Av(ai)/3));
    ind=[max(round(ai/3),1):ai];
    if strcmp(mj,'e')
      mmean=q^2/12;
      hold on, plot([min(Av),max(Av)],mmean*[1,1],'-.','linewidth',0.7)
      hold off
      if (ord==2)&strcmp(dist,'s')&strcmp(mtype,'n')
        %Gray's plot
        indint=find((abs(Av-round(Av))<1e-6)&(Av>0.5));
        hold on
        plot(Av(indint),Rmax(indint),'--','tag','Gray')
        plot(Av(indint),Rmax(indint),'o','tag','Gray')
        hold off
        axgray=[0,35,0.085,0.115];
      end
    elseif strcmp(mj,'r'), mmean=0; set(gca,'ylim',[-2,2])
    else mmean=0;
    end
    emax=max((Rmax(ind)-mmean)./scvl(ind).*Av(ind).^Aexp);
    emin=min((Rmin(ind)-mmean)./scvl(ind).*Av(ind).^Aexp);
    ind=find(Av>max(Av)/1140);
    ax=axis;
    if ~strcmp(dist,'g')
      hold on
      plot(Av(ind),mmean+emax./Av(ind).^Aexp,':','linewidth',0.7)
      plot(Av(ind),mmean+emin./Av(ind).^Aexp,':','linewidth',0.7)
      emax,emin,Aexp
      hold off
    end
    if ax(3)<0
      ax(3:4)=max(abs(ax(3:4)))*[-1,1];
    else
      ax(3:4)=max(abs(ax(3:4)))*[0,1];
    end
    if any(ax~=axis), axis(ax), end
    hold off
    if ~strcmp(dist,'g')
      axes(txth)
      if Aexp>=0, xp=0.5; yp=0.85; else xp=0.14; yp=0.20; end
      text(xp,yp,...
        sprintf('emax=%.4g, emin=%.4g',emax,emin),'VerticalAlignment','bottom');
      if Aexp~=0
        text(xp,yp-0.04,sprintf(['env = em/(',amprec,amp,')^%.2g'],...
          Aexp),'VerticalAlignment','bottom');
      else
        text(xp,yp-0.04,'env = const','VerticalAlignment','bottom');
      end
      %Calculation of d in d/A^p
      if ord==1
        if ~exist('c'), c=[]; end
        if isempty(c)
          %c=yesinput('Value of c',c);
          %disp('Warning: c is not defined')
        end
        if isstr(c), eval(['c=',c,';']), end
        if ~isempty(c)
          d=c*2*(q/2/pi)^(enve+1)*zeta(enve+1);
          text(xp,yp-0.08,sprintf('emax <= %.3g',d),'VerticalAlignment','bottom')
          c=[];
        end
      end
    end %~strcmp(dist,'g')
    axes(plh)
  end %if dist,'g'
  if strcmp(amp,'sigma')
    eval(['sigma','=ampsav;'])
    %xlabel(sprintf([amprec,amp,'  (da=%.3g)'],da)) ??? error?
  else
    eval([amp,'=ampsav;'])
    amptxt=amp; if strcmp(amp,'alpha_rayleigh'), amptxt='alpha_{Rayleigh}'; end
    xlabel(sprintf([amprec,amptxt,'  (da=%.3g)'],da))
  end
  if nargout>0, moment=[Rmax(:)'/scv;Rmin(:)'/scv]; end
else
  doplot=0;
end %if ptype
%end
%
if doplot==1
  if (length(scv)==1)&strcmp(mtype,'n')&(strcmp(mj,'e')|strcmp(mj,'w'))
    hold on, ax=axis; plot(ax(1:2),q^2/12/scv*[1,1],':','linewidth',0.7)
    hold off
    set(gca,'Xgrid','off','Ygrid','off')
  end
  ylabel(['Units: ',sc])
  title(titl)
  %grid
  %
  axes(txth)
  if ~exist('datstr'), datstr=''; end
  if ~isempty(datstr), text(0,0,['Date: ',datstr],...
      'VerticalAlignment','bottom')
  end
  if strcmp(ptype,'a')
    text(0,0.035,['File: ',specfile],'VerticalAlignment','bottom')
    %text(0,0.98,sprintf('Zero limit: %.3g',a_zero_limit))
  end
  text(.85,0,['cfcalc: ',calc],'VerticalAlignment','bottom')
  axes(plh)
  %
  zoom on
  figure(gcf)
  %ax(3:4)=[-1,1]*.02, axis(ax)
end
sst='Rsav=R; muvsav=muv;';
%
%End of qmoments
