function [num,den]=res2tf(wm,rm,zm)
%RES2TF  Resonator to tf conversion

num=0; As=0; b0=[];
N=length(wm);
if nargin<2, rm=[]; end, 
if isempty(rm), rm=1/N*ones(N,1); 
elseif length(wm)==length(rm)+1, b0=wm(end); wm(end)=[]; N=length(wm);
end
if isequal(b0,0), b0=[]; end
if nargin<3, zm=[]; end
if isempty(zm), zm=exp(j*[0:N-1]'/N*2*pi); end
for n=0:N-1
  tfn=[1];
  for m=0:N/2
    if (m==0)|(m==N/2)
      if n~=m, tfn=conv(tfn,[1,-zm(m+1)]); end
    else
      if m==n, tfn=conv(tfn,[1,-conj(zm(m+1))]);
      elseif m==N-n, tfn=conv(tfn,[1,-zm(m+1)]);
      else tfn=conv(tfn,[1,-2*real(zm(m+1)),abs(zm(m+1))^2]);
      end
    end
  end %for m
  num=num+[0,wm(n+1)*rm(n+1)*zm(n+1)*tfn]; As=As+[0,rm(n+1)*zm(n+1)*tfn];
end %for n
den=conv([1,-zm(N)],tfn)+As;
num=real(num); den=real(den);
if ~isempty(b0)&~isequal(b0,0)
  while length(den)<length(num), den=[den,0]; end
  if length(num)>length(den), num(1:length(den))=num(1:length(den))+b0*den;
  else num=num+b0*den;
  end
end
while abs(den(end))<1e4*eps, den(end)=[]; end
while (abs(num(end))<1e4*eps)&(length(num)>1), num(end)=[]; end
