function xprime=roundconv(x)
%ROUNDCONV Fixed-point roundoff of numbers, with convergent rounding for fraction = 0.5
%
%   Examples:
%     roundconv([-5.5:5.5]) %random integer values at distance 0.5

%	Copyright (c) I. Kollar, 2006, all rights reserved
%	Last modified: 1-May-2006

if any(imag(x(:))), x=real(x); xi=imag(x); else xi=[]; end
%
ind=find(abs(abs(rem(x,2))-0.5)<1e5*eps);
if ~isempty(ind), x(ind)=fix(x(ind)); end
ind=find(abs(abs(rem(x,2))-1.5)<1e5*eps);
if ~isempty(ind), x(ind)=round(x(ind)); end
xprime=round(x);
%
if ~isempty(xi)
  ind=find(abs(abs(rem(xi,2))-0.5)<1e5*eps);
  if ~isempty(ind2sub), xi(ind)=fix(xi(ind)); end
  ind=find(abs(abs(rem(xi,2))-1.5)<1e5*eps);
  if ~isempty(ind), xi(ind)=round(xi(ind)); end
  xprimei=round(xi);
  xprime=xprime+j*xprimei;
end
%
%End of roundconv